/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.40.0-dev.20230624(84d1bed101c30355d2ad4115e7c7d91882b578d5)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var J=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/errors","vs/base/common/strings","vs/editor/common/core/offsetRange","vs/base/common/event","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/objects","vs/editor/common/core/lineRange","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/nls","vs/base/common/arrays","vs/base/common/cache","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cancellation","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/smartLinesDiffComputer","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/path","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],Z=function(O){for(var n=[],E=0,D=O.length;E<D;E++)n[E]=J[O[E]];return n};const Ee=this,Re=typeof global=="object"?global:{};var ue;(function(O){O.global=Ee;class n{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=n._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof O.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}O.Environment=n})(ue||(ue={}));var ue;(function(O){class n{constructor(o,m,w){this.type=o,this.detail=m,this.timestamp=w}}O.LoaderEvent=n;class E{constructor(o){this._events=[new n(1,"",o)]}record(o,m){this._events.push(new n(o,m,O.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}O.LoaderEventRecorder=E;class D{record(o,m){}getEvents(){return[]}}D.INSTANCE=new D,O.NullLoaderEventRecorder=D})(ue||(ue={}));var ue;(function(O){class n{static fileUriToFilePath(D,i){if(i=decodeURI(i).replace(/%23/g,"#"),D){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(D,i){return D.length>=i.length&&D.substr(0,i.length)===i}static endsWith(D,i){return D.length>=i.length&&D.substr(D.length-i.length)===i}static containsQueryString(D){return/^[^\#]*\?/gi.test(D)}static isAbsolutePath(D){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(D)}static forEachProperty(D,i){if(D){let o;for(o in D)D.hasOwnProperty(o)&&i(o,D[o])}}static isEmpty(D){let i=!0;return n.forEachProperty(D,()=>{i=!1}),i}static recursiveClone(D){if(!D||typeof D!="object"||D instanceof RegExp||!Array.isArray(D)&&Object.getPrototypeOf(D)!==Object.prototype)return D;let i=Array.isArray(D)?[]:{};return n.forEachProperty(D,(o,m)=>{m&&typeof m=="object"?i[o]=n.recursiveClone(m):i[o]=m}),i}static generateAnonymousModule(){return"===anonymous"+n.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(D){return n.startsWith(D,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=O.global.performance&&typeof O.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?O.global.performance.now():Date.now()}}n.NEXT_ANONYMOUS_ID=1,n.PERFORMANCE_NOW_PROBED=!1,n.HAS_PERFORMANCE_NOW=!1,O.Utilities=n})(ue||(ue={}));var ue;(function(O){function n(i){if(i instanceof Error)return i;const o=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(o.stack=i.stack),o}O.ensureError=n;class E{static validateConfigurationOptions(o){function m(w){if(w.phase==="loading"){console.error('Loading "'+w.moduleId+'" failed'),console.error(w),console.error("Here are the modules that depend on it:"),console.error(w.neededBy);return}if(w.phase==="factory"){console.error('The factory function of "'+w.moduleId+'" has thrown an exception'),console.error(w),console.error("Here are the modules that depend on it:"),console.error(w.neededBy);return}}if(o=o||{},typeof o.baseUrl!="string"&&(o.baseUrl=""),typeof o.isBuild!="boolean"&&(o.isBuild=!1),typeof o.paths!="object"&&(o.paths={}),typeof o.config!="object"&&(o.config={}),typeof o.catchError>"u"&&(o.catchError=!1),typeof o.recordStats>"u"&&(o.recordStats=!1),typeof o.urlArgs!="string"&&(o.urlArgs=""),typeof o.onError!="function"&&(o.onError=m),Array.isArray(o.ignoreDuplicateModules)||(o.ignoreDuplicateModules=[]),o.baseUrl.length>0&&(O.Utilities.endsWith(o.baseUrl,"/")||(o.baseUrl+="/")),typeof o.cspNonce!="string"&&(o.cspNonce=""),typeof o.preferScriptTags>"u"&&(o.preferScriptTags=!1),o.nodeCachedData&&typeof o.nodeCachedData=="object"&&(typeof o.nodeCachedData.seed!="string"&&(o.nodeCachedData.seed="seed"),(typeof o.nodeCachedData.writeDelay!="number"||o.nodeCachedData.writeDelay<0)&&(o.nodeCachedData.writeDelay=1e3*7),!o.nodeCachedData.path||typeof o.nodeCachedData.path!="string")){const w=n(new Error("INVALID cached data configuration, 'path' MUST be set"));w.phase="configuration",o.onError(w),o.nodeCachedData=void 0}return o}static mergeConfigurationOptions(o=null,m=null){let w=O.Utilities.recursiveClone(m||{});return O.Utilities.forEachProperty(o,(a,s)=>{a==="ignoreDuplicateModules"&&typeof w.ignoreDuplicateModules<"u"?w.ignoreDuplicateModules=w.ignoreDuplicateModules.concat(s):a==="paths"&&typeof w.paths<"u"?O.Utilities.forEachProperty(s,(b,e)=>w.paths[b]=e):a==="config"&&typeof w.config<"u"?O.Utilities.forEachProperty(s,(b,e)=>w.config[b]=e):w[a]=O.Utilities.recursiveClone(s)}),E.validateConfigurationOptions(w)}}O.ConfigurationOptionsUtil=E;class D{constructor(o,m){if(this._env=o,this.options=E.mergeConfigurationOptions(m),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let w=this.options.nodeRequire.main.filename,a=Math.max(w.lastIndexOf("/"),w.lastIndexOf("\\"));this.options.baseUrl=w.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let o=0;o<this.options.ignoreDuplicateModules.length;o++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[o]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],O.Utilities.forEachProperty(this.options.paths,(o,m)=>{Array.isArray(m)?this.sortedPathsRules.push({from:o,to:m}):this.sortedPathsRules.push({from:o,to:[m]})}),this.sortedPathsRules.sort((o,m)=>m.from.length-o.from.length)}cloneAndMerge(o){return new D(this._env,E.mergeConfigurationOptions(o,this.options))}getOptionsLiteral(){return this.options}_applyPaths(o){let m;for(let w=0,a=this.sortedPathsRules.length;w<a;w++)if(m=this.sortedPathsRules[w],O.Utilities.startsWith(o,m.from)){let s=[];for(let b=0,e=m.to.length;b<e;b++)s.push(m.to[b]+o.substr(m.from.length));return s}return[o]}_addUrlArgsToUrl(o){return O.Utilities.containsQueryString(o)?o+"&"+this.options.urlArgs:o+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(o){return this.options.urlArgs?this._addUrlArgsToUrl(o):o}_addUrlArgsIfNecessaryToUrls(o){if(this.options.urlArgs)for(let m=0,w=o.length;m<w;m++)o[m]=this._addUrlArgsToUrl(o[m]);return o}moduleIdToPaths(o){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(o))return this.isBuild()?["empty:"]:["node|"+o];let m=o,w;if(!O.Utilities.endsWith(m,".js")&&!O.Utilities.isAbsolutePath(m)){w=this._applyPaths(m);for(let a=0,s=w.length;a<s;a++)this.isBuild()&&w[a]==="empty:"||(O.Utilities.isAbsolutePath(w[a])||(w[a]=this.options.baseUrl+w[a]),!O.Utilities.endsWith(w[a],".js")&&!O.Utilities.containsQueryString(w[a])&&(w[a]=w[a]+".js"))}else!O.Utilities.endsWith(m,".js")&&!O.Utilities.containsQueryString(m)&&(m=m+".js"),w=[m];return this._addUrlArgsIfNecessaryToUrls(w)}requireToUrl(o){let m=o;return O.Utilities.isAbsolutePath(m)||(m=this._applyPaths(m)[0],O.Utilities.isAbsolutePath(m)||(m=this.options.baseUrl+m)),this._addUrlArgsIfNecessaryToUrl(m)}isBuild(){return this.options.isBuild}shouldInvokeFactory(o){return!!(!this.options.isBuild||O.Utilities.isAnonymousModule(o)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[o])}isDuplicateMessageIgnoredFor(o){return this.ignoreDuplicateModulesMap.hasOwnProperty(o)}getConfigForModule(o){if(this.options.config)return this.options.config[o]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(o){this.options.onError(o)}}O.Configuration=D})(ue||(ue={}));var ue;(function(O){class n{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,b,e,c){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:d}=s.getConfig().getOptionsLiteral();d?this._scriptLoader=new E:this._scriptLoader=new o(this._env)}else this._env.isNode?this._scriptLoader=new o(this._env):this._scriptLoader=new E;let h={callback:e,errorback:c};if(this._callbackMap.hasOwnProperty(b)){this._callbackMap[b].push(h);return}this._callbackMap[b]=[h],this._scriptLoader.load(s,b,()=>this.triggerCallback(b),d=>this.triggerErrorback(b,d))}triggerCallback(s){let b=this._callbackMap[s];delete this._callbackMap[s];for(let e=0;e<b.length;e++)b[e].callback()}triggerErrorback(s,b){let e=this._callbackMap[s];delete this._callbackMap[s];for(let c=0;c<e.length;c++)e[c].errorback(b)}}class E{attachListeners(s,b,e){let c=()=>{s.removeEventListener("load",h),s.removeEventListener("error",d)},h=_=>{c(),b()},d=_=>{c(),e(_)};s.addEventListener("load",h),s.addEventListener("error",d)}load(s,b,e,c){if(/^node\|/.test(b)){let h=s.getConfig().getOptionsLiteral(),d=m(s.getRecorder(),h.nodeRequire||O.global.nodeRequire),_=b.split("|"),g=null;try{g=d(_[1])}catch(N){c(N);return}s.enqueueDefineAnonymousModule([],()=>g),e()}else{let h=document.createElement("script");h.setAttribute("async","async"),h.setAttribute("type","text/javascript"),this.attachListeners(h,e,c);const{trustedTypesPolicy:d}=s.getConfig().getOptionsLiteral();d&&(b=d.createScriptURL(b)),h.setAttribute("src",b);const{cspNonce:_}=s.getConfig().getOptionsLiteral();_&&h.setAttribute("nonce",_),document.getElementsByTagName("head")[0].appendChild(h)}}}function D(a){const{trustedTypesPolicy:s}=a.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=D(s)),this._cachedCanUseEval}load(s,b,e,c){if(/^node\|/.test(b)){const h=s.getConfig().getOptionsLiteral(),d=m(s.getRecorder(),h.nodeRequire||O.global.nodeRequire),_=b.split("|");let g=null;try{g=d(_[1])}catch(N){c(N);return}s.enqueueDefineAnonymousModule([],function(){return g}),e()}else{const{trustedTypesPolicy:h}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(b)&&b.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(b).then(_=>{if(_.status!==200)throw new Error(_.statusText);return _.text()}).then(_=>{_=`${_}
//# sourceURL=${b}`,(h?self.eval(h.createScript("",_)):new Function(_)).call(self),e()}).then(void 0,c);return}try{h&&(b=h.createScriptURL(b)),importScripts(b),e()}catch(_){c(_)}}}}class o{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,b){const{nodeCachedData:e}=b.getConfig().getOptionsLiteral();if(!e||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const c=this,h=s("module");function d(_){const g=_.constructor;let N=function(A){try{return _.require(A)}finally{}};return N.resolve=function(A,S){return g._resolveFilename(A,_,!1,S)},N.resolve.paths=function(A){return g._resolveLookupPaths(A,_)},N.main=process.mainModule,N.extensions=g._extensions,N.cache=g._cache,N}h.prototype._compile=function(_,g){const N=h.wrap(_.replace(/^#!.*/,"")),v=b.getRecorder(),A=c._getCachedDataPath(e,g),S={filename:g};let u;try{const R=c._fs.readFileSync(A);u=R.slice(0,16),S.cachedData=R.slice(16),v.record(60,A)}catch{v.record(61,A)}const r=new c._vm.Script(N,S),l=r.runInThisContext(S),f=c._path.dirname(g),L=d(this),C=[this.exports,L,this,g,f,process,Re,Buffer],p=l.apply(this.exports,C);return c._handleCachedData(r,N,A,!S.cachedData,b),c._verifyCachedData(r,N,A,u,b),p}}load(s,b,e,c){const h=s.getConfig().getOptionsLiteral(),d=m(s.getRecorder(),h.nodeRequire||O.global.nodeRequire),_=h.nodeInstrumenter||function(N){return N};this._init(d),this._initNodeRequire(d,s);let g=s.getRecorder();if(/^node\|/.test(b)){let N=b.split("|"),v=null;try{v=d(N[1])}catch(A){c(A);return}s.enqueueDefineAnonymousModule([],()=>v),e()}else{b=O.Utilities.fileUriToFilePath(this._env.isWindows,b);const N=this._path.normalize(b),v=this._getElectronRendererScriptPathOrUri(N),A=!!h.nodeCachedData,S=A?this._getCachedDataPath(h.nodeCachedData,b):void 0;this._readSourceAndCachedData(N,S,g,(u,r,l,f)=>{if(u){c(u);return}let L;r.charCodeAt(0)===o._BOM?L=o._PREFIX+r.substring(1)+o._SUFFIX:L=o._PREFIX+r+o._SUFFIX,L=_(L,N);const C={filename:v,cachedData:l},p=this._createAndEvalScript(s,L,C,e,c);this._handleCachedData(p,L,S,A&&!l,s),this._verifyCachedData(p,L,S,f,s)})}}_createAndEvalScript(s,b,e,c,h){const d=s.getRecorder();d.record(31,e.filename);const _=new this._vm.Script(b,e),g=_.runInThisContext(e),N=s.getGlobalAMDDefineFunc();let v=!1;const A=function(){return v=!0,N.apply(null,arguments)};return A.amd=N.amd,g.call(O.global,s.getGlobalAMDRequireFunc(),A,e.filename,this._path.dirname(e.filename)),d.record(32,e.filename),v?c():h(new Error(`Didn't receive define call in ${e.filename}!`)),_}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let b=s.match(/^([a-z])\:(.*)/i);return b?`file:///${(b[1].toUpperCase()+":"+b[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,b){const e=this._crypto.createHash("md5").update(b,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),c=this._path.basename(b).replace(/\.js$/,"");return this._path.join(s.path,`${c}-${e}.code`)}_handleCachedData(s,b,e,c,h){s.cachedDataRejected?this._fs.unlink(e,d=>{h.getRecorder().record(62,e),this._createAndWriteCachedData(s,b,e,h),d&&h.getConfig().onError(d)}):c&&this._createAndWriteCachedData(s,b,e,h)}_createAndWriteCachedData(s,b,e,c){let h=Math.ceil(c.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),d=-1,_=0,g;const N=()=>{setTimeout(()=>{g||(g=this._crypto.createHash("md5").update(b,"utf8").digest());const v=s.createCachedData();if(!(v.length===0||v.length===d||_>=5)){if(v.length<d){N();return}d=v.length,this._fs.writeFile(e,Buffer.concat([g,v]),A=>{A&&c.getConfig().onError(A),c.getRecorder().record(63,e),N()})}},h*Math.pow(4,_++))};N()}_readSourceAndCachedData(s,b,e,c){if(!b)this._fs.readFile(s,{encoding:"utf8"},c);else{let h,d,_,g=2;const N=v=>{v?c(v):--g===0&&c(void 0,h,d,_)};this._fs.readFile(s,{encoding:"utf8"},(v,A)=>{h=A,N(v)}),this._fs.readFile(b,(v,A)=>{!v&&A&&A.length>0?(_=A.slice(0,16),d=A.slice(16),e.record(60,b)):e.record(61,b),N()})}}_verifyCachedData(s,b,e,c,h){c&&(s.cachedDataRejected||setTimeout(()=>{const d=this._crypto.createHash("md5").update(b,"utf8").digest();c.equals(d)||(h.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${e}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(e,_=>{_&&h.getConfig().onError(_)}))},Math.ceil(5e3*(1+Math.random()))))}}o._BOM=65279,o._PREFIX="(function (require, define, __filename, __dirname) { ",o._SUFFIX=`
});`;function m(a,s){if(s.__$__isRecorded)return s;const b=function(c){a.record(33,c);try{return s(c)}finally{a.record(34,c)}};return b.__$__isRecorded=!0,b}O.ensureRecordedNodeRequire=m;function w(a){return new n(a)}O.createScriptLoader=w})(ue||(ue={}));var ue;(function(O){class n{constructor(a){let s=a.lastIndexOf("/");s!==-1?this.fromModulePath=a.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(a){let s=a,b;for(b=/\/\.\//;b.test(s);)s=s.replace(b,"/");for(s=s.replace(/^\.\//g,""),b=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;b.test(s);)s=s.replace(b,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(a){let s=a;return O.Utilities.isAbsolutePath(s)||(O.Utilities.startsWith(s,"./")||O.Utilities.startsWith(s,"../"))&&(s=n._normalizeModuleId(this.fromModulePath+s)),s}}n.ROOT=new n(""),O.ModuleIdResolver=n;class E{constructor(a,s,b,e,c,h){this.id=a,this.strId=s,this.dependencies=b,this._callback=e,this._errorback=c,this.moduleIdResolver=h,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,s){try{return{returnedValue:a.apply(O.global,s),producedError:null}}catch(b){return{returnedValue:null,producedError:b}}}static _invokeFactory(a,s,b,e){return a.shouldInvokeFactory(s)?a.shouldCatchError()?this._safeInvokeFunction(b,e):{returnedValue:b.apply(O.global,e),producedError:null}:{returnedValue:null,producedError:null}}complete(a,s,b,e){this._isComplete=!0;let c=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let h=E._invokeFactory(s,this.strId,this._callback,b);c=h.producedError,a.record(22,this.strId),!c&&typeof h.returnedValue<"u"&&(!this.exportsPassedIn||O.Utilities.isEmpty(this.exports))&&(this.exports=h.returnedValue)}else this.exports=this._callback;if(c){let h=O.ensureError(c);h.phase="factory",h.moduleId=this.strId,h.neededBy=e(this.id),this.error=h,s.onError(h)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}O.Module=E;class D{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let s=this._strModuleIdToIntModuleId.get(a);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(a,s),this._intModuleIdToStrModuleId[s]=a),s}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class i{constructor(a){this.id=a}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),O.RegularDependency=i;class o{constructor(a,s,b){this.id=a,this.pluginId=s,this.pluginParam=b}}O.PluginDependency=o;class m{constructor(a,s,b,e,c=0){this._env=a,this._scriptLoader=s,this._loaderAvailableTimestamp=c,this._defineFunc=b,this._requireFunc=e,this._moduleIdProvider=new D,this._config=new O.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}reset(){return new m(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,s){let b=h=>h.replace(/\\/g,"/"),e=b(a),c=s.split(/\n/);for(let h=0;h<c.length;h++){let d=c[h].match(/(.*):(\d+):(\d+)\)?$/);if(d){let _=d[1],g=d[2],N=d[3],v=Math.max(_.lastIndexOf(" ")+1,_.lastIndexOf("(")+1);if(_=_.substr(v),_=b(_),_===e){let A={line:parseInt(g,10),col:parseInt(N,10)};return A.line===1&&(A.col-=53),A}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],s=0;for(let b=0,e=this._modules2.length;b<e;b++){let c=this._modules2[b];if(!c)continue;let h=this._buildInfoPath[c.id]||null,d=this._buildInfoDefineStack[c.id]||null,_=this._buildInfoDependencies[c.id];a[s++]={id:c.strId,path:h,defineLocation:h&&d?m._findRelevantLocationInStack(h,d):null,dependencies:_,shim:null,exports:c.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new O.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=O.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let b=null;this._config.isBuild()&&(b=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:b,dependencies:a,callback:s}}defineModule(a,s,b,e,c,h=new n(a)){let d=this._moduleIdProvider.getModuleId(a);if(this._modules2[d]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let _=new E(d,a,this._normalizeDependencies(s,h),b,e,h);this._modules2[d]=_,this._config.isBuild()&&(this._buildInfoDefineStack[d]=c,this._buildInfoDependencies[d]=(_.dependencies||[]).map(g=>this._moduleIdProvider.getStrModuleId(g.id))),this._resolve(_)}_normalizeDependency(a,s){if(a==="exports")return i.EXPORTS;if(a==="module")return i.MODULE;if(a==="require")return i.REQUIRE;let b=a.indexOf("!");if(b>=0){let e=s.resolveModule(a.substr(0,b)),c=s.resolveModule(a.substr(b+1)),h=this._moduleIdProvider.getModuleId(e+"!"+c),d=this._moduleIdProvider.getModuleId(e);return new o(h,d,c)}return new i(this._moduleIdProvider.getModuleId(s.resolveModule(a)))}_normalizeDependencies(a,s){let b=[],e=0;for(let c=0,h=a.length;c<h;c++)b[e++]=this._normalizeDependency(a[c],s);return b}_relativeRequire(a,s,b,e){if(typeof s=="string")return this.synchronousRequire(s,a);this.defineModule(O.Utilities.generateAnonymousModule(),s,b,e,null,a)}synchronousRequire(a,s=new n(a)){let b=this._normalizeDependency(a,s),e=this._modules2[b.id];if(!e)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!e.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(e.error)throw e.error;return e.exports}configure(a,s){let b=this._config.shouldRecordStats();s?this._config=new O.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!b&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),s.dependencies,s.callback,null,s.stack)}}_createLoadError(a,s){let b=this._moduleIdProvider.getStrModuleId(a),e=(this._inverseDependencies2[a]||[]).map(h=>this._moduleIdProvider.getStrModuleId(h));const c=O.ensureError(s);return c.phase="loading",c.moduleId=b,c.neededBy=e,c}_onLoadError(a,s){const b=this._createLoadError(a,s);this._modules2[a]||(this._modules2[a]=new E(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let e=[];for(let d=0,_=this._moduleIdProvider.getMaxModuleId();d<_;d++)e[d]=!1;let c=!1,h=[];for(h.push(a),e[a]=!0;h.length>0;){let d=h.shift(),_=this._modules2[d];_&&(c=_.onDependencyError(b)||c);let g=this._inverseDependencies2[d];if(g)for(let N=0,v=g.length;N<v;N++){let A=g[N];e[A]||(h.push(A),e[A]=!0)}}c||this._config.onError(b)}_hasDependencyPath(a,s){let b=this._modules2[a];if(!b)return!1;let e=[];for(let h=0,d=this._moduleIdProvider.getMaxModuleId();h<d;h++)e[h]=!1;let c=[];for(c.push(b),e[a]=!0;c.length>0;){let d=c.shift().dependencies;if(d)for(let _=0,g=d.length;_<g;_++){let N=d[_];if(N.id===s)return!0;let v=this._modules2[N.id];v&&!e[N.id]&&(e[N.id]=!0,c.push(v))}}return!1}_findCyclePath(a,s,b){if(a===s||b===50)return[a];let e=this._modules2[a];if(!e)return null;let c=e.dependencies;if(c)for(let h=0,d=c.length;h<d;h++){let _=this._findCyclePath(c[h].id,s,b+1);if(_!==null)return _.push(a),_}return null}_createRequire(a){let s=(b,e,c)=>this._relativeRequire(a,b,e,c);return s.toUrl=b=>this._config.requireToUrl(a.resolveModule(b)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(b,e=!1)=>{this.configure(b,e)},s.__$__nodeRequire=O.global.nodeRequire,s}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let s=this._moduleIdProvider.getStrModuleId(a),b=this._config.moduleIdToPaths(s),e=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||e.test(s))&&b.push("node|"+s);let c=-1,h=d=>{if(c++,c>=b.length)this._onLoadError(a,d);else{let _=b[c],g=this.getRecorder();if(this._config.isBuild()&&_==="empty:"){this._buildInfoPath[a]=_,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}g.record(10,_),this._scriptLoader.load(this,_,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=_),g.record(11,_),this._onLoad(a)},N=>{g.record(12,_),h(N)})}};h(null)}_loadPluginDependency(a,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let b=e=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],e,null,null)};b.error=e=>{this._config.onError(this._createLoadError(s.id,e))},a.load(s.pluginParam,this._createRequire(n.ROOT),b,this._config.getOptionsLiteral())}_resolve(a){let s=a.dependencies;if(s)for(let b=0,e=s.length;b<e;b++){let c=s[b];if(c===i.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(c===i.MODULE){a.unresolvedDependenciesCount--;continue}if(c===i.REQUIRE){a.unresolvedDependenciesCount--;continue}let h=this._modules2[c.id];if(h&&h.isComplete()){if(h.error){a.onDependencyError(h.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(c.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(c.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let d=this._findCyclePath(c.id,a.id,0)||[];d.reverse(),d.push(c.id),console.warn(d.map(_=>this._moduleIdProvider.getStrModuleId(_)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[c.id]=this._inverseDependencies2[c.id]||[],this._inverseDependencies2[c.id].push(a.id),c instanceof o){let d=this._modules2[c.pluginId];if(d&&d.isComplete()){this._loadPluginDependency(d.exports,c);continue}let _=this._inversePluginDependencies2.get(c.pluginId);_||(_=[],this._inversePluginDependencies2.set(c.pluginId,_)),_.push(c),this._loadModule(c.pluginId);continue}this._loadModule(c.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let s=this.getRecorder();if(a.isComplete())return;let b=a.dependencies,e=[];if(b)for(let _=0,g=b.length;_<g;_++){let N=b[_];if(N===i.EXPORTS){e[_]=a.exports;continue}if(N===i.MODULE){e[_]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(N===i.REQUIRE){e[_]=this._createRequire(a.moduleIdResolver);continue}let v=this._modules2[N.id];if(v){e[_]=v.exports;continue}e[_]=null}const c=_=>(this._inverseDependencies2[_]||[]).map(g=>this._moduleIdProvider.getStrModuleId(g));a.complete(s,this._config,e,c);let h=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,h)for(let _=0,g=h.length;_<g;_++){let N=h[_],v=this._modules2[N];v.unresolvedDependenciesCount--,v.unresolvedDependenciesCount===0&&this._onModuleComplete(v)}let d=this._inversePluginDependencies2.get(a.id);if(d){this._inversePluginDependencies2.delete(a.id);for(let _=0,g=d.length;_<g;_++)this._loadPluginDependency(a.exports,d[_])}}}O.ModuleManager=m})(ue||(ue={}));var X,ue;(function(O){const n=new O.Environment;let E=null;const D=function(w,a,s){typeof w!="string"&&(s=a,a=w,w=null),(typeof a!="object"||!Array.isArray(a))&&(s=a,a=null),a||(a=["require","exports","module"]),w?E.defineModule(w,a,s,null,null):E.enqueueDefineAnonymousModule(a,s)};D.amd={jQuery:!0};const i=function(w,a=!1){E.configure(w,a)},o=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return E.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){E.defineModule(O.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};o.config=i,o.getConfig=function(){return E.getConfig().getOptionsLiteral()},o.reset=function(){E=E.reset()},o.getBuildInfo=function(){return E.getBuildInfo()},o.getStats=function(){return E.getLoaderEvents()},o.define=D;function m(){if(typeof O.global.require<"u"||typeof require<"u"){const w=O.global.require||require;if(typeof w=="function"&&typeof w.resolve=="function"){const a=O.ensureRecordedNodeRequire(E.getRecorder(),w);O.global.nodeRequire=a,o.nodeRequire=a,o.__$__nodeRequire=a}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?module.exports=o:(n.isElectronRenderer||(O.global.define=D),O.global.require=o)}O.init=m,(typeof O.global.define!="function"||!O.global.define.amd)&&(E=new O.ModuleManager(n,O.createScriptLoader(n),D,o,O.Utilities.getHighPerformanceTimestamp()),typeof O.global.require<"u"&&typeof O.global.require!="function"&&o.config(O.global.require),X=function(){return D.apply(null,arguments)},X.amd=D.amd,typeof doNotInitLoader>"u"&&m())})(ue||(ue={}));var ge=this&&this.__awaiter||function(O,n,E,D){function i(o){return o instanceof E?o:new E(function(m){m(o)})}return new(E||(E=Promise))(function(o,m){function w(b){try{s(D.next(b))}catch(e){m(e)}}function a(b){try{s(D.throw(b))}catch(e){m(e)}}function s(b){b.done?o(b.value):i(b.value).then(w,a)}s((D=D.apply(O,n||[])).next())})};X(J[25],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.load=n.create=n.setPseudoTranslation=n.getConfiguredDefaultLocale=n.localize=void 0;let E=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const D="i-default";function i(d,_){let g;return _.length===0?g=d:g=d.replace(/\{(\d+)\}/g,(N,v)=>{const A=v[0],S=_[A];let u=N;return typeof S=="string"?u=S:(typeof S=="number"||typeof S=="boolean"||S===void 0||S===null)&&(u=String(S)),u}),E&&(g="\uFF3B"+g.replace(/[aouei]/g,"$&$&")+"\uFF3D"),g}function o(d,_){let g=d[_];return g||(g=d["*"],g)?g:null}function m(d){return d.charAt(d.length-1)==="/"?d:d+"/"}function w(d,_,g){return ge(this,void 0,void 0,function*(){const N=m(d)+m(_)+"vscode/"+m(g),v=yield fetch(N);if(v.ok)return yield v.json();throw new Error(`${v.status} - ${v.statusText}`)})}function a(d){return function(_,g){const N=Array.prototype.slice.call(arguments,2);return i(d[_],N)}}function s(d,_,...g){return i(_,g)}n.localize=s;function b(d){}n.getConfiguredDefaultLocale=b;function e(d){E=d}n.setPseudoTranslation=e;function c(d,_){var g;return{localize:a(_[d]),getConfiguredDefaultLocale:(g=_.getConfiguredDefaultLocale)!==null&&g!==void 0?g:N=>{}}}n.create=c;function h(d,_,g,N){var v;const A=(v=N["vs/nls"])!==null&&v!==void 0?v:{};if(!d||d.length===0)return g({localize:s,getConfiguredDefaultLocale:()=>{var f;return(f=A.availableLanguages)===null||f===void 0?void 0:f["*"]}});const S=A.availableLanguages?o(A.availableLanguages,d):null,u=S===null||S===D;let r=".nls";u||(r=r+"."+S);const l=f=>{Array.isArray(f)?f.localize=a(f):f.localize=a(f[d]),f.getConfiguredDefaultLocale=()=>{var L;return(L=A.availableLanguages)===null||L===void 0?void 0:L["*"]},g(f)};typeof A.loadBundle=="function"?A.loadBundle(d,S,(f,L)=>{f?_([d+".nls"],l):l(L)}):A.translationServiceUrl&&!u?ge(this,void 0,void 0,function*(){var f;try{const L=yield w(A.translationServiceUrl,S,d);return l(L)}catch(L){if(!S.includes("-"))return console.error(L),_([d+".nls"],l);try{const C=S.split("-")[0],p=yield w(A.translationServiceUrl,C,d);return(f=A.availableLanguages)!==null&&f!==void 0||(A.availableLanguages={}),A.availableLanguages["*"]=C,l(p)}catch(C){return console.error(C),_([d+".nls"],l)}}}):_([d+r],l,f=>{if(r===".nls"){console.error("Failed trying to load default language strings",f);return}console.error(`Failed to load message bundle for language ${S}. Falling back to the default language:`,f),_([d+".nls"],l)})}n.load=h}),function(){const O=globalThis.MonacoEnvironment,n=O&&O.baseUrl?O.baseUrl:"../../../";function E(b,e){var c;if(O?.createTrustedTypesPolicy)try{return O.createTrustedTypesPolicy(b,e)}catch(h){console.warn(h);return}try{return(c=self.trustedTypes)===null||c===void 0?void 0:c.createPolicy(b,e)}catch(h){console.warn(h);return}}const D=E("amdLoader",{createScriptURL:b=>b,createScript:(b,...e)=>{const c=e.slice(0,-1).join(","),h=e.pop().toString();return`(function anonymous(${c}) { ${h}
})`}});function i(){try{return(D?globalThis.eval(D.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function o(){return new Promise((b,e)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return b();const c=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(c)&&c.substring(0,globalThis.origin.length)!==globalThis.origin)&&i()){fetch(c).then(d=>{if(d.status!==200)throw new Error(d.statusText);return d.text()}).then(d=>{d=`${d}
//# sourceURL=${c}`,(D?globalThis.eval(D.createScript("",d)):new Function(d)).call(globalThis),b()}).then(void 0,e);return}D?importScripts(D.createScriptURL(c)):importScripts(c),b()})}function m(){require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:D,amdModulesPattern:/^vs\//})}function w(b){o().then(()=>{m(),require([b],function(e){setTimeout(function(){const c=e.create((h,d)=>{globalThis.postMessage(h,d)},null);for(globalThis.onmessage=h=>c.onmessage(h.data,h.ports);s.length>0;){const h=s.shift();c.onmessage(h.data,h.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&m();let a=!0;const s=[];globalThis.onmessage=b=>{if(!a){s.push(b);return}a=!1,w(b.data)}}(),X(J[26],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CallbackIterable=n.ArrayQueue=n.findMinBy=n.findLastMaxBy=n.findMaxBy=n.numberComparator=n.compareBy=n.CompareResult=n.splice=n.insertInto=n.mapFind=n.asArray=n.pushMany=n.pushToEnd=n.pushToStart=n.arrayInsert=n.range=n.firstOrDefault=n.lastIndex=n.findLast=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.coalesceInPlace=n.coalesce=n.groupBy=n.quickSelect=n.findFirstInSorted=n.binarySearch2=n.binarySearch=n.removeFastWithoutKeepingOrder=n.equals=n.tail2=n.tail=void 0;function E(T,x=0){return T[T.length-(1+x)]}n.tail=E;function D(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}n.tail2=D;function i(T,x,q=(H,t)=>H===t){if(T===x)return!0;if(!T||!x||T.length!==x.length)return!1;for(let H=0,t=T.length;H<t;H++)if(!q(T[H],x[H]))return!1;return!0}n.equals=i;function o(T,x){const q=T.length-1;x<q&&(T[x]=T[q]),T.pop()}n.removeFastWithoutKeepingOrder=o;function m(T,x,q){return w(T.length,H=>q(T[H],x))}n.binarySearch=m;function w(T,x){let q=0,H=T-1;for(;q<=H;){const t=(q+H)/2|0,ne=x(t);if(ne<0)q=t+1;else if(ne>0)H=t-1;else return t}return-(q+1)}n.binarySearch2=w;function a(T,x){let q=0,H=T.length;if(H===0)return 0;for(;q<H;){const t=Math.floor((q+H)/2);x(T[t])?H=t:q=t+1}return q}n.findFirstInSorted=a;function s(T,x,q){if(T=T|0,T>=x.length)throw new TypeError("invalid index");const H=x[Math.floor(x.length*Math.random())],t=[],ne=[],ie=[];for(const he of x){const me=q(he,H);me<0?t.push(he):me>0?ne.push(he):ie.push(he)}return T<t.length?s(T,t,q):T<t.length+ie.length?ie[0]:s(T-(t.length+ie.length),ne,q)}n.quickSelect=s;function b(T,x){const q=[];let H;for(const t of T.slice(0).sort(x))!H||x(H[0],t)!==0?(H=[t],q.push(H)):H.push(t);return q}n.groupBy=b;function e(T){return T.filter(x=>!!x)}n.coalesce=e;function c(T){let x=0;for(let q=0;q<T.length;q++)T[q]&&(T[x]=T[q],x+=1);T.length=x}n.coalesceInPlace=c;function h(T){return!Array.isArray(T)||T.length===0}n.isFalsyOrEmpty=h;function d(T){return Array.isArray(T)&&T.length>0}n.isNonEmptyArray=d;function _(T,x=q=>q){const q=new Set;return T.filter(H=>{const t=x(H);return q.has(t)?!1:(q.add(t),!0)})}n.distinct=_;function g(T,x){const q=N(T,x);if(q!==-1)return T[q]}n.findLast=g;function N(T,x){for(let q=T.length-1;q>=0;q--){const H=T[q];if(x(H))return q}return-1}n.lastIndex=N;function v(T,x){return T.length>0?T[0]:x}n.firstOrDefault=v;function A(T,x){let q=typeof x=="number"?T:0;typeof x=="number"?q=T:(q=0,x=T);const H=[];if(q<=x)for(let t=q;t<x;t++)H.push(t);else for(let t=q;t>x;t--)H.push(t);return H}n.range=A;function S(T,x,q){const H=T.slice(0,x),t=T.slice(x);return H.concat(q,t)}n.arrayInsert=S;function u(T,x){const q=T.indexOf(x);q>-1&&(T.splice(q,1),T.unshift(x))}n.pushToStart=u;function r(T,x){const q=T.indexOf(x);q>-1&&(T.splice(q,1),T.push(x))}n.pushToEnd=r;function l(T,x){for(const q of x)T.push(q)}n.pushMany=l;function f(T){return Array.isArray(T)?T:[T]}n.asArray=f;function L(T,x){for(const q of T){const H=x(q);if(H!==void 0)return H}}n.mapFind=L;function C(T,x,q){const H=R(T,x),t=T.length,ne=q.length;T.length=t+ne;for(let ie=t-1;ie>=H;ie--)T[ie+ne]=T[ie];for(let ie=0;ie<ne;ie++)T[ie+H]=q[ie]}n.insertInto=C;function p(T,x,q,H){const t=R(T,x),ne=T.splice(t,q);return C(T,t,H),ne}n.splice=p;function R(T,x){return x<0?Math.max(x+T.length,0):Math.min(x,T.length)}var y;(function(T){function x(t){return t<0}T.isLessThan=x;function q(t){return t>0}T.isGreaterThan=q;function H(t){return t===0}T.isNeitherLessOrGreaterThan=H,T.greaterThan=1,T.lessThan=-1,T.neitherLessOrGreaterThan=0})(y||(n.CompareResult=y={}));function M(T,x){return(q,H)=>x(T(q),T(H))}n.compareBy=M;const F=(T,x)=>T-x;n.numberComparator=F;function I(T,x){if(T.length===0)return;let q=T[0];for(let H=1;H<T.length;H++){const t=T[H];x(t,q)>0&&(q=t)}return q}n.findMaxBy=I;function P(T,x){if(T.length===0)return;let q=T[0];for(let H=1;H<T.length;H++){const t=T[H];x(t,q)>=0&&(q=t)}return q}n.findLastMaxBy=P;function U(T,x){return I(T,(q,H)=>-x(q,H))}n.findMinBy=U;class W{constructor(x){this.items=x,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(x){let q=this.firstIdx;for(;q<this.items.length&&x(this.items[q]);)q++;const H=q===this.firstIdx?null:this.items.slice(this.firstIdx,q);return this.firstIdx=q,H}takeFromEndWhile(x){let q=this.lastIdx;for(;q>=0&&x(this.items[q]);)q--;const H=q===this.lastIdx?null:this.items.slice(q+1,this.lastIdx+1);return this.lastIdx=q,H}peek(){if(this.length!==0)return this.items[this.firstIdx]}dequeue(){const x=this.items[this.firstIdx];return this.firstIdx++,x}takeCount(x){const q=this.items.slice(this.firstIdx,this.firstIdx+x);return this.firstIdx+=x,q}}n.ArrayQueue=W;class z{constructor(x){this.iterate=x}toArray(){const x=[];return this.iterate(q=>(x.push(q),!0)),x}filter(x){return new z(q=>this.iterate(H=>x(H)?q(H):!0))}map(x){return new z(q=>this.iterate(H=>q(x(H))))}findLast(x){let q;return this.iterate(H=>(x(H)&&(q=H),!0)),q}findLastMaxBy(x){let q,H=!0;return this.iterate(t=>((H||y.isGreaterThan(x(t,q)))&&(H=!1,q=t),!0)),q}}n.CallbackIterable=z,z.empty=new z(T=>{})}),X(J[27],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=void 0;class E{constructor(o){this.fn=o,this.lastCache=void 0,this.lastArgKey=void 0}get(o){const m=JSON.stringify(o);return this.lastArgKey!==m&&(this.lastArgKey=m,this.lastCache=this.fn(o)),this.lastCache}}n.LRUCachedFunction=E;class D{get cachedValues(){return this._map}constructor(o){this.fn=o,this._map=new Map}get(o){if(this._map.has(o))return this._map.get(o);const m=this.fn(o);return this._map.set(o,m),m}}n.CachedFunction=D}),X(J[28],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Color=n.HSVA=n.HSLA=n.RGBA=void 0;function E(w,a){const s=Math.pow(10,a);return Math.round(w*s)/s}class D{constructor(a,s,b,e=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,a))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,b))|0,this.a=E(Math.max(Math.min(1,e),0),3)}static equals(a,s){return a.r===s.r&&a.g===s.g&&a.b===s.b&&a.a===s.a}}n.RGBA=D;class i{constructor(a,s,b,e){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=E(Math.max(Math.min(1,s),0),3),this.l=E(Math.max(Math.min(1,b),0),3),this.a=E(Math.max(Math.min(1,e),0),3)}static equals(a,s){return a.h===s.h&&a.s===s.s&&a.l===s.l&&a.a===s.a}static fromRGBA(a){const s=a.r/255,b=a.g/255,e=a.b/255,c=a.a,h=Math.max(s,b,e),d=Math.min(s,b,e);let _=0,g=0;const N=(d+h)/2,v=h-d;if(v>0){switch(g=Math.min(N<=.5?v/(2*N):v/(2-2*N),1),h){case s:_=(b-e)/v+(b<e?6:0);break;case b:_=(e-s)/v+2;break;case e:_=(s-b)/v+4;break}_*=60,_=Math.round(_)}return new i(_,g,N,c)}static _hue2rgb(a,s,b){return b<0&&(b+=1),b>1&&(b-=1),b<1/6?a+(s-a)*6*b:b<1/2?s:b<2/3?a+(s-a)*(2/3-b)*6:a}static toRGBA(a){const s=a.h/360,{s:b,l:e,a:c}=a;let h,d,_;if(b===0)h=d=_=e;else{const g=e<.5?e*(1+b):e+b-e*b,N=2*e-g;h=i._hue2rgb(N,g,s+1/3),d=i._hue2rgb(N,g,s),_=i._hue2rgb(N,g,s-1/3)}return new D(Math.round(h*255),Math.round(d*255),Math.round(_*255),c)}}n.HSLA=i;class o{constructor(a,s,b,e){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=E(Math.max(Math.min(1,s),0),3),this.v=E(Math.max(Math.min(1,b),0),3),this.a=E(Math.max(Math.min(1,e),0),3)}static equals(a,s){return a.h===s.h&&a.s===s.s&&a.v===s.v&&a.a===s.a}static fromRGBA(a){const s=a.r/255,b=a.g/255,e=a.b/255,c=Math.max(s,b,e),h=Math.min(s,b,e),d=c-h,_=c===0?0:d/c;let g;return d===0?g=0:c===s?g=((b-e)/d%6+6)%6:c===b?g=(e-s)/d+2:g=(s-b)/d+4,new o(Math.round(g*60),_,c,a.a)}static toRGBA(a){const{h:s,s:b,v:e,a:c}=a,h=e*b,d=h*(1-Math.abs(s/60%2-1)),_=e-h;let[g,N,v]=[0,0,0];return s<60?(g=h,N=d):s<120?(g=d,N=h):s<180?(N=h,v=d):s<240?(N=d,v=h):s<300?(g=d,v=h):s<=360&&(g=h,v=d),g=Math.round((g+_)*255),N=Math.round((N+_)*255),v=Math.round((v+_)*255),new D(g,N,v,c)}}n.HSVA=o;class m{static fromHex(a){return m.Format.CSS.parseHex(a)||m.red}static equals(a,s){return!a&&!s?!0:!a||!s?!1:a.equals(s)}get hsla(){return this._hsla?this._hsla:i.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:o.fromRGBA(this.rgba)}constructor(a){if(a)if(a instanceof D)this.rgba=a;else if(a instanceof i)this._hsla=a,this.rgba=i.toRGBA(a);else if(a instanceof o)this._hsva=a,this.rgba=o.toRGBA(a);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(a){return!!a&&D.equals(this.rgba,a.rgba)&&i.equals(this.hsla,a.hsla)&&o.equals(this.hsva,a.hsva)}getRelativeLuminance(){const a=m._relativeLuminanceForComponent(this.rgba.r),s=m._relativeLuminanceForComponent(this.rgba.g),b=m._relativeLuminanceForComponent(this.rgba.b),e=.2126*a+.7152*s+.0722*b;return E(e,4)}static _relativeLuminanceForComponent(a){const s=a/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(a){const s=this.getRelativeLuminance(),b=a.getRelativeLuminance();return s>b}isDarkerThan(a){const s=this.getRelativeLuminance(),b=a.getRelativeLuminance();return s<b}lighten(a){return new m(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*a,this.hsla.a))}darken(a){return new m(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*a,this.hsla.a))}transparent(a){const{r:s,g:b,b:e,a:c}=this.rgba;return new m(new D(s,b,e,c*a))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new m(new D(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}makeOpaque(a){if(this.isOpaque()||a.rgba.a!==1)return this;const{r:s,g:b,b:e,a:c}=this.rgba;return new m(new D(a.rgba.r-c*(a.rgba.r-s),a.rgba.g-c*(a.rgba.g-b),a.rgba.b-c*(a.rgba.b-e),1))}toString(){return this._toString||(this._toString=m.Format.CSS.format(this)),this._toString}static getLighterColor(a,s,b){if(a.isLighterThan(s))return a;b=b||.5;const e=a.getRelativeLuminance(),c=s.getRelativeLuminance();return b=b*(c-e)/c,a.lighten(b)}static getDarkerColor(a,s,b){if(a.isDarkerThan(s))return a;b=b||.5;const e=a.getRelativeLuminance(),c=s.getRelativeLuminance();return b=b*(e-c)/e,a.darken(b)}}n.Color=m,m.white=new m(new D(255,255,255,1)),m.black=new m(new D(0,0,0,1)),m.red=new m(new D(255,0,0,1)),m.blue=new m(new D(0,0,255,1)),m.green=new m(new D(0,255,0,1)),m.cyan=new m(new D(0,255,255,1)),m.lightgrey=new m(new D(211,211,211,1)),m.transparent=new m(new D(0,0,0,0)),function(w){let a;(function(s){let b;(function(e){function c(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:w.Format.CSS.formatRGBA(r)}e.formatRGB=c;function h(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}e.formatRGBA=h;function d(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:w.Format.CSS.formatHSLA(r)}e.formatHSL=d;function _(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}e.formatHSLA=_;function g(r){const l=r.toString(16);return l.length!==2?"0"+l:l}function N(r){return`#${g(r.rgba.r)}${g(r.rgba.g)}${g(r.rgba.b)}`}e.formatHex=N;function v(r,l=!1){return l&&r.rgba.a===1?w.Format.CSS.formatHex(r):`#${g(r.rgba.r)}${g(r.rgba.g)}${g(r.rgba.b)}${g(Math.round(r.rgba.a*255))}`}e.formatHexA=v;function A(r){return r.isOpaque()?w.Format.CSS.formatHex(r):w.Format.CSS.formatRGBA(r)}e.format=A;function S(r){const l=r.length;if(l===0||r.charCodeAt(0)!==35)return null;if(l===7){const f=16*u(r.charCodeAt(1))+u(r.charCodeAt(2)),L=16*u(r.charCodeAt(3))+u(r.charCodeAt(4)),C=16*u(r.charCodeAt(5))+u(r.charCodeAt(6));return new w(new D(f,L,C,1))}if(l===9){const f=16*u(r.charCodeAt(1))+u(r.charCodeAt(2)),L=16*u(r.charCodeAt(3))+u(r.charCodeAt(4)),C=16*u(r.charCodeAt(5))+u(r.charCodeAt(6)),p=16*u(r.charCodeAt(7))+u(r.charCodeAt(8));return new w(new D(f,L,C,p/255))}if(l===4){const f=u(r.charCodeAt(1)),L=u(r.charCodeAt(2)),C=u(r.charCodeAt(3));return new w(new D(16*f+f,16*L+L,16*C+C))}if(l===5){const f=u(r.charCodeAt(1)),L=u(r.charCodeAt(2)),C=u(r.charCodeAt(3)),p=u(r.charCodeAt(4));return new w(new D(16*f+f,16*L+L,16*C+C,(16*p+p)/255))}return null}e.parseHex=S;function u(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(b=s.CSS||(s.CSS={}))})(a=w.Format||(w.Format={}))}(m||(n.Color=m={}))}),X(J[29],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class E{constructor(i,o,m,w){this.originalStart=i,this.originalLength=o,this.modifiedStart=m,this.modifiedLength=w}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=E}),X(J[4],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.NotSupportedError=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isCancellationError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.errorHandler=n.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(g){setTimeout(()=>{throw g.stack?h.isErrorNoTelemetry(g)?new h(g.message+`

`+g.stack):new Error(g.message+`

`+g.stack):g},0)}}emit(g){this.listeners.forEach(N=>{N(g)})}onUnexpectedError(g){this.unexpectedErrorHandler(g),this.emit(g)}onUnexpectedExternalError(g){this.unexpectedErrorHandler(g)}}n.ErrorHandler=E,n.errorHandler=new E;function D(_){w(_)||n.errorHandler.onUnexpectedError(_)}n.onUnexpectedError=D;function i(_){w(_)||n.errorHandler.onUnexpectedExternalError(_)}n.onUnexpectedExternalError=i;function o(_){if(_ instanceof Error){const{name:g,message:N}=_,v=_.stacktrace||_.stack;return{$isError:!0,name:g,message:N,stack:v,noTelemetry:h.isErrorNoTelemetry(_)}}return _}n.transformErrorForSerialization=o;const m="Canceled";function w(_){return _ instanceof a?!0:_ instanceof Error&&_.name===m&&_.message===m}n.isCancellationError=w;class a extends Error{constructor(){super(m),this.name=this.message}}n.CancellationError=a;function s(){const _=new Error(m);return _.name=_.message,_}n.canceled=s;function b(_){return _?new Error(`Illegal argument: ${_}`):new Error("Illegal argument")}n.illegalArgument=b;function e(_){return _?new Error(`Illegal state: ${_}`):new Error("Illegal state")}n.illegalState=e;class c extends Error{constructor(g){super("NotSupported"),g&&(this.message=g)}}n.NotSupportedError=c;class h extends Error{constructor(g){super(g),this.name="CodeExpectedError"}static fromError(g){if(g instanceof h)return g;const N=new h;return N.message=g.message,N.stack=g.stack,N}static isErrorNoTelemetry(g){return g.name==="CodeExpectedError"}}n.ErrorNoTelemetry=h;class d extends Error{constructor(g){super(g||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype)}}n.BugIndicatingError=d}),X(J[9],Z([0,1,4]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.checkAdjacentItems=n.assertFn=n.assertNever=n.ok=void 0;function D(w,a){if(!w)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}n.ok=D;function i(w,a="Unreachable"){throw new Error(a)}n.assertNever=i;function o(w){if(!w()){debugger;w(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}n.assertFn=o;function m(w,a){let s=0;for(;s<w.length-1;){const b=w[s],e=w[s+1];if(!a(b,e))return!1;s++}return!0}n.checkAdjacentItems=m}),X(J[15],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function E(D){const i=this;let o=!1,m;return function(){return o||(o=!0,m=D.apply(i,arguments)),m}}n.once=E}),X(J[16],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var E;(function(D){function i(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}D.is=i;const o=Object.freeze([]);function m(){return o}D.empty=m;function*w(S){yield S}D.single=w;function a(S){return i(S)?S:w(S)}D.wrap=a;function s(S){return S||o}D.from=s;function b(S){return!S||S[Symbol.iterator]().next().done===!0}D.isEmpty=b;function e(S){return S[Symbol.iterator]().next().value}D.first=e;function c(S,u){for(const r of S)if(u(r))return!0;return!1}D.some=c;function h(S,u){for(const r of S)if(u(r))return r}D.find=h;function*d(S,u){for(const r of S)u(r)&&(yield r)}D.filter=d;function*_(S,u){let r=0;for(const l of S)yield u(l,r++)}D.map=_;function*g(...S){for(const u of S)for(const r of u)yield r}D.concat=g;function N(S,u,r){let l=r;for(const f of S)l=u(l,f);return l}D.reduce=N;function*v(S,u,r=S.length){for(u<0&&(u+=S.length),r<0?r+=S.length:r>S.length&&(r=S.length);u<r;u++)yield S[u]}D.slice=v;function A(S,u=Number.POSITIVE_INFINITY){const r=[];if(u===0)return[r,S];const l=S[Symbol.iterator]();for(let f=0;f<u;f++){const L=l.next();if(L.done)return[r,D.empty()];r.push(L.value)}return[r,{[Symbol.iterator](){return l}}]}D.consume=A})(E||(n.Iterable=E={}))}),X(J[30],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=void 0;class E{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(c,h){this._keyCodeToStr[c]=h,this._strToKeyCode[h.toLowerCase()]=c}keyCodeToStr(c){return this._keyCodeToStr[c]}strToKeyCode(c){return this._strToKeyCode[c.toLowerCase()]||0}}const D=new E,i=new E,o=new E;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const m=[],w=Object.create(null),a=Object.create(null);n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",c=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],h=[],d=[];for(const _ of c){const[g,N,v,A,S,u,r,l,f]=_;if(d[N]||(d[N]=!0,m[N]=v,w[v]=N,a[v.toLowerCase()]=N,g&&(n.IMMUTABLE_CODE_TO_KEY_CODE[N]=A,A!==0&&A!==3&&A!==5&&A!==4&&A!==6&&A!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[A]=N))),!h[A]){if(h[A]=!0,!S)throw new Error(`String representation missing for key code ${A} around scan code ${v}`);D.define(A,S),i.define(A,l||S),o.define(A,f||l||S)}u&&(n.EVENT_KEY_CODE_MAP[u]=A),r&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[r]=A)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var s;(function(e){function c(v){return D.keyCodeToStr(v)}e.toString=c;function h(v){return D.strToKeyCode(v)}e.fromString=h;function d(v){return i.keyCodeToStr(v)}e.toUserSettingsUS=d;function _(v){return o.keyCodeToStr(v)}e.toUserSettingsGeneral=_;function g(v){return i.strToKeyCode(v)||o.strToKeyCode(v)}e.fromUserSettings=g;function N(v){if(v>=98&&v<=113)return null;switch(v){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return D.keyCodeToStr(v)}e.toElectronAccelerator=N})(s||(n.KeyCodeUtils=s={}));function b(e,c){const h=(c&65535)<<16>>>0;return(e|h)>>>0}n.KeyChord=b}),X(J[31],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class E{constructor(i){this.executor=i,this._didRun=!1}get value(){if(!this._didRun)try{this._value=this.executor()}catch(i){this._error=i}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}n.Lazy=E}),X(J[10],Z([0,1,15,16]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DisposableMap=n.ImmortalReference=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.dispose=n.isDisposable=n.markAsSingleton=n.setDisposableTracker=void 0;const i=!1;let o=null;function m(r){o=r}if(n.setDisposableTracker=m,i){const r="__is_disposable_tracked__";m(new class{trackDisposable(l){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[r]||console.log(f)},3e3)}setParent(l,f){if(l&&l!==N.None)try{l[r]=!0}catch{}}markAsDisposed(l){if(l&&l!==N.None)try{l[r]=!0}catch{}}markAsSingleton(l){}})}function w(r){return o?.trackDisposable(r),r}function a(r){o?.markAsDisposed(r)}function s(r,l){o?.setParent(r,l)}function b(r,l){if(o)for(const f of r)o.setParent(f,l)}function e(r){return o?.markAsSingleton(r),r}n.markAsSingleton=e;function c(r){return typeof r.dispose=="function"&&r.dispose.length===0}n.isDisposable=c;function h(r){if(D.Iterable.is(r)){const l=[];for(const f of r)if(f)try{f.dispose()}catch(L){l.push(L)}if(l.length===1)throw l[0];if(l.length>1)throw new AggregateError(l,"Encountered errors while disposing of store");return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}n.dispose=h;function d(...r){const l=_(()=>h(r));return b(r,l),l}n.combinedDisposable=d;function _(r){const l=w({dispose:(0,E.once)(()=>{a(l),r()})});return l}n.toDisposable=_;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1,w(this)}dispose(){this._isDisposed||(a(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{h(this._toDispose)}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return s(l,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}n.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class N{constructor(){this._store=new g,w(this),s(this._store,this)}dispose(){a(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}n.Disposable=N,N.None=Object.freeze({dispose(){}});class v{constructor(){this._isDisposed=!1,w(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){var f;this._isDisposed||l===this._value||((f=this._value)===null||f===void 0||f.dispose(),l&&s(l,this),this._value=l)}clear(){this.value=void 0}dispose(){var l;this._isDisposed=!0,a(this),(l=this._value)===null||l===void 0||l.dispose(),this._value=void 0}}n.MutableDisposable=v;class A{constructor(l){this._disposable=l,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}n.RefCountedDisposable=A;class S{constructor(l){this.object=l}dispose(){}}n.ImmortalReference=S;class u{constructor(){this._store=new Map,this._isDisposed=!1,w(this)}dispose(){a(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{h(this._store.values())}finally{this._store.clear()}}get(l){return this._store.get(l)}set(l,f,L=!1){var C;this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),L||(C=this._store.get(l))===null||C===void 0||C.dispose(),this._store.set(l,f)}deleteAndDispose(l){var f;(f=this._store.get(l))===null||f===void 0||f.dispose(),this._store.delete(l)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}n.DisposableMap=u}),X(J[17],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class E{constructor(o){this.element=o,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class D{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let o=this._first;for(;o!==E.Undefined;){const m=o.next;o.prev=E.Undefined,o.next=E.Undefined,o=m}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(o){return this._insert(o,!1)}push(o){return this._insert(o,!0)}_insert(o,m){const w=new E(o);if(this._first===E.Undefined)this._first=w,this._last=w;else if(m){const s=this._last;this._last=w,w.prev=s,s.next=w}else{const s=this._first;this._first=w,w.next=s,s.prev=w}this._size+=1;let a=!1;return()=>{a||(a=!0,this._remove(w))}}shift(){if(this._first!==E.Undefined){const o=this._first.element;return this._remove(this._first),o}}pop(){if(this._last!==E.Undefined){const o=this._last.element;return this._remove(this._last),o}}_remove(o){if(o.prev!==E.Undefined&&o.next!==E.Undefined){const m=o.prev;m.next=o.next,o.next.prev=m}else o.prev===E.Undefined&&o.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):o.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):o.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let o=this._first;for(;o!==E.Undefined;)yield o.element,o=o.next}}n.LinkedList=D}),X(J[18],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const E=globalThis.performance&&typeof globalThis.performance.now=="function";class D{static create(o){return new D(o)}constructor(o){this._now=E&&o===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}n.StopWatch=D}),X(J[7],Z([0,1,4,15,10,17,18]),function(O,n,E,D,i,o,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.createEventDeliveryQueue=n.Emitter=n.EventProfiling=n.Event=void 0;const w=!1,a=!1;var s;(function(C){C.None=()=>i.Disposable.None;function p(Q){if(a){const{onDidAddListener:$}=Q,Y=h.create();let j=0;Q.onDidAddListener=()=>{++j===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),$?.()}}}function R(Q,$){return T(Q,()=>{},0,void 0,!0,void 0,$)}C.defer=R;function y(Q){return($,Y=null,j)=>{let K=!1,te;return te=Q(re=>{if(!K)return te?te.dispose():K=!0,$.call(Y,re)},null,j),K&&te.dispose(),te}}C.once=y;function M(Q,$,Y){return z((j,K=null,te)=>Q(re=>j.call(K,$(re)),null,te),Y)}C.map=M;function F(Q,$,Y){return z((j,K=null,te)=>Q(re=>{$(re),j.call(K,re)},null,te),Y)}C.forEach=F;function I(Q,$,Y){return z((j,K=null,te)=>Q(re=>$(re)&&j.call(K,re),null,te),Y)}C.filter=I;function P(Q){return Q}C.signal=P;function U(...Q){return($,Y=null,j)=>(0,i.combinedDisposable)(...Q.map(K=>K(te=>$.call(Y,te),null,j)))}C.any=U;function W(Q,$,Y,j){let K=Y;return M(Q,te=>(K=$(K,te),K),j)}C.reduce=W;function z(Q,$){let Y;const j={onWillAddFirstListener(){Y=Q(K.fire,K)},onDidRemoveLastListener(){Y?.dispose()}};$||p(j);const K=new N(j);return $?.add(K),K.event}function T(Q,$,Y=100,j=!1,K=!1,te,re){let fe,ce,_e,k=0,B;const V={leakWarningThreshold:te,onWillAddFirstListener(){fe=Q(ee=>{k++,ce=$(ce,ee),j&&!_e&&(G.fire(ce),ce=void 0),B=()=>{const le=ce;ce=void 0,_e=void 0,(!j||k>1)&&G.fire(le),k=0},typeof Y=="number"?(clearTimeout(_e),_e=setTimeout(B,Y)):_e===void 0&&(_e=0,queueMicrotask(B))})},onWillRemoveListener(){K&&k>0&&B?.()},onDidRemoveLastListener(){B=void 0,fe.dispose()}};re||p(V);const G=new N(V);return re?.add(G),G.event}C.debounce=T;function x(Q,$=0,Y){return C.debounce(Q,(j,K)=>j?(j.push(K),j):[K],$,void 0,!0,void 0,Y)}C.accumulate=x;function q(Q,$=(j,K)=>j===K,Y){let j=!0,K;return I(Q,te=>{const re=j||!$(te,K);return j=!1,K=te,re},Y)}C.latch=q;function H(Q,$,Y){return[C.filter(Q,$,Y),C.filter(Q,j=>!$(j),Y)]}C.split=H;function t(Q,$=!1,Y=[]){let j=Y.slice(),K=Q(fe=>{j?j.push(fe):re.fire(fe)});const te=()=>{j?.forEach(fe=>re.fire(fe)),j=null},re=new N({onWillAddFirstListener(){K||(K=Q(fe=>re.fire(fe)))},onDidAddFirstListener(){j&&($?setTimeout(te):te())},onDidRemoveLastListener(){K&&K.dispose(),K=null}});return re.event}C.buffer=t;class ne{constructor($){this.event=$,this.disposables=new i.DisposableStore}map($){return new ne(M(this.event,$,this.disposables))}forEach($){return new ne(F(this.event,$,this.disposables))}filter($){return new ne(I(this.event,$,this.disposables))}reduce($,Y){return new ne(W(this.event,$,Y,this.disposables))}latch(){return new ne(q(this.event,void 0,this.disposables))}debounce($,Y=100,j=!1,K=!1,te){return new ne(T(this.event,$,Y,j,K,te,this.disposables))}on($,Y,j){return this.event($,Y,j)}once($,Y,j){return y(this.event)($,Y,j)}dispose(){this.disposables.dispose()}}function ie(Q){return new ne(Q)}C.chain=ie;function he(Q,$,Y=j=>j){const j=(...fe)=>re.fire(Y(...fe)),K=()=>Q.on($,j),te=()=>Q.removeListener($,j),re=new N({onWillAddFirstListener:K,onDidRemoveLastListener:te});return re.event}C.fromNodeEventEmitter=he;function me(Q,$,Y=j=>j){const j=(...fe)=>re.fire(Y(...fe)),K=()=>Q.addEventListener($,j),te=()=>Q.removeEventListener($,j),re=new N({onWillAddFirstListener:K,onDidRemoveLastListener:te});return re.event}C.fromDOMEventEmitter=me;function be(Q){return new Promise($=>y(Q)($))}C.toPromise=be;function pe(Q,$){return $(void 0),Q(Y=>$(Y))}C.runAndSubscribe=pe;function Le(Q,$){let Y=null;function j(te){Y?.dispose(),Y=new i.DisposableStore,$(te,Y)}j(void 0);const K=Q(te=>j(te));return(0,i.toDisposable)(()=>{K.dispose(),Y?.dispose()})}C.runAndSubscribeWithStore=Le;class Ce{constructor($,Y){this._observable=$,this._counter=0,this._hasChanged=!1;const j={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};Y||p(j),this.emitter=new N(j),Y&&Y.add(this.emitter)}beginUpdate($){this._counter++}handlePossibleChange($){}handleChange($,Y){this._hasChanged=!0}endUpdate($){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function se(Q,$){return new Ce(Q,$).emitter.event}C.fromObservable=se;function ae(Q){return $=>{let Y=0,j=!1;const K={beginUpdate(){Y++},endUpdate(){Y--,Y===0&&(Q.reportChanges(),j&&(j=!1,$()))},handlePossibleChange(){},handleChange(){j=!0}};return Q.addObserver(K),{dispose(){Q.removeObserver(K)}}}}C.fromObservableLight=ae})(s||(n.Event=s={}));class b{constructor(p){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${p}_${b._idPool++}`,b.all.add(this)}start(p){this._stopWatch=new m.StopWatch,this.listenerCount=p}stop(){if(this._stopWatch){const p=this._stopWatch.elapsed();this.durations.push(p),this.elapsedOverall+=p,this.invocationCount+=1,this._stopWatch=void 0}}}n.EventProfiling=b,b.all=new Set,b._idPool=0;let e=-1;class c{constructor(p,R=Math.random().toString(18).slice(2,5)){this.threshold=p,this.name=R,this._warnCountdown=0}dispose(){var p;(p=this._stacks)===null||p===void 0||p.clear()}check(p,R){const y=this.threshold;if(y<=0||R<y)return;this._stacks||(this._stacks=new Map);const M=this._stacks.get(p.value)||0;if(this._stacks.set(p.value,M+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=y*.5;let F,I=0;for(const[P,U]of this._stacks)(!F||I<U)&&(F=P,I=U);console.warn(`[${this.name}] potential listener LEAK detected, having ${R} listeners already. MOST frequent listener (${I}):`),console.warn(F)}return()=>{const F=this._stacks.get(p.value)||0;this._stacks.set(p.value,F-1)}}}class h{static create(){var p;return new h((p=new Error().stack)!==null&&p!==void 0?p:"")}constructor(p){this.value=p}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d{constructor(p){this.value=p}}const _=2,g=(C,p)=>{if(C instanceof d)p(C);else for(let R=0;R<C.length;R++){const y=C[R];y&&p(y)}};class N{constructor(p){var R,y,M,F,I;this._size=0,this._options=p,this._leakageMon=e>0||!((R=this._options)===null||R===void 0)&&R.leakWarningThreshold?new c((M=(y=this._options)===null||y===void 0?void 0:y.leakWarningThreshold)!==null&&M!==void 0?M:e):void 0,this._perfMon=!((F=this._options)===null||F===void 0)&&F._profName?new b(this._options._profName):void 0,this._deliveryQueue=(I=this._options)===null||I===void 0?void 0:I.deliveryQueue}dispose(){var p,R,y,M;if(!this._disposed){if(this._disposed=!0,((p=this._deliveryQueue)===null||p===void 0?void 0:p.current)===this&&this._deliveryQueue.reset(),this._listeners){if(w){const F=this._listeners;queueMicrotask(()=>{g(F,I=>{var P;return(P=I.stack)===null||P===void 0?void 0:P.print()})})}this._listeners=void 0,this._size=0}(y=(R=this._options)===null||R===void 0?void 0:R.onDidRemoveLastListener)===null||y===void 0||y.call(R),(M=this._leakageMon)===null||M===void 0||M.dispose()}}get event(){var p;return(p=this._event)!==null&&p!==void 0||(this._event=(R,y,M)=>{var F,I,P,U,W;if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;if(this._disposed)return i.Disposable.None;y&&(R=R.bind(y));const z=new d(R);let T,x;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(z.stack=h.create(),T=this._leakageMon.check(z.stack,this._size+1)),w&&(z.stack=x??h.create()),this._listeners?this._listeners instanceof d?((W=this._deliveryQueue)!==null&&W!==void 0||(this._deliveryQueue=new A),this._listeners=[this._listeners,z]):this._listeners.push(z):((I=(F=this._options)===null||F===void 0?void 0:F.onWillAddFirstListener)===null||I===void 0||I.call(F,this),this._listeners=z,(U=(P=this._options)===null||P===void 0?void 0:P.onDidAddFirstListener)===null||U===void 0||U.call(P,this)),this._size++;const q=(0,i.toDisposable)(()=>{T?.(),this._removeListener(z)});return M instanceof i.DisposableStore?M.add(q):Array.isArray(M)&&M.push(q),q}),this._event}_removeListener(p){var R,y,M,F;if((y=(R=this._options)===null||R===void 0?void 0:R.onWillRemoveListener)===null||y===void 0||y.call(R,this),!this._listeners)return;if(this._size===1){this._listeners=void 0,(F=(M=this._options)===null||M===void 0?void 0:M.onDidRemoveLastListener)===null||F===void 0||F.call(M,this),this._size=0;return}const I=this._listeners,P=I.indexOf(p);if(P===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,I[P]=void 0;const U=this._deliveryQueue.current===this;if(this._size*_<=I.length){let W=0;for(let z=0;z<I.length;z++)I[z]?I[W++]=I[z]:U&&(this._deliveryQueue.end--,W<this._deliveryQueue.i&&this._deliveryQueue.i--);I.length=W}}_deliver(p,R){var y;if(!p)return;const M=((y=this._options)===null||y===void 0?void 0:y.onListenerError)||E.onUnexpectedError;if(!M){p.value(R);return}try{p.value(R)}catch(F){M(F)}}_deliverQueue(p){const R=p.current._listeners;for(;p.i<p.end;)this._deliver(R[p.i++],p.value);p.reset()}fire(p){var R,y,M,F;if(!((R=this._deliveryQueue)===null||R===void 0)&&R.current&&(this._deliverQueue(this._deliveryQueue),(y=this._perfMon)===null||y===void 0||y.stop()),(M=this._perfMon)===null||M===void 0||M.start(this._size),this._listeners)if(this._listeners instanceof d)this._deliver(this._listeners,p);else{const I=this._deliveryQueue;I.enqueue(this,p,this._listeners.length),this._deliverQueue(I)}(F=this._perfMon)===null||F===void 0||F.stop()}hasListeners(){return this._size>0}}n.Emitter=N;const v=()=>new A;n.createEventDeliveryQueue=v;class A{constructor(){this.i=-1,this.end=0}enqueue(p,R,y){this.i=0,this.end=y,this.current=p,this.value=R}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class S extends N{constructor(p){super(p),this._isPaused=0,this._eventQueue=new o.LinkedList,this._mergeFn=p?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const p=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(p))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(p){this._size&&(this._isPaused!==0?this._eventQueue.push(p):super.fire(p))}}n.PauseableEmitter=S;class u extends S{constructor(p){var R;super(p),this._delay=(R=p.delay)!==null&&R!==void 0?R:100}fire(p){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(p)}}n.DebounceEmitter=u;class r extends N{constructor(p){super(p),this._queuedEvents=[],this._mergeFn=p?.merge}fire(p){this.hasListeners()&&(this._queuedEvents.push(p),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(R=>super.fire(R)),this._queuedEvents=[]}))}}n.MicrotaskEmitter=r;class l{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new N({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(p){const R={event:p,listener:null};this.events.push(R),this.hasListeners&&this.hook(R);const y=()=>{this.hasListeners&&this.unhook(R);const M=this.events.indexOf(R);this.events.splice(M,1)};return(0,i.toDisposable)((0,D.once)(y))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(p=>this.hook(p))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(p=>this.unhook(p))}hook(p){p.listener=p.event(R=>this.emitter.fire(R))}unhook(p){p.listener&&p.listener.dispose(),p.listener=null}dispose(){this.emitter.dispose()}}n.EventMultiplexer=l;class f{constructor(){this.buffers=[]}wrapEvent(p){return(R,y,M)=>p(F=>{const I=this.buffers[this.buffers.length-1];I?I.push(()=>R.call(y,F)):R.call(y,F)},void 0,M)}bufferEvents(p){const R=[];this.buffers.push(R);const y=p();return this.buffers.pop(),R.forEach(M=>M()),y}}n.EventBufferer=f;class L{constructor(){this.listening=!1,this.inputEvent=s.None,this.inputEventListener=i.Disposable.None,this.emitter=new N({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(p){this.inputEvent=p,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=p(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=L}),X(J[32],Z([0,1,7]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const D=Object.freeze(function(w,a){const s=setTimeout(w.bind(a),0);return{dispose(){clearTimeout(s)}}});var i;(function(w){function a(s){return s===w.None||s===w.Cancelled||s instanceof o?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}w.isCancellationToken=a,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(i||(n.CancellationToken=i={}));class o{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?D:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class m{constructor(a){this._token=void 0,this._parentListener=void 0,this._parentListener=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new o),this._token}cancel(){this._token?this._token instanceof o&&this._token.cancel():this._token=i.Cancelled}dispose(a=!1){var s;a&&this.cancel(),(s=this._parentListener)===null||s===void 0||s.dispose(),this._token?this._token instanceof o&&this._token.dispose():this._token=i.None}}n.CancellationTokenSource=m}),X(J[5],Z([0,1,27,31]),function(O,n,E,D){"use strict";var i;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.singleLetterHash=n.containsUppercaseCharacter=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsRTL=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.GraphemeIterator=n.CodePointIterator=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.isAsciiDigit=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpFlags=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.escapeRegExpCharacters=n.escape=n.format=n.isFalsyOrWhitespace=void 0;function o(k){return!k||typeof k!="string"?!0:k.trim().length===0}n.isFalsyOrWhitespace=o;const m=/{(\d+)}/g;function w(k,...B){return B.length===0?k:k.replace(m,function(V,G){const ee=parseInt(G,10);return isNaN(ee)||ee<0||ee>=B.length?V:B[ee]})}n.format=w;function a(k){return k.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}n.escape=a;function s(k){return k.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=s;function b(k,B=" "){const V=e(k,B);return c(V,B)}n.trim=b;function e(k,B){if(!k||!B)return k;const V=B.length;if(V===0||k.length===0)return k;let G=0;for(;k.indexOf(B,G)===G;)G=G+V;return k.substring(G)}n.ltrim=e;function c(k,B){if(!k||!B)return k;const V=B.length,G=k.length;if(V===0||G===0)return k;let ee=G,le=-1;for(;le=k.lastIndexOf(B,ee-1),!(le===-1||le+V!==ee);){if(le===0)return"";ee=le}return k.substring(0,ee)}n.rtrim=c;function h(k){return k.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=h;function d(k){return k.replace(/\*/g,"")}n.stripWildcards=d;function _(k,B,V={}){if(!k)throw new Error("Cannot create regex from empty string");B||(k=s(k)),V.wholeWord&&(/\B/.test(k.charAt(0))||(k="\\b"+k),/\B/.test(k.charAt(k.length-1))||(k=k+"\\b"));let G="";return V.global&&(G+="g"),V.matchCase||(G+="i"),V.multiline&&(G+="m"),V.unicode&&(G+="u"),new RegExp(k,G)}n.createRegExp=_;function g(k){return k.source==="^"||k.source==="^$"||k.source==="$"||k.source==="^\\s*$"?!1:!!(k.exec("")&&k.lastIndex===0)}n.regExpLeadsToEndlessLoop=g;function N(k){return(k.global?"g":"")+(k.ignoreCase?"i":"")+(k.multiline?"m":"")+(k.unicode?"u":"")}n.regExpFlags=N;function v(k){return k.split(/\r\n|\r|\n/)}n.splitLines=v;function A(k){for(let B=0,V=k.length;B<V;B++){const G=k.charCodeAt(B);if(G!==32&&G!==9)return B}return-1}n.firstNonWhitespaceIndex=A;function S(k,B=0,V=k.length){for(let G=B;G<V;G++){const ee=k.charCodeAt(G);if(ee!==32&&ee!==9)return k.substring(B,G)}return k.substring(B,V)}n.getLeadingWhitespace=S;function u(k,B=k.length-1){for(let V=B;V>=0;V--){const G=k.charCodeAt(V);if(G!==32&&G!==9)return V}return-1}n.lastNonWhitespaceIndex=u;function r(k,B){return k<B?-1:k>B?1:0}n.compare=r;function l(k,B,V=0,G=k.length,ee=0,le=B.length){for(;V<G&&ee<le;V++,ee++){const we=k.charCodeAt(V),oe=B.charCodeAt(ee);if(we<oe)return-1;if(we>oe)return 1}const de=G-V,ye=le-ee;return de<ye?-1:de>ye?1:0}n.compareSubstring=l;function f(k,B){return L(k,B,0,k.length,0,B.length)}n.compareIgnoreCase=f;function L(k,B,V=0,G=k.length,ee=0,le=B.length){for(;V<G&&ee<le;V++,ee++){let we=k.charCodeAt(V),oe=B.charCodeAt(ee);if(we===oe)continue;if(we>=128||oe>=128)return l(k.toLowerCase(),B.toLowerCase(),V,G,ee,le);p(we)&&(we-=32),p(oe)&&(oe-=32);const ve=we-oe;if(ve!==0)return ve}const de=G-V,ye=le-ee;return de<ye?-1:de>ye?1:0}n.compareSubstringIgnoreCase=L;function C(k){return k>=48&&k<=57}n.isAsciiDigit=C;function p(k){return k>=97&&k<=122}n.isLowerAsciiLetter=p;function R(k){return k>=65&&k<=90}n.isUpperAsciiLetter=R;function y(k,B){return k.length===B.length&&L(k,B)===0}n.equalsIgnoreCase=y;function M(k,B){const V=B.length;return B.length>k.length?!1:L(k,B,0,V)===0}n.startsWithIgnoreCase=M;function F(k,B){const V=Math.min(k.length,B.length);let G;for(G=0;G<V;G++)if(k.charCodeAt(G)!==B.charCodeAt(G))return G;return V}n.commonPrefixLength=F;function I(k,B){const V=Math.min(k.length,B.length);let G;const ee=k.length-1,le=B.length-1;for(G=0;G<V;G++)if(k.charCodeAt(ee-G)!==B.charCodeAt(le-G))return G;return V}n.commonSuffixLength=I;function P(k){return 55296<=k&&k<=56319}n.isHighSurrogate=P;function U(k){return 56320<=k&&k<=57343}n.isLowSurrogate=U;function W(k,B){return(k-55296<<10)+(B-56320)+65536}n.computeCodePoint=W;function z(k,B,V){const G=k.charCodeAt(V);if(P(G)&&V+1<B){const ee=k.charCodeAt(V+1);if(U(ee))return W(G,ee)}return G}n.getNextCodePoint=z;function T(k,B){const V=k.charCodeAt(B-1);if(U(V)&&B>1){const G=k.charCodeAt(B-2);if(P(G))return W(G,V)}return V}class x{get offset(){return this._offset}constructor(B,V=0){this._str=B,this._len=B.length,this._offset=V}setOffset(B){this._offset=B}prevCodePoint(){const B=T(this._str,this._offset);return this._offset-=B>=65536?2:1,B}nextCodePoint(){const B=z(this._str,this._len,this._offset);return this._offset+=B>=65536?2:1,B}eol(){return this._offset>=this._len}}n.CodePointIterator=x;class q{get offset(){return this._iterator.offset}constructor(B,V=0){this._iterator=new x(B,V)}nextGraphemeLength(){const B=j.getInstance(),V=this._iterator,G=V.offset;let ee=B.getGraphemeBreakType(V.nextCodePoint());for(;!V.eol();){const le=V.offset,de=B.getGraphemeBreakType(V.nextCodePoint());if(Y(ee,de)){V.setOffset(le);break}ee=de}return V.offset-G}prevGraphemeLength(){const B=j.getInstance(),V=this._iterator,G=V.offset;let ee=B.getGraphemeBreakType(V.prevCodePoint());for(;V.offset>0;){const le=V.offset,de=B.getGraphemeBreakType(V.prevCodePoint());if(Y(de,ee)){V.setOffset(le);break}ee=de}return G-V.offset}eol(){return this._iterator.eol()}}n.GraphemeIterator=q;function H(k,B){return new q(k,B).nextGraphemeLength()}n.nextCharLength=H;function t(k,B){return new q(k,B).prevGraphemeLength()}n.prevCharLength=t;function ne(k,B){B>0&&U(k.charCodeAt(B))&&B--;const V=B+H(k,B);return[V-t(k,V),V]}n.getCharContainingOffset=ne;let ie;function he(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function me(k){return ie||(ie=he()),ie.test(k)}n.containsRTL=me;const be=/^[\t\n\r\x20-\x7E]*$/;function pe(k){return be.test(k)}n.isBasicASCII=pe,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Le(k){return n.UNUSUAL_LINE_TERMINATORS.test(k)}n.containsUnusualLineTerminators=Le;function Ce(k){return k>=11904&&k<=55215||k>=63744&&k<=64255||k>=65281&&k<=65374}n.isFullWidthCharacter=Ce;function se(k){return k>=127462&&k<=127487||k===8986||k===8987||k===9200||k===9203||k>=9728&&k<=10175||k===11088||k===11093||k>=127744&&k<=128591||k>=128640&&k<=128764||k>=128992&&k<=129008||k>=129280&&k<=129535||k>=129648&&k<=129782}n.isEmojiImprecise=se,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ae(k){return!!(k&&k.length>0&&k.charCodeAt(0)===65279)}n.startsWithUTF8BOM=ae;function Q(k,B=!1){return k?(B&&(k=k.replace(/\\./g,"")),k.toLowerCase()!==k):!1}n.containsUppercaseCharacter=Q;function $(k){return k=k%(2*26),k<26?String.fromCharCode(97+k):String.fromCharCode(65+k-26)}n.singleLetterHash=$;function Y(k,B){return k===0?B!==5&&B!==7:k===2&&B===3?!1:k===4||k===2||k===3||B===4||B===2||B===3?!0:!(k===8&&(B===8||B===9||B===11||B===12)||(k===11||k===9)&&(B===9||B===10)||(k===12||k===10)&&B===10||B===5||B===13||B===7||k===1||k===13&&B===14||k===6&&B===6)}class j{static getInstance(){return j._INSTANCE||(j._INSTANCE=new j),j._INSTANCE}constructor(){this._data=K()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const V=this._data,G=V.length/3;let ee=1;for(;ee<=G;)if(B<V[3*ee])ee=2*ee;else if(B>V[3*ee+1])ee=2*ee+1;else return V[3*ee+2];return 0}}j._INSTANCE=null;function K(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function te(k,B){if(k===0)return 0;const V=re(k,B);if(V!==void 0)return V;const G=new x(B,k);return G.prevCodePoint(),G.offset}n.getLeftDeleteOffset=te;function re(k,B){const V=new x(B,k);let G=V.prevCodePoint();for(;fe(G)||G===65039||G===8419;){if(V.offset===0)return;G=V.prevCodePoint()}if(!se(G))return;let ee=V.offset;return ee>0&&V.prevCodePoint()===8205&&(ee=V.offset),ee}function fe(k){return 127995<=k&&k<=127999}n.noBreakWhitespace="\xA0";class ce{static getInstance(B){return ce.cache.get(Array.from(B))}static getLocales(){return ce._locales.value}constructor(B){this.confusableDictionary=B}isAmbiguous(B){return this.confusableDictionary.has(B)}getPrimaryConfusable(B){return this.confusableDictionary.get(B)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}n.AmbiguousCharacters=ce,i=ce,ce.ambiguousCharacterData=new D.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ce.cache=new E.LRUCachedFunction(k=>{function B(oe){const ve=new Map;for(let Se=0;Se<oe.length;Se+=2)ve.set(oe[Se],oe[Se+1]);return ve}function V(oe,ve){const Se=new Map(oe);for(const[Ne,Ae]of ve)Se.set(Ne,Ae);return Se}function G(oe,ve){if(!oe)return ve;const Se=new Map;for(const[Ne,Ae]of oe)ve.has(Ne)&&Se.set(Ne,Ae);return Se}const ee=i.ambiguousCharacterData.value;let le=k.filter(oe=>!oe.startsWith("_")&&oe in ee);le.length===0&&(le=["_default"]);let de;for(const oe of le){const ve=B(ee[oe]);de=G(de,ve)}const ye=B(ee._common),we=V(ye,de);return new ce(we)}),ce._locales=new D.Lazy(()=>Object.keys(ce.ambiguousCharacterData.value).filter(k=>!k.startsWith("_")));class _e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(_e.getRawData())),this._data}static isInvisibleCharacter(B){return _e.getData().has(B)}static get codePoints(){return _e.getData()}}n.InvisibleCharacters=_e,_e._data=void 0}),X(J[33],Z([0,1,5]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function D(_){return i(_,0)}n.hash=D;function i(_,g){switch(typeof _){case"object":return _===null?o(349,g):Array.isArray(_)?a(_,g):s(_,g);case"string":return w(_,g);case"boolean":return m(_,g);case"number":return o(_,g);case"undefined":return o(937,g);default:return o(617,g)}}n.doHash=i;function o(_,g){return(g<<5)-g+_|0}n.numberHash=o;function m(_,g){return o(_?433:863,g)}function w(_,g){g=o(149417,g);for(let N=0,v=_.length;N<v;N++)g=o(_.charCodeAt(N),g);return g}n.stringHash=w;function a(_,g){return g=o(104579,g),_.reduce((N,v)=>i(v,N),g)}function s(_,g){return g=o(181387,g),Object.keys(_).sort().reduce((N,v)=>(N=w(v,N),i(_[v],N)),g)}function b(_,g,N=32){const v=N-g,A=~((1<<v)-1);return(_<<g|(A&_)>>>v)>>>0}function e(_,g=0,N=_.byteLength,v=0){for(let A=0;A<N;A++)_[g+A]=v}function c(_,g,N="0"){for(;_.length<g;)_=N+_;return _}function h(_,g=32){return _ instanceof ArrayBuffer?Array.from(new Uint8Array(_)).map(N=>N.toString(16).padStart(2,"0")).join(""):c((_>>>0).toString(16),g/4)}n.toHexString=h;class d{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const N=g.length;if(N===0)return;const v=this._buff;let A=this._buffLen,S=this._leftoverHighSurrogate,u,r;for(S!==0?(u=S,r=-1,S=0):(u=g.charCodeAt(0),r=0);;){let l=u;if(E.isHighSurrogate(u))if(r+1<N){const f=g.charCodeAt(r+1);E.isLowSurrogate(f)?(r++,l=E.computeCodePoint(u,f)):l=65533}else{S=u;break}else E.isLowSurrogate(u)&&(l=65533);if(A=this._push(v,A,l),r++,r<N)u=g.charCodeAt(r);else break}this._buffLen=A,this._leftoverHighSurrogate=S}_push(g,N,v){return v<128?g[N++]=v:v<2048?(g[N++]=192|(v&1984)>>>6,g[N++]=128|(v&63)>>>0):v<65536?(g[N++]=224|(v&61440)>>>12,g[N++]=128|(v&4032)>>>6,g[N++]=128|(v&63)>>>0):(g[N++]=240|(v&1835008)>>>18,g[N++]=128|(v&258048)>>>12,g[N++]=128|(v&4032)>>>6,g[N++]=128|(v&63)>>>0),N>=64&&(this._step(),N-=64,this._totalLen+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),N}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,e(this._buff,this._buffLen),this._buffLen>56&&(this._step(),e(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=d._bigBlock32,N=this._buffDV;for(let C=0;C<64;C+=4)g.setUint32(C,N.getUint32(C,!1),!1);for(let C=64;C<320;C+=4)g.setUint32(C,b(g.getUint32(C-12,!1)^g.getUint32(C-32,!1)^g.getUint32(C-56,!1)^g.getUint32(C-64,!1),1),!1);let v=this._h0,A=this._h1,S=this._h2,u=this._h3,r=this._h4,l,f,L;for(let C=0;C<80;C++)C<20?(l=A&S|~A&u,f=1518500249):C<40?(l=A^S^u,f=1859775393):C<60?(l=A&S|A&u|S&u,f=2400959708):(l=A^S^u,f=3395469782),L=b(v,5)+l+r+f+g.getUint32(C*4,!1)&4294967295,r=u,u=S,S=b(A,30),A=v,v=L;this._h0=this._h0+v&4294967295,this._h1=this._h1+A&4294967295,this._h2=this._h2+S&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+r&4294967295}}n.StringSHA1=d,d._bigBlock32=new DataView(new ArrayBuffer(320))}),X(J[19],Z([0,1,29,33]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.stringDiff=n.StringDiffSequence=void 0;class i{constructor(e){this.source=e}getElements(){const e=this.source,c=new Int32Array(e.length);for(let h=0,d=e.length;h<d;h++)c[h]=e.charCodeAt(h);return c}}n.StringDiffSequence=i;function o(b,e,c){return new s(new i(b),new i(e)).ComputeDiff(c).changes}n.stringDiff=o;class m{static Assert(e,c){if(!e)throw new Error(c)}}class w{static Copy(e,c,h,d,_){for(let g=0;g<_;g++)h[d+g]=e[c+g]}static Copy2(e,c,h,d,_){for(let g=0;g<_;g++)h[d+g]=e[c+g]}}class a{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new E.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(e,c){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,c),this.m_originalCount++}AddModifiedElement(e,c){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,c),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class s{constructor(e,c,h=null){this.ContinueProcessingPredicate=h,this._originalSequence=e,this._modifiedSequence=c;const[d,_,g]=s._getElements(e),[N,v,A]=s._getElements(c);this._hasStrings=g&&A,this._originalStringElements=d,this._originalElementsOrHash=_,this._modifiedStringElements=N,this._modifiedElementsOrHash=v,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(e){return e.length>0&&typeof e[0]=="string"}static _getElements(e){const c=e.getElements();if(s._isStringArray(c)){const h=new Int32Array(c.length);for(let d=0,_=c.length;d<_;d++)h[d]=(0,D.stringHash)(c[d],0);return[c,h,!0]}return c instanceof Int32Array?[[],c,!1]:[[],new Int32Array(c),!1]}ElementsAreEqual(e,c){return this._originalElementsOrHash[e]!==this._modifiedElementsOrHash[c]?!1:this._hasStrings?this._originalStringElements[e]===this._modifiedStringElements[c]:!0}ElementsAreStrictEqual(e,c){if(!this.ElementsAreEqual(e,c))return!1;const h=s._getStrictElement(this._originalSequence,e),d=s._getStrictElement(this._modifiedSequence,c);return h===d}static _getStrictElement(e,c){return typeof e.getStrictElement=="function"?e.getStrictElement(c):null}OriginalElementsAreEqual(e,c){return this._originalElementsOrHash[e]!==this._originalElementsOrHash[c]?!1:this._hasStrings?this._originalStringElements[e]===this._originalStringElements[c]:!0}ModifiedElementsAreEqual(e,c){return this._modifiedElementsOrHash[e]!==this._modifiedElementsOrHash[c]?!1:this._hasStrings?this._modifiedStringElements[e]===this._modifiedStringElements[c]:!0}ComputeDiff(e){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,e)}_ComputeDiff(e,c,h,d,_){const g=[!1];let N=this.ComputeDiffRecursive(e,c,h,d,g);return _&&(N=this.PrettifyChanges(N)),{quitEarly:g[0],changes:N}}ComputeDiffRecursive(e,c,h,d,_){for(_[0]=!1;e<=c&&h<=d&&this.ElementsAreEqual(e,h);)e++,h++;for(;c>=e&&d>=h&&this.ElementsAreEqual(c,d);)c--,d--;if(e>c||h>d){let u;return h<=d?(m.Assert(e===c+1,"originalStart should only be one more than originalEnd"),u=[new E.DiffChange(e,0,h,d-h+1)]):e<=c?(m.Assert(h===d+1,"modifiedStart should only be one more than modifiedEnd"),u=[new E.DiffChange(e,c-e+1,h,0)]):(m.Assert(e===c+1,"originalStart should only be one more than originalEnd"),m.Assert(h===d+1,"modifiedStart should only be one more than modifiedEnd"),u=[]),u}const g=[0],N=[0],v=this.ComputeRecursionPoint(e,c,h,d,g,N,_),A=g[0],S=N[0];if(v!==null)return v;if(!_[0]){const u=this.ComputeDiffRecursive(e,A,h,S,_);let r=[];return _[0]?r=[new E.DiffChange(A+1,c-(A+1)+1,S+1,d-(S+1)+1)]:r=this.ComputeDiffRecursive(A+1,c,S+1,d,_),this.ConcatenateChanges(u,r)}return[new E.DiffChange(e,c-e+1,h,d-h+1)]}WALKTRACE(e,c,h,d,_,g,N,v,A,S,u,r,l,f,L,C,p,R){let y=null,M=null,F=new a,I=c,P=h,U=l[0]-C[0]-d,W=-1073741824,z=this.m_forwardHistory.length-1;do{const T=U+e;T===I||T<P&&A[T-1]<A[T+1]?(u=A[T+1],f=u-U-d,u<W&&F.MarkNextChange(),W=u,F.AddModifiedElement(u+1,f),U=T+1-e):(u=A[T-1]+1,f=u-U-d,u<W&&F.MarkNextChange(),W=u-1,F.AddOriginalElement(u,f+1),U=T-1-e),z>=0&&(A=this.m_forwardHistory[z],e=A[0],I=1,P=A.length-1)}while(--z>=-1);if(y=F.getReverseChanges(),R[0]){let T=l[0]+1,x=C[0]+1;if(y!==null&&y.length>0){const q=y[y.length-1];T=Math.max(T,q.getOriginalEnd()),x=Math.max(x,q.getModifiedEnd())}M=[new E.DiffChange(T,r-T+1,x,L-x+1)]}else{F=new a,I=g,P=N,U=l[0]-C[0]-v,W=1073741824,z=p?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const T=U+_;T===I||T<P&&S[T-1]>=S[T+1]?(u=S[T+1]-1,f=u-U-v,u>W&&F.MarkNextChange(),W=u+1,F.AddOriginalElement(u+1,f+1),U=T+1-_):(u=S[T-1],f=u-U-v,u>W&&F.MarkNextChange(),W=u,F.AddModifiedElement(u+1,f+1),U=T-1-_),z>=0&&(S=this.m_reverseHistory[z],_=S[0],I=1,P=S.length-1)}while(--z>=-1);M=F.getChanges()}return this.ConcatenateChanges(y,M)}ComputeRecursionPoint(e,c,h,d,_,g,N){let v=0,A=0,S=0,u=0,r=0,l=0;e--,h--,_[0]=0,g[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const f=c-e+(d-h),L=f+1,C=new Int32Array(L),p=new Int32Array(L),R=d-h,y=c-e,M=e-h,F=c-d,P=(y-R)%2===0;C[R]=e,p[y]=c,N[0]=!1;for(let U=1;U<=f/2+1;U++){let W=0,z=0;S=this.ClipDiagonalBound(R-U,U,R,L),u=this.ClipDiagonalBound(R+U,U,R,L);for(let x=S;x<=u;x+=2){x===S||x<u&&C[x-1]<C[x+1]?v=C[x+1]:v=C[x-1]+1,A=v-(x-R)-M;const q=v;for(;v<c&&A<d&&this.ElementsAreEqual(v+1,A+1);)v++,A++;if(C[x]=v,v+A>W+z&&(W=v,z=A),!P&&Math.abs(x-y)<=U-1&&v>=p[x])return _[0]=v,g[0]=A,q<=p[x]&&1447>0&&U<=1447+1?this.WALKTRACE(R,S,u,M,y,r,l,F,C,p,v,c,_,A,d,g,P,N):null}const T=(W-e+(z-h)-U)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(W,T))return N[0]=!0,_[0]=W,g[0]=z,T>0&&1447>0&&U<=1447+1?this.WALKTRACE(R,S,u,M,y,r,l,F,C,p,v,c,_,A,d,g,P,N):(e++,h++,[new E.DiffChange(e,c-e+1,h,d-h+1)]);r=this.ClipDiagonalBound(y-U,U,y,L),l=this.ClipDiagonalBound(y+U,U,y,L);for(let x=r;x<=l;x+=2){x===r||x<l&&p[x-1]>=p[x+1]?v=p[x+1]-1:v=p[x-1],A=v-(x-y)-F;const q=v;for(;v>e&&A>h&&this.ElementsAreEqual(v,A);)v--,A--;if(p[x]=v,P&&Math.abs(x-R)<=U&&v<=C[x])return _[0]=v,g[0]=A,q>=C[x]&&1447>0&&U<=1447+1?this.WALKTRACE(R,S,u,M,y,r,l,F,C,p,v,c,_,A,d,g,P,N):null}if(U<=1447){let x=new Int32Array(u-S+2);x[0]=R-S+1,w.Copy2(C,S,x,1,u-S+1),this.m_forwardHistory.push(x),x=new Int32Array(l-r+2),x[0]=y-r+1,w.Copy2(p,r,x,1,l-r+1),this.m_reverseHistory.push(x)}}return this.WALKTRACE(R,S,u,M,y,r,l,F,C,p,v,c,_,A,d,g,P,N)}PrettifyChanges(e){for(let c=0;c<e.length;c++){const h=e[c],d=c<e.length-1?e[c+1].originalStart:this._originalElementsOrHash.length,_=c<e.length-1?e[c+1].modifiedStart:this._modifiedElementsOrHash.length,g=h.originalLength>0,N=h.modifiedLength>0;for(;h.originalStart+h.originalLength<d&&h.modifiedStart+h.modifiedLength<_&&(!g||this.OriginalElementsAreEqual(h.originalStart,h.originalStart+h.originalLength))&&(!N||this.ModifiedElementsAreEqual(h.modifiedStart,h.modifiedStart+h.modifiedLength));){const A=this.ElementsAreStrictEqual(h.originalStart,h.modifiedStart);if(this.ElementsAreStrictEqual(h.originalStart+h.originalLength,h.modifiedStart+h.modifiedLength)&&!A)break;h.originalStart++,h.modifiedStart++}const v=[null];if(c<e.length-1&&this.ChangesOverlap(e[c],e[c+1],v)){e[c]=v[0],e.splice(c+1,1),c--;continue}}for(let c=e.length-1;c>=0;c--){const h=e[c];let d=0,_=0;if(c>0){const u=e[c-1];d=u.originalStart+u.originalLength,_=u.modifiedStart+u.modifiedLength}const g=h.originalLength>0,N=h.modifiedLength>0;let v=0,A=this._boundaryScore(h.originalStart,h.originalLength,h.modifiedStart,h.modifiedLength);for(let u=1;;u++){const r=h.originalStart-u,l=h.modifiedStart-u;if(r<d||l<_||g&&!this.OriginalElementsAreEqual(r,r+h.originalLength)||N&&!this.ModifiedElementsAreEqual(l,l+h.modifiedLength))break;const L=(r===d&&l===_?5:0)+this._boundaryScore(r,h.originalLength,l,h.modifiedLength);L>A&&(A=L,v=u)}h.originalStart-=v,h.modifiedStart-=v;const S=[null];if(c>0&&this.ChangesOverlap(e[c-1],e[c],S)){e[c-1]=S[0],e.splice(c,1),c++;continue}}if(this._hasStrings)for(let c=1,h=e.length;c<h;c++){const d=e[c-1],_=e[c],g=_.originalStart-d.originalStart-d.originalLength,N=d.originalStart,v=_.originalStart+_.originalLength,A=v-N,S=d.modifiedStart,u=_.modifiedStart+_.modifiedLength,r=u-S;if(g<5&&A<20&&r<20){const l=this._findBetterContiguousSequence(N,A,S,r,g);if(l){const[f,L]=l;(f!==d.originalStart+d.originalLength||L!==d.modifiedStart+d.modifiedLength)&&(d.originalLength=f-d.originalStart,d.modifiedLength=L-d.modifiedStart,_.originalStart=f+g,_.modifiedStart=L+g,_.originalLength=v-_.originalStart,_.modifiedLength=u-_.modifiedStart)}}}return e}_findBetterContiguousSequence(e,c,h,d,_){if(c<_||d<_)return null;const g=e+c-_+1,N=h+d-_+1;let v=0,A=0,S=0;for(let u=e;u<g;u++)for(let r=h;r<N;r++){const l=this._contiguousSequenceScore(u,r,_);l>0&&l>v&&(v=l,A=u,S=r)}return v>0?[A,S]:null}_contiguousSequenceScore(e,c,h){let d=0;for(let _=0;_<h;_++){if(!this.ElementsAreEqual(e+_,c+_))return 0;d+=this._originalStringElements[e+_].length}return d}_OriginalIsBoundary(e){return e<=0||e>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[e])}_OriginalRegionIsBoundary(e,c){if(this._OriginalIsBoundary(e)||this._OriginalIsBoundary(e-1))return!0;if(c>0){const h=e+c;if(this._OriginalIsBoundary(h-1)||this._OriginalIsBoundary(h))return!0}return!1}_ModifiedIsBoundary(e){return e<=0||e>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[e])}_ModifiedRegionIsBoundary(e,c){if(this._ModifiedIsBoundary(e)||this._ModifiedIsBoundary(e-1))return!0;if(c>0){const h=e+c;if(this._ModifiedIsBoundary(h-1)||this._ModifiedIsBoundary(h))return!0}return!1}_boundaryScore(e,c,h,d){const _=this._OriginalRegionIsBoundary(e,c)?1:0,g=this._ModifiedRegionIsBoundary(h,d)?1:0;return _+g}ConcatenateChanges(e,c){const h=[];if(e.length===0||c.length===0)return c.length>0?c:e;if(this.ChangesOverlap(e[e.length-1],c[0],h)){const d=new Array(e.length+c.length-1);return w.Copy(e,0,d,0,e.length-1),d[e.length-1]=h[0],w.Copy(c,1,d,e.length,c.length-1),d}else{const d=new Array(e.length+c.length);return w.Copy(e,0,d,0,e.length),w.Copy(c,0,d,e.length,c.length),d}}ChangesOverlap(e,c,h){if(m.Assert(e.originalStart<=c.originalStart,"Left change is not less than or equal to right change"),m.Assert(e.modifiedStart<=c.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=c.originalStart||e.modifiedStart+e.modifiedLength>=c.modifiedStart){const d=e.originalStart;let _=e.originalLength;const g=e.modifiedStart;let N=e.modifiedLength;return e.originalStart+e.originalLength>=c.originalStart&&(_=c.originalStart+c.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=c.modifiedStart&&(N=c.modifiedStart+c.modifiedLength-e.modifiedStart),h[0]=new E.DiffChange(d,_,g,N),!0}else return h[0]=null,!1}ClipDiagonalBound(e,c,h,d){if(e>=0&&e<d)return e;const _=h,g=d-h-1,N=c%2===0;if(e<0){const v=_%2===0;return N===v?0:1}else{const v=g%2===0;return N===v?d-1:d-2}}}n.LcsDiff=s}),X(J[20],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.withUndefinedAsNull=n.withNullAsUndefined=n.validateConstraint=n.validateConstraints=n.isFunction=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isTypedArray=n.isObject=n.isString=void 0;function E(v){return typeof v=="string"}n.isString=E;function D(v){return typeof v=="object"&&v!==null&&!Array.isArray(v)&&!(v instanceof RegExp)&&!(v instanceof Date)}n.isObject=D;function i(v){const A=Object.getPrototypeOf(Uint8Array);return typeof v=="object"&&v instanceof A}n.isTypedArray=i;function o(v){return typeof v=="number"&&!isNaN(v)}n.isNumber=o;function m(v){return!!v&&typeof v[Symbol.iterator]=="function"}n.isIterable=m;function w(v){return v===!0||v===!1}n.isBoolean=w;function a(v){return typeof v>"u"}n.isUndefined=a;function s(v){return!b(v)}n.isDefined=s;function b(v){return a(v)||v===null}n.isUndefinedOrNull=b;function e(v,A){if(!v)throw new Error(A?`Unexpected type, expected '${A}'`:"Unexpected type")}n.assertType=e;function c(v){if(b(v))throw new Error("Assertion Failed: argument is undefined or null");return v}n.assertIsDefined=c;function h(v){return typeof v=="function"}n.isFunction=h;function d(v,A){const S=Math.min(v.length,A.length);for(let u=0;u<S;u++)_(v[u],A[u])}n.validateConstraints=d;function _(v,A){if(E(A)){if(typeof v!==A)throw new Error(`argument does not match constraint: typeof ${A}`)}else if(h(A)){try{if(v instanceof A)return}catch{}if(!b(v)&&v.constructor===A||A.length===1&&A.call(void 0,v)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=_;function g(v){return v===null?void 0:v}n.withNullAsUndefined=g;function N(v){return typeof v>"u"?null:v}n.withUndefinedAsNull=N}),X(J[34],Z([0,1,20]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Codicon=n.getCodiconFontCharacters=void 0;const D=Object.create(null);function i(m,w){if((0,E.isString)(w)){const a=D[w];if(a===void 0)throw new Error(`${m} references an unknown codicon: ${w}`);w=a}return D[m]=w,{id:m}}function o(){return D}n.getCodiconFontCharacters=o,n.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),X(J[11],Z([0,1,20]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function D(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const d=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([_,g])=>{d[_]=g&&typeof g=="object"?D(g):g}),d}n.deepClone=D;function i(h){if(!h||typeof h!="object")return h;const d=[h];for(;d.length>0;){const _=d.shift();Object.freeze(_);for(const g in _)if(o.call(_,g)){const N=_[g];typeof N=="object"&&!Object.isFrozen(N)&&!(0,E.isTypedArray)(N)&&d.push(N)}}return h}n.deepFreeze=i;const o=Object.prototype.hasOwnProperty;function m(h,d){return w(h,d,new Set)}n.cloneAndChange=m;function w(h,d,_){if((0,E.isUndefinedOrNull)(h))return h;const g=d(h);if(typeof g<"u")return g;if(Array.isArray(h)){const N=[];for(const v of h)N.push(w(v,d,_));return N}if((0,E.isObject)(h)){if(_.has(h))throw new Error("Cannot clone recursive data-structure");_.add(h);const N={};for(const v in h)o.call(h,v)&&(N[v]=w(h[v],d,_));return _.delete(h),N}return h}function a(h,d,_=!0){return(0,E.isObject)(h)?((0,E.isObject)(d)&&Object.keys(d).forEach(g=>{g in h?_&&((0,E.isObject)(h[g])&&(0,E.isObject)(d[g])?a(h[g],d[g],_):h[g]=d[g]):h[g]=d[g]}),h):d}n.mixin=a;function s(h,d){if(h===d)return!0;if(h==null||d===null||d===void 0||typeof h!=typeof d||typeof h!="object"||Array.isArray(h)!==Array.isArray(d))return!1;let _,g;if(Array.isArray(h)){if(h.length!==d.length)return!1;for(_=0;_<h.length;_++)if(!s(h[_],d[_]))return!1}else{const N=[];for(g in h)N.push(g);N.sort();const v=[];for(g in d)v.push(g);if(v.sort(),!s(N,v))return!1;for(_=0;_<N.length;_++)if(!s(h[N[_]],d[N[_]]))return!1}return!0}n.equals=s;function b(h){let d=[],_=Object.getPrototypeOf(h);for(;Object.prototype!==_;)d=d.concat(Object.getOwnPropertyNames(_)),_=Object.getPrototypeOf(_);return d}n.getAllPropertyNames=b;function e(h){const d=[];for(const _ of b(h))typeof h[_]=="function"&&d.push(_);return d}n.getAllMethodNames=e;function c(h,d){const _=N=>function(){const v=Array.prototype.slice.call(arguments,0);return d(N,v)},g={};for(const N of h)g[N]=_(N);return g}n.createProxyObject=c}),X(J[21],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=void 0;function E(i){return i<0?0:i>255?255:i|0}n.toUint8=E;function D(i){return i<0?0:i>4294967295?4294967295:i|0}n.toUint32=D}),X(J[22],Z([0,1,21]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class D{constructor(m){const w=(0,E.toUint8)(m);this._defaultValue=w,this._asciiMap=D._createAsciiMap(w),this._map=new Map}static _createAsciiMap(m){const w=new Uint8Array(256);return w.fill(m),w}set(m,w){const a=(0,E.toUint8)(w);m>=0&&m<256?this._asciiMap[m]=a:this._map.set(m,a)}get(m){return m>=0&&m<256?this._asciiMap[m]:this._map.get(m)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}n.CharacterClassifier=D;class i{constructor(){this._actual=new D(0)}add(m){this._actual.set(m,1)}has(m){return this._actual.get(m)===1}clear(){return this._actual.clear()}}n.CharacterSet=i}),X(J[6],Z([0,1,4]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.OffsetRange=void 0;class D{static addRange(o,m){let w=0;for(;w<m.length&&m[w].endExclusive<o.start;)w++;let a=w;for(;a<m.length&&m[a].start<=o.endExclusive;)a++;if(w===a)m.splice(w,0,o);else{const s=Math.min(o.start,m[w].start),b=Math.max(o.endExclusive,m[a-1].endExclusive);m.splice(w,a-w,new D(s,b))}}static tryCreate(o,m){if(!(o>m))return new D(o,m)}constructor(o,m){if(this.start=o,this.endExclusive=m,o>m)throw new E.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(o){return new D(this.start+o,this.endExclusive+o)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(o){return this.start===o.start&&this.endExclusive===o.endExclusive}containsRange(o){return this.start<=o.start&&o.endExclusive<=this.endExclusive}join(o){return new D(Math.min(this.start,o.start),Math.max(this.endExclusive,o.endExclusive))}intersect(o){const m=Math.max(this.start,o.start),w=Math.min(this.endExclusive,o.endExclusive);if(m<=w)return new D(m,w)}}n.OffsetRange=D}),X(J[3],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class E{constructor(i,o){this.lineNumber=i,this.column=o}with(i=this.lineNumber,o=this.column){return i===this.lineNumber&&o===this.column?this:new E(i,o)}delta(i=0,o=0){return this.with(this.lineNumber+i,this.column+o)}equals(i){return E.equals(this,i)}static equals(i,o){return!i&&!o?!0:!!i&&!!o&&i.lineNumber===o.lineNumber&&i.column===o.column}isBefore(i){return E.isBefore(this,i)}static isBefore(i,o){return i.lineNumber<o.lineNumber?!0:o.lineNumber<i.lineNumber?!1:i.column<o.column}isBeforeOrEqual(i){return E.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,o){return i.lineNumber<o.lineNumber?!0:o.lineNumber<i.lineNumber?!1:i.column<=o.column}static compare(i,o){const m=i.lineNumber|0,w=o.lineNumber|0;if(m===w){const a=i.column|0,s=o.column|0;return a-s}return m-w}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new E(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}n.Position=E}),X(J[2],Z([0,1,3]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class D{constructor(o,m,w,a){o>w||o===w&&m>a?(this.startLineNumber=w,this.startColumn=a,this.endLineNumber=o,this.endColumn=m):(this.startLineNumber=o,this.startColumn=m,this.endLineNumber=w,this.endColumn=a)}isEmpty(){return D.isEmpty(this)}static isEmpty(o){return o.startLineNumber===o.endLineNumber&&o.startColumn===o.endColumn}containsPosition(o){return D.containsPosition(this,o)}static containsPosition(o,m){return!(m.lineNumber<o.startLineNumber||m.lineNumber>o.endLineNumber||m.lineNumber===o.startLineNumber&&m.column<o.startColumn||m.lineNumber===o.endLineNumber&&m.column>o.endColumn)}static strictContainsPosition(o,m){return!(m.lineNumber<o.startLineNumber||m.lineNumber>o.endLineNumber||m.lineNumber===o.startLineNumber&&m.column<=o.startColumn||m.lineNumber===o.endLineNumber&&m.column>=o.endColumn)}containsRange(o){return D.containsRange(this,o)}static containsRange(o,m){return!(m.startLineNumber<o.startLineNumber||m.endLineNumber<o.startLineNumber||m.startLineNumber>o.endLineNumber||m.endLineNumber>o.endLineNumber||m.startLineNumber===o.startLineNumber&&m.startColumn<o.startColumn||m.endLineNumber===o.endLineNumber&&m.endColumn>o.endColumn)}strictContainsRange(o){return D.strictContainsRange(this,o)}static strictContainsRange(o,m){return!(m.startLineNumber<o.startLineNumber||m.endLineNumber<o.startLineNumber||m.startLineNumber>o.endLineNumber||m.endLineNumber>o.endLineNumber||m.startLineNumber===o.startLineNumber&&m.startColumn<=o.startColumn||m.endLineNumber===o.endLineNumber&&m.endColumn>=o.endColumn)}plusRange(o){return D.plusRange(this,o)}static plusRange(o,m){let w,a,s,b;return m.startLineNumber<o.startLineNumber?(w=m.startLineNumber,a=m.startColumn):m.startLineNumber===o.startLineNumber?(w=m.startLineNumber,a=Math.min(m.startColumn,o.startColumn)):(w=o.startLineNumber,a=o.startColumn),m.endLineNumber>o.endLineNumber?(s=m.endLineNumber,b=m.endColumn):m.endLineNumber===o.endLineNumber?(s=m.endLineNumber,b=Math.max(m.endColumn,o.endColumn)):(s=o.endLineNumber,b=o.endColumn),new D(w,a,s,b)}intersectRanges(o){return D.intersectRanges(this,o)}static intersectRanges(o,m){let w=o.startLineNumber,a=o.startColumn,s=o.endLineNumber,b=o.endColumn;const e=m.startLineNumber,c=m.startColumn,h=m.endLineNumber,d=m.endColumn;return w<e?(w=e,a=c):w===e&&(a=Math.max(a,c)),s>h?(s=h,b=d):s===h&&(b=Math.min(b,d)),w>s||w===s&&a>b?null:new D(w,a,s,b)}equalsRange(o){return D.equalsRange(this,o)}static equalsRange(o,m){return!o&&!m?!0:!!o&&!!m&&o.startLineNumber===m.startLineNumber&&o.startColumn===m.startColumn&&o.endLineNumber===m.endLineNumber&&o.endColumn===m.endColumn}getEndPosition(){return D.getEndPosition(this)}static getEndPosition(o){return new E.Position(o.endLineNumber,o.endColumn)}getStartPosition(){return D.getStartPosition(this)}static getStartPosition(o){return new E.Position(o.startLineNumber,o.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(o,m){return new D(this.startLineNumber,this.startColumn,o,m)}setStartPosition(o,m){return new D(o,m,this.endLineNumber,this.endColumn)}collapseToStart(){return D.collapseToStart(this)}static collapseToStart(o){return new D(o.startLineNumber,o.startColumn,o.startLineNumber,o.startColumn)}collapseToEnd(){return D.collapseToEnd(this)}static collapseToEnd(o){return new D(o.endLineNumber,o.endColumn,o.endLineNumber,o.endColumn)}delta(o){return new D(this.startLineNumber+o,this.startColumn,this.endLineNumber+o,this.endColumn)}static fromPositions(o,m=o){return new D(o.lineNumber,o.column,m.lineNumber,m.column)}static lift(o){return o?new D(o.startLineNumber,o.startColumn,o.endLineNumber,o.endColumn):null}static isIRange(o){return o&&typeof o.startLineNumber=="number"&&typeof o.startColumn=="number"&&typeof o.endLineNumber=="number"&&typeof o.endColumn=="number"}static areIntersectingOrTouching(o,m){return!(o.endLineNumber<m.startLineNumber||o.endLineNumber===m.startLineNumber&&o.endColumn<m.startColumn||m.endLineNumber<o.startLineNumber||m.endLineNumber===o.startLineNumber&&m.endColumn<o.startColumn)}static areIntersecting(o,m){return!(o.endLineNumber<m.startLineNumber||o.endLineNumber===m.startLineNumber&&o.endColumn<=m.startColumn||m.endLineNumber<o.startLineNumber||m.endLineNumber===o.startLineNumber&&m.endColumn<=o.startColumn)}static compareRangesUsingStarts(o,m){if(o&&m){const s=o.startLineNumber|0,b=m.startLineNumber|0;if(s===b){const e=o.startColumn|0,c=m.startColumn|0;if(e===c){const h=o.endLineNumber|0,d=m.endLineNumber|0;if(h===d){const _=o.endColumn|0,g=m.endColumn|0;return _-g}return h-d}return e-c}return s-b}return(o?1:0)-(m?1:0)}static compareRangesUsingEnds(o,m){return o.endLineNumber===m.endLineNumber?o.endColumn===m.endColumn?o.startLineNumber===m.startLineNumber?o.startColumn-m.startColumn:o.startLineNumber-m.startLineNumber:o.endColumn-m.endColumn:o.endLineNumber-m.endLineNumber}static spansMultipleLines(o){return o.endLineNumber>o.startLineNumber}toJSON(){return this}}n.Range=D}),X(J[12],Z([0,1,4,2]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRange=void 0;class i{static fromRange(m){return new i(m.startLineNumber,m.endLineNumber)}static subtract(m,w){return w?m.startLineNumber<w.startLineNumber&&w.endLineNumberExclusive<m.endLineNumberExclusive?[new i(m.startLineNumber,w.startLineNumber),new i(w.endLineNumberExclusive,m.endLineNumberExclusive)]:w.startLineNumber<=m.startLineNumber&&m.endLineNumberExclusive<=w.endLineNumberExclusive?[]:w.endLineNumberExclusive<m.endLineNumberExclusive?[new i(Math.max(w.endLineNumberExclusive,m.startLineNumber),m.endLineNumberExclusive)]:[new i(m.startLineNumber,Math.min(w.startLineNumber,m.endLineNumberExclusive))]:[m]}static joinMany(m){if(m.length===0)return[];let w=m[0];for(let a=1;a<m.length;a++)w=this.join(w,m[a]);return w}static join(m,w){if(m.length===0)return w;if(w.length===0)return m;const a=[];let s=0,b=0,e=null;for(;s<m.length||b<w.length;){let c=null;if(s<m.length&&b<w.length){const h=m[s],d=w[b];h.startLineNumber<d.startLineNumber?(c=h,s++):(c=d,b++)}else s<m.length?(c=m[s],s++):(c=w[b],b++);e===null?e=c:e.endLineNumberExclusive>=c.startLineNumber?e=new i(e.startLineNumber,Math.max(e.endLineNumberExclusive,c.endLineNumberExclusive)):(a.push(e),e=c)}return e!==null&&a.push(e),a}static ofLength(m,w){return new i(m,m+w)}constructor(m,w){if(m>w)throw new E.BugIndicatingError(`startLineNumber ${m} cannot be after endLineNumberExclusive ${w}`);this.startLineNumber=m,this.endLineNumberExclusive=w}contains(m){return this.startLineNumber<=m&&m<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(m){return new i(this.startLineNumber+m,this.endLineNumberExclusive+m)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(m){return new i(Math.min(this.startLineNumber,m.startLineNumber),Math.max(this.endLineNumberExclusive,m.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(m){const w=Math.max(this.startLineNumber,m.startLineNumber),a=Math.min(this.endLineNumberExclusive,m.endLineNumberExclusive);if(w<=a)return new i(w,a)}intersectsStrict(m){return this.startLineNumber<m.endLineNumberExclusive&&m.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(m){return this.startLineNumber<=m.endLineNumberExclusive&&m.startLineNumber<=this.endLineNumberExclusive}equals(m){return this.startLineNumber===m.startLineNumber&&this.endLineNumberExclusive===m.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new D.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new D.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(m){const w=[];for(let a=this.startLineNumber;a<this.endLineNumberExclusive;a++)w.push(m(a));return w}}n.LineRange=i}),X(J[35],Z([0,1,3,2]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=void 0;class i extends D.Range{constructor(m,w,a,s){super(m,w,a,s),this.selectionStartLineNumber=m,this.selectionStartColumn=w,this.positionLineNumber=a,this.positionColumn=s}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(m){return i.selectionsEqual(this,m)}static selectionsEqual(m,w){return m.selectionStartLineNumber===w.selectionStartLineNumber&&m.selectionStartColumn===w.selectionStartColumn&&m.positionLineNumber===w.positionLineNumber&&m.positionColumn===w.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(m,w){return this.getDirection()===0?new i(this.startLineNumber,this.startColumn,m,w):new i(m,w,this.startLineNumber,this.startColumn)}getPosition(){return new E.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new E.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(m,w){return this.getDirection()===0?new i(m,w,this.endLineNumber,this.endColumn):new i(this.endLineNumber,this.endColumn,m,w)}static fromPositions(m,w=m){return new i(m.lineNumber,m.column,w.lineNumber,w.column)}static fromRange(m,w){return w===0?new i(m.startLineNumber,m.startColumn,m.endLineNumber,m.endColumn):new i(m.endLineNumber,m.endColumn,m.startLineNumber,m.startColumn)}static liftSelection(m){return new i(m.selectionStartLineNumber,m.selectionStartColumn,m.positionLineNumber,m.positionColumn)}static selectionsArrEqual(m,w){if(m&&!w||!m&&w)return!1;if(!m&&!w)return!0;if(m.length!==w.length)return!1;for(let a=0,s=m.length;a<s;a++)if(!this.selectionsEqual(m[a],w[a]))return!1;return!0}static isISelection(m){return m&&typeof m.selectionStartLineNumber=="number"&&typeof m.selectionStartColumn=="number"&&typeof m.positionLineNumber=="number"&&typeof m.positionColumn=="number"}static createWithDirection(m,w,a,s,b){return b===0?new i(m,w,a,s):new i(a,s,m,w)}}n.Selection=i}),X(J[36],Z([0,1,22]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=void 0;class D extends E.CharacterClassifier{constructor(m){super(0);for(let w=0,a=m.length;w<a;w++)this.set(m.charCodeAt(w),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=D;function i(o){const m={};return w=>(m.hasOwnProperty(w)||(m[w]=o(w)),m[w])}n.getMapForWordSeparators=i(o=>new D(o))}),X(J[23],Z([0,1,16,17]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function i(s=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const e of n.USUAL_WORD_SEPARATORS)s.indexOf(e)>=0||(b+="\\"+e);return b+="\\s]+)",new RegExp(b,"g")}n.DEFAULT_WORD_REGEXP=i();function o(s){let b=n.DEFAULT_WORD_REGEXP;if(s&&s instanceof RegExp)if(s.global)b=s;else{let e="g";s.ignoreCase&&(e+="i"),s.multiline&&(e+="m"),s.unicode&&(e+="u"),b=new RegExp(s.source,e)}return b.lastIndex=0,b}n.ensureValidWordDefinition=o;const m=new D.LinkedList;m.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function w(s,b,e,c,h){if(h||(h=E.Iterable.first(m)),e.length>h.maxLen){let v=s-h.maxLen/2;return v<0?v=0:c+=v,e=e.substring(v,s+h.maxLen/2),w(s,b,e,c,h)}const d=Date.now(),_=s-1-c;let g=-1,N=null;for(let v=1;!(Date.now()-d>=h.timeBudget);v++){const A=_-h.windowSize*v;b.lastIndex=Math.max(0,A);const S=a(b,e,_,g);if(!S&&N||(N=S,A<=0))break;g=A}if(N){const v={word:N[0],startColumn:c+1+N.index,endColumn:c+1+N.index+N[0].length};return b.lastIndex=0,v}return null}n.getWordAtText=w;function a(s,b,e,c){let h;for(;h=s.exec(b);){const d=h.index||0;if(d<=e&&s.lastIndex>=e)return h;if(c>0&&d>c)return null}return null}}),X(J[8],Z([0,1,4,6]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DateTimeout=n.InfiniteTimeout=n.SequenceDiff=n.DiffAlgorithmResult=void 0;class i{static trivial(s,b){return new i([new o(new D.OffsetRange(0,s.length),new D.OffsetRange(0,b.length))],!1)}static trivialTimedOut(s,b){return new i([new o(new D.OffsetRange(0,s.length),new D.OffsetRange(0,b.length))],!0)}constructor(s,b){this.diffs=s,this.hitTimeout=b}}n.DiffAlgorithmResult=i;class o{constructor(s,b){this.seq1Range=s,this.seq2Range=b}reverse(){return new o(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(s){return new o(this.seq1Range.join(s.seq1Range),this.seq2Range.join(s.seq2Range))}delta(s){return s===0?this:new o(this.seq1Range.delta(s),this.seq2Range.delta(s))}}n.SequenceDiff=o;class m{isValid(){return!0}}n.InfiniteTimeout=m,m.instance=new m;class w{constructor(s){if(this.timeout=s,this.startTime=Date.now(),this.valid=!0,s<=0)throw new E.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}}n.DateTimeout=w}),X(J[37],Z([0,1,6,8]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shiftSequenceDiffs=n.joinSequenceDiffs=n.smoothenSequenceDiffs=n.optimizeSequenceDiffs=void 0;function i(s,b,e){let c=e;return c=m(s,b,c),c=w(s,b,c),c}n.optimizeSequenceDiffs=i;function o(s,b,e){const c=[];for(const h of e){const d=c[c.length-1];if(!d){c.push(h);continue}h.seq1Range.start-d.seq1Range.endExclusive<=2||h.seq2Range.start-d.seq2Range.endExclusive<=2?c[c.length-1]=new D.SequenceDiff(d.seq1Range.join(h.seq1Range),d.seq2Range.join(h.seq2Range)):c.push(h)}return c}n.smoothenSequenceDiffs=o;function m(s,b,e){const c=[];e.length>0&&c.push(e[0]);for(let d=1;d<e.length;d++){const _=e[d-1];let g=e[d];if(g.seq1Range.isEmpty||g.seq2Range.isEmpty){const N=g.seq1Range.start-_.seq1Range.endExclusive;let v;for(v=1;v<=N&&!(s.getElement(g.seq1Range.start-v)!==s.getElement(g.seq1Range.endExclusive-v)||b.getElement(g.seq2Range.start-v)!==b.getElement(g.seq2Range.endExclusive-v));v++);if(v--,v===N){c[c.length-1]=new D.SequenceDiff(new E.OffsetRange(_.seq1Range.start,g.seq1Range.endExclusive-N),new E.OffsetRange(_.seq2Range.start,g.seq2Range.endExclusive-N));continue}g=g.delta(-v)}c.push(g)}const h=[];for(let d=0;d<c.length-1;d++){const _=c[d+1];let g=c[d];if(g.seq1Range.isEmpty||g.seq2Range.isEmpty){const N=_.seq1Range.start-g.seq1Range.endExclusive;let v;for(v=0;v<N&&!(s.getElement(g.seq1Range.start+v)!==s.getElement(g.seq1Range.endExclusive+v)||b.getElement(g.seq2Range.start+v)!==b.getElement(g.seq2Range.endExclusive+v));v++);if(v===N){c[d+1]=new D.SequenceDiff(new E.OffsetRange(g.seq1Range.start+N,_.seq1Range.endExclusive),new E.OffsetRange(g.seq2Range.start+N,_.seq2Range.endExclusive));continue}v>0&&(g=g.delta(v))}h.push(g)}return c.length>0&&h.push(c[c.length-1]),h}n.joinSequenceDiffs=m;function w(s,b,e){if(!s.getBoundaryScore||!b.getBoundaryScore)return e;for(let c=0;c<e.length;c++){const h=c>0?e[c-1]:void 0,d=e[c],_=c+1<e.length?e[c+1]:void 0,g=new E.OffsetRange(h?h.seq1Range.start+1:0,_?_.seq1Range.endExclusive-1:s.length),N=new E.OffsetRange(h?h.seq2Range.start+1:0,_?_.seq2Range.endExclusive-1:b.length);d.seq1Range.isEmpty?e[c]=a(d,s,b,g,N):d.seq2Range.isEmpty&&(e[c]=a(d.reverse(),b,s,N,g).reverse())}return e}n.shiftSequenceDiffs=w;function a(s,b,e,c,h){let _=1;for(;s.seq1Range.start-_>=c.start&&s.seq2Range.start-_>=h.start&&e.getElement(s.seq2Range.start-_)===e.getElement(s.seq2Range.endExclusive-_)&&_<100;)_++;_--;let g=0;for(;s.seq1Range.start+g<c.endExclusive&&s.seq2Range.endExclusive+g<h.endExclusive&&e.getElement(s.seq2Range.start+g)===e.getElement(s.seq2Range.endExclusive+g)&&g<100;)g++;if(_===0&&g===0)return s;let N=0,v=-1;for(let A=-_;A<=g;A++){const S=s.seq2Range.start+A,u=s.seq2Range.endExclusive+A,r=s.seq1Range.start+A,l=b.getBoundaryScore(r)+e.getBoundaryScore(S)+e.getBoundaryScore(u);l>v&&(v=l,N=A)}return s.delta(N)}}),X(J[38],Z([0,1,6,8]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MyersDiffAlgorithm=void 0;class i{compute(s,b,e=D.InfiniteTimeout.instance){if(s.length===0||b.length===0)return D.DiffAlgorithmResult.trivial(s,b);function c(u,r){for(;u<s.length&&r<b.length&&s.getElement(u)===b.getElement(r);)u++,r++;return u}let h=0;const d=new m;d.set(0,c(0,0));const _=new w;_.set(0,d.get(0)===0?null:new o(null,0,0,d.get(0)));let g=0;e:for(;;){if(h++,!e.isValid())return D.DiffAlgorithmResult.trivialTimedOut(s,b);const u=-Math.min(h,b.length+h%2),r=Math.min(h,s.length+h%2);for(g=u;g<=r;g+=2){const l=g===r?-1:d.get(g+1),f=g===u?-1:d.get(g-1)+1,L=Math.min(Math.max(l,f),s.length),C=L-g;if(L>s.length||C>b.length)continue;const p=c(L,C);d.set(g,p);const R=L===l?_.get(g+1):_.get(g-1);if(_.set(g,p!==L?new o(R,L,C,p-L):R),d.get(g)===s.length&&d.get(g)-g===b.length)break e}}let N=_.get(g);const v=[];let A=s.length,S=b.length;for(;;){const u=N?N.x+N.length:0,r=N?N.y+N.length:0;if((u!==A||r!==S)&&v.push(new D.SequenceDiff(new E.OffsetRange(u,A),new E.OffsetRange(r,S))),!N)break;A=N.x,S=N.y,N=N.prev}return v.reverse(),new D.DiffAlgorithmResult(v,!1)}}n.MyersDiffAlgorithm=i;class o{constructor(s,b,e,c){this.prev=s,this.x=b,this.y=e,this.length=c}}class m{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.negativeArr[s]):this.positiveArr[s]}set(s,b){if(s<0){if(s=-s-1,s>=this.negativeArr.length){const e=this.negativeArr;this.negativeArr=new Int32Array(e.length*2),this.negativeArr.set(e)}this.negativeArr[s]=b}else{if(s>=this.positiveArr.length){const e=this.positiveArr;this.positiveArr=new Int32Array(e.length*2),this.positiveArr.set(e)}this.positiveArr[s]=b}}}class w{constructor(){this.positiveArr=[],this.negativeArr=[]}get(s){return s<0?(s=-s-1,this.negativeArr[s]):this.positiveArr[s]}set(s,b){s<0?(s=-s-1,this.negativeArr[s]=b):this.positiveArr[s]=b}}}),X(J[39],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Array2D=void 0;class E{constructor(i,o){this.width=i,this.height=o,this.array=[],this.array=new Array(i*o)}get(i,o){return this.array[i+o*this.width]}set(i,o,m){this.array[i+o*this.width]=m}}n.Array2D=E}),X(J[40],Z([0,1,6,8,39]),function(O,n,E,D,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DynamicProgrammingDiffing=void 0;class o{compute(w,a,s=D.InfiniteTimeout.instance,b){if(w.length===0||a.length===0)return D.DiffAlgorithmResult.trivial(w,a);const e=new i.Array2D(w.length,a.length),c=new i.Array2D(w.length,a.length),h=new i.Array2D(w.length,a.length);for(let S=0;S<w.length;S++)for(let u=0;u<a.length;u++){if(!s.isValid())return D.DiffAlgorithmResult.trivialTimedOut(w,a);const r=S===0?0:e.get(S-1,u),l=u===0?0:e.get(S,u-1);let f;w.getElement(S)===a.getElement(u)?(S===0||u===0?f=0:f=e.get(S-1,u-1),S>0&&u>0&&c.get(S-1,u-1)===3&&(f+=h.get(S-1,u-1)),f+=b?b(S,u):1):f=-1;const L=Math.max(r,l,f);if(L===f){const C=S>0&&u>0?h.get(S-1,u-1):0;h.set(S,u,C+1),c.set(S,u,3)}else L===r?(h.set(S,u,0),c.set(S,u,1)):L===l&&(h.set(S,u,0),c.set(S,u,2));e.set(S,u,L)}const d=[];let _=w.length,g=a.length;function N(S,u){(S+1!==_||u+1!==g)&&d.push(new D.SequenceDiff(new E.OffsetRange(S+1,_),new E.OffsetRange(u+1,g))),_=S,g=u}let v=w.length-1,A=a.length-1;for(;v>=0&&A>=0;)c.get(v,A)===3?(N(v,A),v--,A--):c.get(v,A)===1?v--:A--;return N(-1,-1),d.reverse(),new D.DiffAlgorithmResult(d,!1)}}n.DynamicProgrammingDiffing=o}),X(J[24],Z([0,1,12]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MovedText=n.SimpleLineRangeMapping=n.RangeMapping=n.LineRangeMapping=n.LinesDiff=void 0;class D{constructor(s,b,e){this.changes=s,this.moves=b,this.hitTimeout=e}}n.LinesDiff=D;class i{static inverse(s,b,e){const c=[];let h=1,d=1;for(const g of s){const N=new i(new E.LineRange(h,g.originalRange.startLineNumber),new E.LineRange(d,g.modifiedRange.startLineNumber),void 0);N.modifiedRange.isEmpty||c.push(N),h=g.originalRange.endLineNumberExclusive,d=g.modifiedRange.endLineNumberExclusive}const _=new i(new E.LineRange(h,b+1),new E.LineRange(d,e+1),void 0);return _.modifiedRange.isEmpty||c.push(_),c}constructor(s,b,e){this.originalRange=s,this.modifiedRange=b,this.innerChanges=e}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}get changedLineCount(){return Math.max(this.originalRange.length,this.modifiedRange.length)}flip(){var s;return new i(this.modifiedRange,this.originalRange,(s=this.innerChanges)===null||s===void 0?void 0:s.map(b=>b.flip()))}}n.LineRangeMapping=i;class o{constructor(s,b){this.originalRange=s,this.modifiedRange=b}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new o(this.modifiedRange,this.originalRange)}}n.RangeMapping=o;class m{constructor(s,b){this.originalRange=s,this.modifiedRange=b}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new m(this.modifiedRange,this.originalRange)}}n.SimpleLineRangeMapping=m;class w{constructor(s,b){this.lineRangeMapping=s,this.changes=b}flip(){return new w(this.lineRangeMapping.flip(),this.changes.map(s=>s.flip()))}}n.MovedText=w}),X(J[41],Z([0,1,19,24,5,2,9,12]),function(O,n,E,D,i,o,m,w){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=n.SmartLinesDiffComputer=void 0;const a=3;class s{computeDiff(u,r,l){var f;const C=new g(u,r,{maxComputationTime:l.maxComputationTimeMs,shouldIgnoreTrimWhitespace:l.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),p=[];let R=null;for(const y of C.changes){let M;y.originalEndLineNumber===0?M=new w.LineRange(y.originalStartLineNumber+1,y.originalStartLineNumber+1):M=new w.LineRange(y.originalStartLineNumber,y.originalEndLineNumber+1);let F;y.modifiedEndLineNumber===0?F=new w.LineRange(y.modifiedStartLineNumber+1,y.modifiedStartLineNumber+1):F=new w.LineRange(y.modifiedStartLineNumber,y.modifiedEndLineNumber+1);let I=new D.LineRangeMapping(M,F,(f=y.charChanges)===null||f===void 0?void 0:f.map(P=>new D.RangeMapping(new o.Range(P.originalStartLineNumber,P.originalStartColumn,P.originalEndLineNumber,P.originalEndColumn),new o.Range(P.modifiedStartLineNumber,P.modifiedStartColumn,P.modifiedEndLineNumber,P.modifiedEndColumn))));R&&(R.modifiedRange.endLineNumberExclusive===I.modifiedRange.startLineNumber||R.originalRange.endLineNumberExclusive===I.originalRange.startLineNumber)&&(I=new D.LineRangeMapping(R.originalRange.join(I.originalRange),R.modifiedRange.join(I.modifiedRange),R.innerChanges&&I.innerChanges?R.innerChanges.concat(I.innerChanges):void 0),p.pop()),p.push(I),R=I}return(0,m.assertFn)(()=>(0,m.checkAdjacentItems)(p,(y,M)=>M.originalRange.startLineNumber-y.originalRange.endLineNumberExclusive===M.modifiedRange.startLineNumber-y.modifiedRange.endLineNumberExclusive&&y.originalRange.endLineNumberExclusive<M.originalRange.startLineNumber&&y.modifiedRange.endLineNumberExclusive<M.modifiedRange.startLineNumber)),new D.LinesDiff(p,[],C.quitEarly)}}n.SmartLinesDiffComputer=s;function b(S,u,r,l){return new E.LcsDiff(S,u,r).ComputeDiff(l)}class e{constructor(u){const r=[],l=[];for(let f=0,L=u.length;f<L;f++)r[f]=N(u[f],1),l[f]=v(u[f],1);this.lines=u,this._startColumns=r,this._endColumns=l}getElements(){const u=[];for(let r=0,l=this.lines.length;r<l;r++)u[r]=this.lines[r].substring(this._startColumns[r]-1,this._endColumns[r]-1);return u}getStrictElement(u){return this.lines[u]}getStartLineNumber(u){return u+1}getEndLineNumber(u){return u+1}createCharSequence(u,r,l){const f=[],L=[],C=[];let p=0;for(let R=r;R<=l;R++){const y=this.lines[R],M=u?this._startColumns[R]:1,F=u?this._endColumns[R]:y.length+1;for(let I=M;I<F;I++)f[p]=y.charCodeAt(I-1),L[p]=R+1,C[p]=I,p++;!u&&R<l&&(f[p]=10,L[p]=R+1,C[p]=y.length+1,p++)}return new c(f,L,C)}}class c{constructor(u,r,l){this._charCodes=u,this._lineNumbers=r,this._columns=l}toString(){return"["+this._charCodes.map((u,r)=>(u===10?"\\n":String.fromCharCode(u))+`-(${this._lineNumbers[r]},${this._columns[r]})`).join(", ")+"]"}_assertIndex(u,r){if(u<0||u>=r.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(u){return u>0&&u===this._lineNumbers.length?this.getEndLineNumber(u-1):(this._assertIndex(u,this._lineNumbers),this._lineNumbers[u])}getEndLineNumber(u){return u===-1?this.getStartLineNumber(u+1):(this._assertIndex(u,this._lineNumbers),this._charCodes[u]===10?this._lineNumbers[u]+1:this._lineNumbers[u])}getStartColumn(u){return u>0&&u===this._columns.length?this.getEndColumn(u-1):(this._assertIndex(u,this._columns),this._columns[u])}getEndColumn(u){return u===-1?this.getStartColumn(u+1):(this._assertIndex(u,this._columns),this._charCodes[u]===10?1:this._columns[u]+1)}}class h{constructor(u,r,l,f,L,C,p,R){this.originalStartLineNumber=u,this.originalStartColumn=r,this.originalEndLineNumber=l,this.originalEndColumn=f,this.modifiedStartLineNumber=L,this.modifiedStartColumn=C,this.modifiedEndLineNumber=p,this.modifiedEndColumn=R}static createFromDiffChange(u,r,l){const f=r.getStartLineNumber(u.originalStart),L=r.getStartColumn(u.originalStart),C=r.getEndLineNumber(u.originalStart+u.originalLength-1),p=r.getEndColumn(u.originalStart+u.originalLength-1),R=l.getStartLineNumber(u.modifiedStart),y=l.getStartColumn(u.modifiedStart),M=l.getEndLineNumber(u.modifiedStart+u.modifiedLength-1),F=l.getEndColumn(u.modifiedStart+u.modifiedLength-1);return new h(f,L,C,p,R,y,M,F)}}function d(S){if(S.length<=1)return S;const u=[S[0]];let r=u[0];for(let l=1,f=S.length;l<f;l++){const L=S[l],C=L.originalStart-(r.originalStart+r.originalLength),p=L.modifiedStart-(r.modifiedStart+r.modifiedLength);Math.min(C,p)<a?(r.originalLength=L.originalStart+L.originalLength-r.originalStart,r.modifiedLength=L.modifiedStart+L.modifiedLength-r.modifiedStart):(u.push(L),r=L)}return u}class _{constructor(u,r,l,f,L){this.originalStartLineNumber=u,this.originalEndLineNumber=r,this.modifiedStartLineNumber=l,this.modifiedEndLineNumber=f,this.charChanges=L}static createFromDiffResult(u,r,l,f,L,C,p){let R,y,M,F,I;if(r.originalLength===0?(R=l.getStartLineNumber(r.originalStart)-1,y=0):(R=l.getStartLineNumber(r.originalStart),y=l.getEndLineNumber(r.originalStart+r.originalLength-1)),r.modifiedLength===0?(M=f.getStartLineNumber(r.modifiedStart)-1,F=0):(M=f.getStartLineNumber(r.modifiedStart),F=f.getEndLineNumber(r.modifiedStart+r.modifiedLength-1)),C&&r.originalLength>0&&r.originalLength<20&&r.modifiedLength>0&&r.modifiedLength<20&&L()){const P=l.createCharSequence(u,r.originalStart,r.originalStart+r.originalLength-1),U=f.createCharSequence(u,r.modifiedStart,r.modifiedStart+r.modifiedLength-1);if(P.getElements().length>0&&U.getElements().length>0){let W=b(P,U,L,!0).changes;p&&(W=d(W)),I=[];for(let z=0,T=W.length;z<T;z++)I.push(h.createFromDiffChange(W[z],P,U))}}return new _(R,y,M,F,I)}}class g{constructor(u,r,l){this.shouldComputeCharChanges=l.shouldComputeCharChanges,this.shouldPostProcessCharChanges=l.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=l.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=l.shouldMakePrettyDiff,this.originalLines=u,this.modifiedLines=r,this.original=new e(u),this.modified=new e(r),this.continueLineDiff=A(l.maxComputationTime),this.continueCharDiff=A(l.maxComputationTime===0?0:Math.min(l.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const u=b(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),r=u.changes,l=u.quitEarly;if(this.shouldIgnoreTrimWhitespace){const p=[];for(let R=0,y=r.length;R<y;R++)p.push(_.createFromDiffResult(this.shouldIgnoreTrimWhitespace,r[R],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:l,changes:p}}const f=[];let L=0,C=0;for(let p=-1,R=r.length;p<R;p++){const y=p+1<R?r[p+1]:null,M=y?y.originalStart:this.originalLines.length,F=y?y.modifiedStart:this.modifiedLines.length;for(;L<M&&C<F;){const I=this.originalLines[L],P=this.modifiedLines[C];if(I!==P){{let U=N(I,1),W=N(P,1);for(;U>1&&W>1;){const z=I.charCodeAt(U-2),T=P.charCodeAt(W-2);if(z!==T)break;U--,W--}(U>1||W>1)&&this._pushTrimWhitespaceCharChange(f,L+1,1,U,C+1,1,W)}{let U=v(I,1),W=v(P,1);const z=I.length+1,T=P.length+1;for(;U<z&&W<T;){const x=I.charCodeAt(U-1),q=I.charCodeAt(W-1);if(x!==q)break;U++,W++}(U<z||W<T)&&this._pushTrimWhitespaceCharChange(f,L+1,U,z,C+1,W,T)}}L++,C++}y&&(f.push(_.createFromDiffResult(this.shouldIgnoreTrimWhitespace,y,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),L+=y.originalLength,C+=y.modifiedLength)}return{quitEarly:l,changes:f}}_pushTrimWhitespaceCharChange(u,r,l,f,L,C,p){if(this._mergeTrimWhitespaceCharChange(u,r,l,f,L,C,p))return;let R;this.shouldComputeCharChanges&&(R=[new h(r,l,r,f,L,C,L,p)]),u.push(new _(r,r,L,L,R))}_mergeTrimWhitespaceCharChange(u,r,l,f,L,C,p){const R=u.length;if(R===0)return!1;const y=u[R-1];return y.originalEndLineNumber===0||y.modifiedEndLineNumber===0?!1:y.originalEndLineNumber===r&&y.modifiedEndLineNumber===L?(this.shouldComputeCharChanges&&y.charChanges&&y.charChanges.push(new h(r,l,r,f,L,C,L,p)),!0):y.originalEndLineNumber+1===r&&y.modifiedEndLineNumber+1===L?(y.originalEndLineNumber=r,y.modifiedEndLineNumber=L,this.shouldComputeCharChanges&&y.charChanges&&y.charChanges.push(new h(r,l,r,f,L,C,L,p)),!0):!1}}n.DiffComputer=g;function N(S,u){const r=i.firstNonWhitespaceIndex(S);return r===-1?u:r+1}function v(S,u){const r=i.lastNonWhitespaceIndex(S);return r===-1?u:r+2}function A(S){if(S===0)return()=>!0;const u=Date.now();return()=>Date.now()-u<S}}),X(J[42],Z([0,1,9,12,6,3,2,8,40,37,38,24]),function(O,n,E,D,i,o,m,w,a,s,b,e){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineSequence=n.getLineRangeMapping=n.lineRangeMappingFromRangeMappings=n.StandardLinesDiffComputer=void 0;class c{constructor(){this.dynamicProgrammingDiffing=new a.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new b.MyersDiffAlgorithm}computeDiff(M,F,I){const P=I.maxComputationTimeMs===0?w.InfiniteTimeout.instance:new w.DateTimeout(I.maxComputationTimeMs),U=!I.ignoreTrimWhitespace,W=new Map;function z(se){let ae=W.get(se);return ae===void 0&&(ae=W.size,W.set(se,ae)),ae}const T=M.map(se=>z(se.trim())),x=F.map(se=>z(se.trim())),q=new v(T,M),H=new v(x,F),t=(()=>q.length+H.length<1500?this.dynamicProgrammingDiffing.compute(q,H,P,(se,ae)=>M[se]===F[ae]?F[ae].length===0?.1:1+Math.log(1+F[ae].length):.99):this.myersDiffingAlgorithm.compute(q,H))();let ne=t.diffs,ie=t.hitTimeout;ne=(0,s.optimizeSequenceDiffs)(q,H,ne);const he=[],me=se=>{if(U)for(let ae=0;ae<se;ae++){const Q=be+ae,$=pe+ae;if(M[Q]!==F[$]){const Y=this.refineDiff(M,F,new w.SequenceDiff(new i.OffsetRange(Q,Q+1),new i.OffsetRange($,$+1)),P,U);for(const j of Y.mappings)he.push(j);Y.hitTimeout&&(ie=!0)}}};let be=0,pe=0;for(const se of ne){(0,E.assertFn)(()=>se.seq1Range.start-be===se.seq2Range.start-pe);const ae=se.seq1Range.start-be;me(ae),be=se.seq1Range.endExclusive,pe=se.seq2Range.endExclusive;const Q=this.refineDiff(M,F,se,P,U);Q.hitTimeout&&(ie=!0);for(const $ of Q.mappings)he.push($)}me(M.length-be);const Le=_(he,M,F),Ce=[];if(I.computeMoves){const se=Le.filter(Q=>Q.modifiedRange.isEmpty&&Q.originalRange.length>=3).map(Q=>new R(Q.originalRange,M)),ae=new Set(Le.filter(Q=>Q.originalRange.isEmpty&&Q.modifiedRange.length>=3).map(Q=>new R(Q.modifiedRange,F)));for(const Q of se){let $=-1,Y;for(const j of ae){const K=Q.computeSimilarity(j);K>$&&($=K,Y=j)}if($>.9&&Y){const j=this.refineDiff(M,F,new w.SequenceDiff(new i.OffsetRange(Q.range.startLineNumber-1,Q.range.endLineNumberExclusive-1),new i.OffsetRange(Y.range.startLineNumber-1,Y.range.endLineNumberExclusive-1)),P,U),K=_(j.mappings,M,F);ae.delete(Y),Ce.push(new e.MovedText(new e.SimpleLineRangeMapping(Q.range,Y.range),K))}}}return new e.LinesDiff(Le,Ce,ie)}refineDiff(M,F,I,P,U){const W=new S(M,I.seq1Range,U),z=new S(F,I.seq2Range,U),T=W.length+z.length<500?this.dynamicProgrammingDiffing.compute(W,z,P):this.myersDiffingAlgorithm.compute(W,z,P);let x=T.diffs;return x=(0,s.optimizeSequenceDiffs)(W,z,x),x=h(W,z,x),x=(0,s.smoothenSequenceDiffs)(W,z,x),{mappings:x.map(H=>new e.RangeMapping(W.translateRange(H.seq1Range),z.translateRange(H.seq2Range))),hitTimeout:T.hitTimeout}}}n.StandardLinesDiffComputer=c;function h(y,M,F){const I=[];let P;function U(){if(!P)return;const z=P.s1Range.length-P.deleted,T=P.s2Range.length-P.added;Math.max(P.deleted,P.added)+(P.count-1)>z&&I.push(new w.SequenceDiff(P.s1Range,P.s2Range)),P=void 0}for(const z of F){let T=function(ne,ie){var he,me,be,pe;if(!P||!P.s1Range.containsRange(ne)||!P.s2Range.containsRange(ie))if(P&&!(P.s1Range.endExclusive<ne.start&&P.s2Range.endExclusive<ie.start)){const se=i.OffsetRange.tryCreate(P.s1Range.endExclusive,ne.start),ae=i.OffsetRange.tryCreate(P.s2Range.endExclusive,ie.start);P.deleted+=(he=se?.length)!==null&&he!==void 0?he:0,P.added+=(me=ae?.length)!==null&&me!==void 0?me:0,P.s1Range=P.s1Range.join(ne),P.s2Range=P.s2Range.join(ie)}else U(),P={added:0,deleted:0,count:0,s1Range:ne,s2Range:ie};const Le=ne.intersect(z.seq1Range),Ce=ie.intersect(z.seq2Range);P.count++,P.deleted+=(be=Le?.length)!==null&&be!==void 0?be:0,P.added+=(pe=Ce?.length)!==null&&pe!==void 0?pe:0};const x=y.findWordContaining(z.seq1Range.start-1),q=M.findWordContaining(z.seq2Range.start-1),H=y.findWordContaining(z.seq1Range.endExclusive),t=M.findWordContaining(z.seq2Range.endExclusive);x&&H&&q&&t&&x.equals(H)&&q.equals(t)?T(x,q):(x&&q&&T(x,q),H&&t&&T(H,t))}return U(),d(F,I)}function d(y,M){const F=[];for(;y.length>0||M.length>0;){const I=y[0],P=M[0];let U;I&&(!P||I.seq1Range.start<P.seq1Range.start)?U=y.shift():U=M.shift(),F.length>0&&F[F.length-1].seq1Range.endExclusive>=U.seq1Range.start?F[F.length-1]=F[F.length-1].join(U):F.push(U)}return F}function _(y,M,F){const I=[];for(const P of N(y.map(U=>g(U,M,F)),(U,W)=>U.originalRange.overlapOrTouch(W.originalRange)||U.modifiedRange.overlapOrTouch(W.modifiedRange))){const U=P[0],W=P[P.length-1];I.push(new e.LineRangeMapping(U.originalRange.join(W.originalRange),U.modifiedRange.join(W.modifiedRange),P.map(z=>z.innerChanges[0])))}return(0,E.assertFn)(()=>I.length>0&&I[0].originalRange.startLineNumber!==I[0].modifiedRange.startLineNumber?!1:(0,E.checkAdjacentItems)(I,(P,U)=>U.originalRange.startLineNumber-P.originalRange.endLineNumberExclusive===U.modifiedRange.startLineNumber-P.modifiedRange.endLineNumberExclusive&&P.originalRange.endLineNumberExclusive<U.originalRange.startLineNumber&&P.modifiedRange.endLineNumberExclusive<U.modifiedRange.startLineNumber)),I}n.lineRangeMappingFromRangeMappings=_;function g(y,M,F){let I=0,P=0;y.modifiedRange.endColumn===1&&y.originalRange.endColumn===1&&y.originalRange.startLineNumber+I<=y.originalRange.endLineNumber&&y.modifiedRange.startLineNumber+I<=y.modifiedRange.endLineNumber&&(P=-1),y.modifiedRange.startColumn-1>=F[y.modifiedRange.startLineNumber-1].length&&y.originalRange.startColumn-1>=M[y.originalRange.startLineNumber-1].length&&y.originalRange.startLineNumber<=y.originalRange.endLineNumber+P&&y.modifiedRange.startLineNumber<=y.modifiedRange.endLineNumber+P&&(I=1);const U=new D.LineRange(y.originalRange.startLineNumber+I,y.originalRange.endLineNumber+1+P),W=new D.LineRange(y.modifiedRange.startLineNumber+I,y.modifiedRange.endLineNumber+1+P);return new e.LineRangeMapping(U,W,[y])}n.getLineRangeMapping=g;function*N(y,M){let F,I;for(const P of y)I!==void 0&&M(I,P)?F.push(P):(F&&(yield F),F=[P]),I=P;F&&(yield F)}class v{constructor(M,F){this.trimmedHash=M,this.lines=F}getElement(M){return this.trimmedHash[M]}get length(){return this.trimmedHash.length}getBoundaryScore(M){const F=M===0?0:A(this.lines[M-1]),I=M===this.lines.length?0:A(this.lines[M]);return 1e3-(F+I)}}n.LineSequence=v;function A(y){let M=0;for(;M<y.length&&(y.charCodeAt(M)===32||y.charCodeAt(M)===9);)M++;return M}class S{constructor(M,F,I){this.lines=M,this.considerWhitespaceChanges=I,this.elements=[],this.firstCharOffsetByLineMinusOne=[],this.offsetByLine=[];let P=!1;F.start>0&&F.endExclusive>=M.length&&(F=new i.OffsetRange(F.start-1,F.endExclusive),P=!0),this.lineRange=F;for(let U=this.lineRange.start;U<this.lineRange.endExclusive;U++){let W=M[U],z=0;if(P)z=W.length,W="",P=!1;else if(!I){const T=W.trimStart();z=W.length-T.length,W=T.trimEnd()}this.offsetByLine.push(z);for(let T=0;T<W.length;T++)this.elements.push(W.charCodeAt(T));U<M.length-1&&(this.elements.push(`
`.charCodeAt(0)),this.firstCharOffsetByLineMinusOne[U-this.lineRange.start]=this.elements.length)}this.offsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return[...this.elements].map(M=>String.fromCharCode(M)).join("")}getElement(M){return this.elements[M]}get length(){return this.elements.length}getBoundaryScore(M){const F=f(M>0?this.elements[M-1]:-1),I=f(M<this.elements.length?this.elements[M]:-1);if(F===6&&I===7)return 0;let P=0;return F!==I&&(P+=10,I===1&&(P+=1)),P+=l(F),P+=l(I),P}translateOffset(M){if(this.lineRange.isEmpty)return new o.Position(this.lineRange.start+1,1);let F=0,I=this.firstCharOffsetByLineMinusOne.length;for(;F<I;){const U=Math.floor((F+I)/2);this.firstCharOffsetByLineMinusOne[U]>M?I=U:F=U+1}const P=F===0?0:this.firstCharOffsetByLineMinusOne[F-1];return new o.Position(this.lineRange.start+F+1,M-P+1+this.offsetByLine[F])}translateRange(M){return m.Range.fromPositions(this.translateOffset(M.start),this.translateOffset(M.endExclusive))}findWordContaining(M){if(M<0||M>=this.elements.length||!u(this.elements[M]))return;let F=M;for(;F>0&&u(this.elements[F-1]);)F--;let I=M;for(;I<this.elements.length&&u(this.elements[I]);)I++;return new i.OffsetRange(F,I)}}function u(y){return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57}const r={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function l(y){return r[y]}function f(y){return y===10?7:y===13?6:L(y)?5:y>=97&&y<=122?0:y>=65&&y<=90?1:y>=48&&y<=57?2:y===-1?3:4}function L(y){return y===32||y===9}const C=new Map;function p(y){let M=C.get(y);return M===void 0&&(M=C.size,C.set(y,M)),M}class R{constructor(M,F){this.range=M,this.lines=F,this.histogram=[];let I=0;for(let P=M.startLineNumber-1;P<M.endLineNumberExclusive-1;P++){const U=F[P];for(let z=0;z<U.length;z++){I++;const T=U[z],x=p(T);this.histogram[x]=(this.histogram[x]||0)+1}I++;const W=p(`
`);this.histogram[W]=(this.histogram[W]||0)+1}this.totalCount=I}computeSimilarity(M){var F,I;let P=0;const U=Math.max(this.histogram.length,M.histogram.length);for(let W=0;W<U;W++)P+=Math.abs(((F=this.histogram[W])!==null&&F!==void 0?F:0)-((I=M.histogram[W])!==null&&I!==void 0?I:0));return 1-P/(this.totalCount+M.totalCount)}}}),X(J[43],Z([0,1,41,42]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.linesDiffComputers=void 0,n.linesDiffComputers={getLegacy:()=>new E.SmartLinesDiffComputer,getAdvanced:()=>new D.StandardLinesDiffComputer}}),X(J[44],Z([0,1,28]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeDefaultDocumentColors=void 0;function D(c){const h=[];for(const d of c){const _=Number(d);(_||_===0&&d.replace(/\s/g,"")!=="")&&h.push(_)}return h}function i(c,h,d,_){return{red:c/255,blue:d/255,green:h/255,alpha:_}}function o(c,h){const d=h.index,_=h[0].length;if(!d)return;const g=c.positionAt(d);return{startLineNumber:g.lineNumber,startColumn:g.column,endLineNumber:g.lineNumber,endColumn:g.column+_}}function m(c,h){if(!c)return;const d=E.Color.Format.CSS.parseHex(h);if(d)return{range:c,color:i(d.rgba.r,d.rgba.g,d.rgba.b,d.rgba.a)}}function w(c,h,d){if(!c||h.length!==1)return;const g=h[0].values(),N=D(g);return{range:c,color:i(N[0],N[1],N[2],d?N[3]:1)}}function a(c,h,d){if(!c||h.length!==1)return;const g=h[0].values(),N=D(g),v=new E.Color(new E.HSLA(N[0],N[1]/100,N[2]/100,d?N[3]:1));return{range:c,color:i(v.rgba.r,v.rgba.g,v.rgba.b,v.rgba.a)}}function s(c,h){return typeof c=="string"?[...c.matchAll(h)]:c.findMatches(h)}function b(c){const h=[],_=s(c,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(_.length>0)for(const g of _){const N=g.filter(u=>u!==void 0),v=N[1],A=N[2];if(!A)continue;let S;if(v==="rgb"){const u=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;S=w(o(c,g),s(A,u),!1)}else if(v==="rgba"){const u=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;S=w(o(c,g),s(A,u),!0)}else if(v==="hsl"){const u=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;S=a(o(c,g),s(A,u),!1)}else if(v==="hsla"){const u=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;S=a(o(c,g),s(A,u),!0)}else v==="#"&&(S=m(o(c,g),v+A));S&&h.push(S)}return h}function e(c){return!c||typeof c.getValue!="function"||typeof c.positionAt!="function"?[]:b(c)}n.computeDefaultDocumentColors=e}),X(J[45],Z([0,1,22]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=void 0;class D{constructor(c,h,d){const _=new Uint8Array(c*h);for(let g=0,N=c*h;g<N;g++)_[g]=d;this._data=_,this.rows=c,this.cols=h}get(c,h){return this._data[c*this.cols+h]}set(c,h,d){this._data[c*this.cols+h]=d}}class i{constructor(c){let h=0,d=0;for(let g=0,N=c.length;g<N;g++){const[v,A,S]=c[g];A>h&&(h=A),v>d&&(d=v),S>d&&(d=S)}h++,d++;const _=new D(d,h,0);for(let g=0,N=c.length;g<N;g++){const[v,A,S]=c[g];_.set(v,A,S)}this._states=_,this._maxCharCode=h}nextState(c,h){return h<0||h>=this._maxCharCode?0:this._states.get(c,h)}}n.StateMachine=i;let o=null;function m(){return o===null&&(o=new i([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),o}let w=null;function a(){if(w===null){w=new E.CharacterClassifier(0);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<e.length;h++)w.set(e.charCodeAt(h),1);const c=".,;:";for(let h=0;h<c.length;h++)w.set(c.charCodeAt(h),2)}return w}class s{static _createLink(c,h,d,_,g){let N=g-1;do{const v=h.charCodeAt(N);if(c.get(v)!==2)break;N--}while(N>_);if(_>0){const v=h.charCodeAt(_-1),A=h.charCodeAt(N);(v===40&&A===41||v===91&&A===93||v===123&&A===125)&&N--}return{range:{startLineNumber:d,startColumn:_+1,endLineNumber:d,endColumn:N+2},url:h.substring(_,N+1)}}static computeLinks(c,h=m()){const d=a(),_=[];for(let g=1,N=c.getLineCount();g<=N;g++){const v=c.getLineContent(g),A=v.length;let S=0,u=0,r=0,l=1,f=!1,L=!1,C=!1,p=!1;for(;S<A;){let R=!1;const y=v.charCodeAt(S);if(l===13){let M;switch(y){case 40:f=!0,M=0;break;case 41:M=f?0:1;break;case 91:C=!0,L=!0,M=0;break;case 93:C=!1,M=L?0:1;break;case 123:p=!0,M=0;break;case 125:M=p?0:1;break;case 39:case 34:case 96:r===y?M=1:r===39||r===34||r===96?M=0:M=1;break;case 42:M=r===42?1:0;break;case 124:M=r===124?1:0;break;case 32:M=C?0:1;break;default:M=d.get(y)}M===1&&(_.push(s._createLink(d,v,g,u,S)),R=!0)}else if(l===12){let M;y===91?(L=!0,M=0):M=d.get(y),M===1?R=!0:l=13}else l=h.nextState(l,y),l===0&&(R=!0);R&&(l=1,f=!1,L=!1,p=!1,u=S+1,r=y),S++}l===13&&_.push(s._createLink(d,v,g,u,A))}return _}}n.LinkComputer=s;function b(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:s.computeLinks(e)}n.computeLinks=b}),X(J[46],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class E{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(i,o,m,w,a){if(i&&o){const s=this.doNavigateValueSet(o,a);if(s)return{range:i,value:s}}if(m&&w){const s=this.doNavigateValueSet(w,a);if(s)return{range:m,value:s}}return null}doNavigateValueSet(i,o){const m=this.numberReplace(i,o);return m!==null?m:this.textReplace(i,o)}numberReplace(i,o){const m=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let w=Number(i);const a=parseFloat(i);return!isNaN(w)&&!isNaN(a)&&w===a?w===0&&!o?null:(w=Math.floor(w*m),w+=o?m:-m,String(w/m)):null}textReplace(i,o){return this.valueSetsReplace(this._defaultValueSet,i,o)}valueSetsReplace(i,o,m){let w=null;for(let a=0,s=i.length;w===null&&a<s;a++)w=this.valueSetReplace(i[a],o,m);return w}valueSetReplace(i,o,m){let w=i.indexOf(o);return w>=0?(w+=m?1:-1,w<0?w=i.length-1:w%=i.length,i[w]):null}}n.BasicInplaceReplace=E,E.INSTANCE=new E}),X(J[47],Z([0,1,11]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shouldSynchronizeModel=n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.isITextSnapshot=n.FindMatch=n.TextModelResolvedOptions=n.InjectedTextCursorStops=n.MinimapPosition=n.GlyphMarginLane=n.OverviewRulerLane=void 0;var D;(function(d){d[d.Left=1]="Left",d[d.Center=2]="Center",d[d.Right=4]="Right",d[d.Full=7]="Full"})(D||(n.OverviewRulerLane=D={}));var i;(function(d){d[d.Left=1]="Left",d[d.Right=2]="Right"})(i||(n.GlyphMarginLane=i={}));var o;(function(d){d[d.Inline=1]="Inline",d[d.Gutter=2]="Gutter"})(o||(n.MinimapPosition=o={}));var m;(function(d){d[d.Both=0]="Both",d[d.Right=1]="Right",d[d.Left=2]="Left",d[d.None=3]="None"})(m||(n.InjectedTextCursorStops=m={}));class w{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(_){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,_.tabSize|0),_.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,_.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!_.insertSpaces,this.defaultEOL=_.defaultEOL|0,this.trimAutoWhitespace=!!_.trimAutoWhitespace,this.bracketPairColorizationOptions=_.bracketPairColorizationOptions}equals(_){return this.tabSize===_.tabSize&&this._indentSizeIsTabSize===_._indentSizeIsTabSize&&this.indentSize===_.indentSize&&this.insertSpaces===_.insertSpaces&&this.defaultEOL===_.defaultEOL&&this.trimAutoWhitespace===_.trimAutoWhitespace&&(0,E.equals)(this.bracketPairColorizationOptions,_.bracketPairColorizationOptions)}createChangeEvent(_){return{tabSize:this.tabSize!==_.tabSize,indentSize:this.indentSize!==_.indentSize,insertSpaces:this.insertSpaces!==_.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==_.trimAutoWhitespace}}}n.TextModelResolvedOptions=w;class a{constructor(_,g){this._findMatchBrand=void 0,this.range=_,this.matches=g}}n.FindMatch=a;function s(d){return d&&typeof d.read=="function"}n.isITextSnapshot=s;class b{constructor(_,g,N,v,A,S){this.identifier=_,this.range=g,this.text=N,this.forceMoveMarkers=v,this.isAutoWhitespaceEdit=A,this._isTracked=S}}n.ValidAnnotatedEditOperation=b;class e{constructor(_,g,N){this.regex=_,this.wordSeparators=g,this.simpleSearch=N}}n.SearchData=e;class c{constructor(_,g,N){this.reverseEdits=_,this.changes=g,this.trimAutoWhitespaceLineNumbers=N}}n.ApplyEditsResult=c;function h(d){return!d.isTooLargeForSyncing()&&!d.isForSimpleWidget}n.shouldSynchronizeModel=h}),X(J[48],Z([0,1,26,21]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class i{constructor(a){this.values=a,this.prefixSum=new Uint32Array(a.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(a,s){a=(0,D.toUint32)(a);const b=this.values,e=this.prefixSum,c=s.length;return c===0?!1:(this.values=new Uint32Array(b.length+c),this.values.set(b.subarray(0,a),0),this.values.set(b.subarray(a),a+c),this.values.set(s,a),a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(a,s){return a=(0,D.toUint32)(a),s=(0,D.toUint32)(s),this.values[a]===s?!1:(this.values[a]=s,a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),!0)}removeValues(a,s){a=(0,D.toUint32)(a),s=(0,D.toUint32)(s);const b=this.values,e=this.prefixSum;if(a>=b.length)return!1;const c=b.length-a;return s>=c&&(s=c),s===0?!1:(this.values=new Uint32Array(b.length-s),this.values.set(b.subarray(0,a),0),this.values.set(b.subarray(a+s),a),this.prefixSum=new Uint32Array(this.values.length),a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(a){return a<0?0:(a=(0,D.toUint32)(a),this._getPrefixSum(a))}_getPrefixSum(a){if(a<=this.prefixSumValidIndex[0])return this.prefixSum[a];let s=this.prefixSumValidIndex[0]+1;s===0&&(this.prefixSum[0]=this.values[0],s++),a>=this.values.length&&(a=this.values.length-1);for(let b=s;b<=a;b++)this.prefixSum[b]=this.prefixSum[b-1]+this.values[b];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],a),this.prefixSum[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let s=0,b=this.values.length-1,e=0,c=0,h=0;for(;s<=b;)if(e=s+(b-s)/2|0,c=this.prefixSum[e],h=c-this.values[e],a<h)b=e-1;else if(a>=c)s=e+1;else break;return new m(e,a-h)}}n.PrefixSumComputer=i;class o{constructor(a){this._values=a,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(a){return this._ensureValid(),a===0?0:this._prefixSum[a-1]}getIndexOf(a){this._ensureValid();const s=this._indexBySum[a],b=s>0?this._prefixSum[s-1]:0;return new m(s,a-b)}removeValues(a,s){this._values.splice(a,s),this._invalidate(a)}insertValues(a,s){this._values=(0,E.arrayInsert)(this._values,a,s),this._invalidate(a)}_invalidate(a){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,a-1)}_ensureValid(){if(!this._isValid){for(let a=this._validEndIndex+1,s=this._values.length;a<s;a++){const b=this._values[a],e=a>0?this._prefixSum[a-1]:0;this._prefixSum[a]=e+b;for(let c=0;c<b;c++)this._indexBySum[e+c]=a}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(a,s){this._values[a]!==s&&(this._values[a]=s,this._invalidate(a))}}n.ConstantTimePrefixSumComputer=o;class m{constructor(a,s){this.index=a,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=s}}n.PrefixSumIndexOfResult=m}),X(J[49],Z([0,1,5,3,48]),function(O,n,E,D,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class o{constructor(w,a,s,b){this._uri=w,this._lines=a,this._eol=s,this._versionId=b,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(w){w.eol&&w.eol!==this._eol&&(this._eol=w.eol,this._lineStarts=null);const a=w.changes;for(const s of a)this._acceptDeleteRange(s.range),this._acceptInsertText(new D.Position(s.range.startLineNumber,s.range.startColumn),s.text);this._versionId=w.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const w=this._eol.length,a=this._lines.length,s=new Uint32Array(a);for(let b=0;b<a;b++)s[b]=this._lines[b].length+w;this._lineStarts=new i.PrefixSumComputer(s)}}_setLineText(w,a){this._lines[w]=a,this._lineStarts&&this._lineStarts.setValue(w,this._lines[w].length+this._eol.length)}_acceptDeleteRange(w){if(w.startLineNumber===w.endLineNumber){if(w.startColumn===w.endColumn)return;this._setLineText(w.startLineNumber-1,this._lines[w.startLineNumber-1].substring(0,w.startColumn-1)+this._lines[w.startLineNumber-1].substring(w.endColumn-1));return}this._setLineText(w.startLineNumber-1,this._lines[w.startLineNumber-1].substring(0,w.startColumn-1)+this._lines[w.endLineNumber-1].substring(w.endColumn-1)),this._lines.splice(w.startLineNumber,w.endLineNumber-w.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(w.startLineNumber,w.endLineNumber-w.startLineNumber)}_acceptInsertText(w,a){if(a.length===0)return;const s=(0,E.splitLines)(a);if(s.length===1){this._setLineText(w.lineNumber-1,this._lines[w.lineNumber-1].substring(0,w.column-1)+s[0]+this._lines[w.lineNumber-1].substring(w.column-1));return}s[s.length-1]+=this._lines[w.lineNumber-1].substring(w.column-1),this._setLineText(w.lineNumber-1,this._lines[w.lineNumber-1].substring(0,w.column-1)+s[0]);const b=new Uint32Array(s.length-1);for(let e=1;e<s.length;e++)this._lines.splice(w.lineNumber+e-1,0,s[e]),b[e-1]=s[e].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(w.lineNumber,b)}}n.MirrorTextModel=o}),X(J[50],Z([0,1,5,36,3,2,47]),function(O,n,E,D,i,o,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.isMultilineRegexSource=n.SearchParams=void 0;const w=999;class a{constructor(v,A,S,u){this.searchString=v,this.isRegex=A,this.matchCase=S,this.wordSeparators=u}parseSearchRequest(){if(this.searchString==="")return null;let v;this.isRegex?v=s(this.searchString):v=this.searchString.indexOf(`
`)>=0;let A=null;try{A=E.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:v,global:!0,unicode:!0})}catch{return null}if(!A)return null;let S=!this.isRegex&&!v;return S&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(S=this.matchCase),new m.SearchData(A,this.wordSeparators?(0,D.getMapForWordSeparators)(this.wordSeparators):null,S?this.searchString:null)}}n.SearchParams=a;function s(N){if(!N||N.length===0)return!1;for(let v=0,A=N.length;v<A;v++){const S=N.charCodeAt(v);if(S===10)return!0;if(S===92){if(v++,v>=A)break;const u=N.charCodeAt(v);if(u===110||u===114||u===87)return!0}}return!1}n.isMultilineRegexSource=s;function b(N,v,A){if(!A)return new m.FindMatch(N,null);const S=[];for(let u=0,r=v.length;u<r;u++)S[u]=v[u];return new m.FindMatch(N,S)}n.createFindMatch=b;class e{constructor(v){const A=[];let S=0;for(let u=0,r=v.length;u<r;u++)v.charCodeAt(u)===10&&(A[S++]=u);this._lineFeedsOffsets=A}findLineFeedCountBeforeOffset(v){const A=this._lineFeedsOffsets;let S=0,u=A.length-1;if(u===-1||v<=A[0])return 0;for(;S<u;){const r=S+((u-S)/2>>0);A[r]>=v?u=r-1:A[r+1]>=v?(S=r,u=r):S=r+1}return S+1}}class c{static findMatches(v,A,S,u,r){const l=A.parseSearchRequest();return l?l.regex.multiline?this._doFindMatchesMultiline(v,S,new g(l.wordSeparators,l.regex),u,r):this._doFindMatchesLineByLine(v,S,l,u,r):[]}static _getMultilineMatchRange(v,A,S,u,r,l){let f,L=0;u?(L=u.findLineFeedCountBeforeOffset(r),f=A+r+L):f=A+r;let C;if(u){const M=u.findLineFeedCountBeforeOffset(r+l.length)-L;C=f+l.length+M}else C=f+l.length;const p=v.getPositionAt(f),R=v.getPositionAt(C);return new o.Range(p.lineNumber,p.column,R.lineNumber,R.column)}static _doFindMatchesMultiline(v,A,S,u,r){const l=v.getOffsetAt(A.getStartPosition()),f=v.getValueInRange(A,1),L=v.getEOL()===`\r
`?new e(f):null,C=[];let p=0,R;for(S.reset(0);R=S.next(f);)if(C[p++]=b(this._getMultilineMatchRange(v,l,f,L,R.index,R[0]),R,u),p>=r)return C;return C}static _doFindMatchesLineByLine(v,A,S,u,r){const l=[];let f=0;if(A.startLineNumber===A.endLineNumber){const C=v.getLineContent(A.startLineNumber).substring(A.startColumn-1,A.endColumn-1);return f=this._findMatchesInLine(S,C,A.startLineNumber,A.startColumn-1,f,l,u,r),l}const L=v.getLineContent(A.startLineNumber).substring(A.startColumn-1);f=this._findMatchesInLine(S,L,A.startLineNumber,A.startColumn-1,f,l,u,r);for(let C=A.startLineNumber+1;C<A.endLineNumber&&f<r;C++)f=this._findMatchesInLine(S,v.getLineContent(C),C,0,f,l,u,r);if(f<r){const C=v.getLineContent(A.endLineNumber).substring(0,A.endColumn-1);f=this._findMatchesInLine(S,C,A.endLineNumber,0,f,l,u,r)}return l}static _findMatchesInLine(v,A,S,u,r,l,f,L){const C=v.wordSeparators;if(!f&&v.simpleSearch){const y=v.simpleSearch,M=y.length,F=A.length;let I=-M;for(;(I=A.indexOf(y,I+M))!==-1;)if((!C||_(C,A,F,I,M))&&(l[r++]=new m.FindMatch(new o.Range(S,I+1+u,S,I+1+M+u),null),r>=L))return r;return r}const p=new g(v.wordSeparators,v.regex);let R;p.reset(0);do if(R=p.next(A),R&&(l[r++]=b(new o.Range(S,R.index+1+u,S,R.index+1+R[0].length+u),R,f),r>=L))return r;while(R);return r}static findNextMatch(v,A,S,u){const r=A.parseSearchRequest();if(!r)return null;const l=new g(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(v,S,l,u):this._doFindNextMatchLineByLine(v,S,l,u)}static _doFindNextMatchMultiline(v,A,S,u){const r=new i.Position(A.lineNumber,1),l=v.getOffsetAt(r),f=v.getLineCount(),L=v.getValueInRange(new o.Range(r.lineNumber,r.column,f,v.getLineMaxColumn(f)),1),C=v.getEOL()===`\r
`?new e(L):null;S.reset(A.column-1);const p=S.next(L);return p?b(this._getMultilineMatchRange(v,l,L,C,p.index,p[0]),p,u):A.lineNumber!==1||A.column!==1?this._doFindNextMatchMultiline(v,new i.Position(1,1),S,u):null}static _doFindNextMatchLineByLine(v,A,S,u){const r=v.getLineCount(),l=A.lineNumber,f=v.getLineContent(l),L=this._findFirstMatchInLine(S,f,l,A.column,u);if(L)return L;for(let C=1;C<=r;C++){const p=(l+C-1)%r,R=v.getLineContent(p+1),y=this._findFirstMatchInLine(S,R,p+1,1,u);if(y)return y}return null}static _findFirstMatchInLine(v,A,S,u,r){v.reset(u-1);const l=v.next(A);return l?b(new o.Range(S,l.index+1,S,l.index+1+l[0].length),l,r):null}static findPreviousMatch(v,A,S,u){const r=A.parseSearchRequest();if(!r)return null;const l=new g(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(v,S,l,u):this._doFindPreviousMatchLineByLine(v,S,l,u)}static _doFindPreviousMatchMultiline(v,A,S,u){const r=this._doFindMatchesMultiline(v,new o.Range(1,1,A.lineNumber,A.column),S,u,10*w);if(r.length>0)return r[r.length-1];const l=v.getLineCount();return A.lineNumber!==l||A.column!==v.getLineMaxColumn(l)?this._doFindPreviousMatchMultiline(v,new i.Position(l,v.getLineMaxColumn(l)),S,u):null}static _doFindPreviousMatchLineByLine(v,A,S,u){const r=v.getLineCount(),l=A.lineNumber,f=v.getLineContent(l).substring(0,A.column-1),L=this._findLastMatchInLine(S,f,l,u);if(L)return L;for(let C=1;C<=r;C++){const p=(r+l-C-1)%r,R=v.getLineContent(p+1),y=this._findLastMatchInLine(S,R,p+1,u);if(y)return y}return null}static _findLastMatchInLine(v,A,S,u){let r=null,l;for(v.reset(0);l=v.next(A);)r=b(new o.Range(S,l.index+1,S,l.index+1+l[0].length),l,u);return r}}n.TextModelSearch=c;function h(N,v,A,S,u){if(S===0)return!0;const r=v.charCodeAt(S-1);if(N.get(r)!==0||r===13||r===10)return!0;if(u>0){const l=v.charCodeAt(S);if(N.get(l)!==0)return!0}return!1}function d(N,v,A,S,u){if(S+u===A)return!0;const r=v.charCodeAt(S+u);if(N.get(r)!==0||r===13||r===10)return!0;if(u>0){const l=v.charCodeAt(S+u-1);if(N.get(l)!==0)return!0}return!1}function _(N,v,A,S,u){return h(N,v,A,S,u)&&d(N,v,A,S,u)}n.isValidMatch=_;class g{constructor(v,A){this._wordSeparators=v,this._searchRegex=A,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(v){this._searchRegex.lastIndex=v,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(v){const A=v.length;let S;do{if(this._prevMatchStartIndex+this._prevMatchLength===A||(S=this._searchRegex.exec(v),!S))return null;const u=S.index,r=S[0].length;if(u===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){E.getNextCodePoint(v,A,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=u,this._prevMatchLength=r,!this._wordSeparators||_(this._wordSeparators,v,A,u,r))return S}while(S);return null}}n.Searcher=g}),X(J[51],Z([0,1,2,50,5,9,23]),function(O,n,E,D,i,o,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeTextModelHighlighter=void 0;class w{static computeUnicodeHighlights(c,h,d){const _=d?d.startLineNumber:1,g=d?d.endLineNumber:c.getLineCount(),N=new s(h),v=N.getCandidateCodePoints();let A;v==="allNonBasicAscii"?A=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):A=new RegExp(`${a(Array.from(v))}`,"g");const S=new D.Searcher(null,A),u=[];let r=!1,l,f=0,L=0,C=0;e:for(let p=_,R=g;p<=R;p++){const y=c.getLineContent(p),M=y.length;S.reset(0);do if(l=S.next(y),l){let F=l.index,I=l.index+l[0].length;if(F>0){const z=y.charCodeAt(F-1);i.isHighSurrogate(z)&&F--}if(I+1<M){const z=y.charCodeAt(I-1);i.isHighSurrogate(z)&&I++}const P=y.substring(F,I);let U=(0,m.getWordAtText)(F+1,m.DEFAULT_WORD_REGEXP,y,0);U&&U.endColumn<=F+1&&(U=null);const W=N.shouldHighlightNonBasicASCII(P,U?U.word:null);if(W!==0){W===3?f++:W===2?L++:W===1?C++:(0,o.assertNever)(W);const z=1e3;if(u.length>=z){r=!0;break e}u.push(new E.Range(p,F+1,p,I+1))}}while(l)}return{ranges:u,hasMore:r,ambiguousCharacterCount:f,invisibleCharacterCount:L,nonBasicAsciiCharacterCount:C}}static computeUnicodeHighlightReason(c,h){const d=new s(h);switch(d.shouldHighlightNonBasicASCII(c,null)){case 0:return null;case 2:return{kind:1};case 3:{const g=c.codePointAt(0),N=d.ambiguousCharacters.getPrimaryConfusable(g),v=i.AmbiguousCharacters.getLocales().filter(A=>!i.AmbiguousCharacters.getInstance(new Set([...h.allowedLocales,A])).isAmbiguous(g));return{kind:0,confusableWith:String.fromCodePoint(N),notAmbiguousInLocales:v}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=w;function a(e,c){return`[${i.escapeRegExpCharacters(e.map(d=>String.fromCodePoint(d)).join(""))}]`}class s{constructor(c){this.options=c,this.allowedCodePoints=new Set(c.allowedCodePoints),this.ambiguousCharacters=i.AmbiguousCharacters.getInstance(new Set(c.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const c=new Set;if(this.options.invisibleCharacters)for(const h of i.InvisibleCharacters.codePoints)b(String.fromCodePoint(h))||c.add(h);if(this.options.ambiguousCharacters)for(const h of this.ambiguousCharacters.getConfusableCodePoints())c.add(h);for(const h of this.allowedCodePoints)c.delete(h);return c}shouldHighlightNonBasicASCII(c,h){const d=c.codePointAt(0);if(this.allowedCodePoints.has(d))return 0;if(this.options.nonBasicASCII)return 1;let _=!1,g=!1;if(h)for(const N of h){const v=N.codePointAt(0),A=i.isBasicASCII(N);_=_||A,!A&&!this.ambiguousCharacters.isAmbiguous(v)&&!i.InvisibleCharacters.isInvisibleCharacter(v)&&(g=!0)}return!_&&g?0:this.options.invisibleCharacters&&!b(c)&&i.InvisibleCharacters.isInvisibleCharacter(d)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(d)?3:0}}function b(e){return e===" "||e===`
`||e==="	"}}),X(J[52],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.GlyphMarginLane=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.CodeActionTriggerType=n.AccessibilitySupport=void 0;var E;(function(t){t[t.Unknown=0]="Unknown",t[t.Disabled=1]="Disabled",t[t.Enabled=2]="Enabled"})(E||(n.AccessibilitySupport=E={}));var D;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(D||(n.CodeActionTriggerType=D={}));var i;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(i||(n.CompletionItemInsertTextRule=i={}));var o;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(o||(n.CompletionItemKind=o={}));var m;(function(t){t[t.Deprecated=1]="Deprecated"})(m||(n.CompletionItemTag=m={}));var w;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w||(n.CompletionTriggerKind=w={}));var a;(function(t){t[t.EXACT=0]="EXACT",t[t.ABOVE=1]="ABOVE",t[t.BELOW=2]="BELOW"})(a||(n.ContentWidgetPositionPreference=a={}));var s;(function(t){t[t.NotSet=0]="NotSet",t[t.ContentFlush=1]="ContentFlush",t[t.RecoverFromMarkers=2]="RecoverFromMarkers",t[t.Explicit=3]="Explicit",t[t.Paste=4]="Paste",t[t.Undo=5]="Undo",t[t.Redo=6]="Redo"})(s||(n.CursorChangeReason=s={}));var b;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(b||(n.DefaultEndOfLine=b={}));var e;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(e||(n.DocumentHighlightKind=e={}));var c;(function(t){t[t.None=0]="None",t[t.Keep=1]="Keep",t[t.Brackets=2]="Brackets",t[t.Advanced=3]="Advanced",t[t.Full=4]="Full"})(c||(n.EditorAutoIndentStrategy=c={}));var h;(function(t){t[t.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",t[t.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",t[t.accessibilitySupport=2]="accessibilitySupport",t[t.accessibilityPageSize=3]="accessibilityPageSize",t[t.ariaLabel=4]="ariaLabel",t[t.autoClosingBrackets=5]="autoClosingBrackets",t[t.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",t[t.autoClosingDelete=7]="autoClosingDelete",t[t.autoClosingOvertype=8]="autoClosingOvertype",t[t.autoClosingQuotes=9]="autoClosingQuotes",t[t.autoIndent=10]="autoIndent",t[t.automaticLayout=11]="automaticLayout",t[t.autoSurround=12]="autoSurround",t[t.bracketPairColorization=13]="bracketPairColorization",t[t.guides=14]="guides",t[t.codeLens=15]="codeLens",t[t.codeLensFontFamily=16]="codeLensFontFamily",t[t.codeLensFontSize=17]="codeLensFontSize",t[t.colorDecorators=18]="colorDecorators",t[t.colorDecoratorsLimit=19]="colorDecoratorsLimit",t[t.columnSelection=20]="columnSelection",t[t.comments=21]="comments",t[t.contextmenu=22]="contextmenu",t[t.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",t[t.cursorBlinking=24]="cursorBlinking",t[t.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",t[t.cursorStyle=26]="cursorStyle",t[t.cursorSurroundingLines=27]="cursorSurroundingLines",t[t.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",t[t.cursorWidth=29]="cursorWidth",t[t.disableLayerHinting=30]="disableLayerHinting",t[t.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",t[t.domReadOnly=32]="domReadOnly",t[t.dragAndDrop=33]="dragAndDrop",t[t.dropIntoEditor=34]="dropIntoEditor",t[t.emptySelectionClipboard=35]="emptySelectionClipboard",t[t.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",t[t.extraEditorClassName=37]="extraEditorClassName",t[t.fastScrollSensitivity=38]="fastScrollSensitivity",t[t.find=39]="find",t[t.fixedOverflowWidgets=40]="fixedOverflowWidgets",t[t.folding=41]="folding",t[t.foldingStrategy=42]="foldingStrategy",t[t.foldingHighlight=43]="foldingHighlight",t[t.foldingImportsByDefault=44]="foldingImportsByDefault",t[t.foldingMaximumRegions=45]="foldingMaximumRegions",t[t.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",t[t.fontFamily=47]="fontFamily",t[t.fontInfo=48]="fontInfo",t[t.fontLigatures=49]="fontLigatures",t[t.fontSize=50]="fontSize",t[t.fontWeight=51]="fontWeight",t[t.fontVariations=52]="fontVariations",t[t.formatOnPaste=53]="formatOnPaste",t[t.formatOnType=54]="formatOnType",t[t.glyphMargin=55]="glyphMargin",t[t.gotoLocation=56]="gotoLocation",t[t.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",t[t.hover=58]="hover",t[t.inDiffEditor=59]="inDiffEditor",t[t.inlineSuggest=60]="inlineSuggest",t[t.letterSpacing=61]="letterSpacing",t[t.lightbulb=62]="lightbulb",t[t.lineDecorationsWidth=63]="lineDecorationsWidth",t[t.lineHeight=64]="lineHeight",t[t.lineNumbers=65]="lineNumbers",t[t.lineNumbersMinChars=66]="lineNumbersMinChars",t[t.linkedEditing=67]="linkedEditing",t[t.links=68]="links",t[t.matchBrackets=69]="matchBrackets",t[t.minimap=70]="minimap",t[t.mouseStyle=71]="mouseStyle",t[t.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",t[t.mouseWheelZoom=73]="mouseWheelZoom",t[t.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",t[t.multiCursorModifier=75]="multiCursorModifier",t[t.multiCursorPaste=76]="multiCursorPaste",t[t.multiCursorLimit=77]="multiCursorLimit",t[t.occurrencesHighlight=78]="occurrencesHighlight",t[t.overviewRulerBorder=79]="overviewRulerBorder",t[t.overviewRulerLanes=80]="overviewRulerLanes",t[t.padding=81]="padding",t[t.pasteAs=82]="pasteAs",t[t.parameterHints=83]="parameterHints",t[t.peekWidgetDefaultFocus=84]="peekWidgetDefaultFocus",t[t.definitionLinkOpensInPeek=85]="definitionLinkOpensInPeek",t[t.quickSuggestions=86]="quickSuggestions",t[t.quickSuggestionsDelay=87]="quickSuggestionsDelay",t[t.readOnly=88]="readOnly",t[t.readOnlyMessage=89]="readOnlyMessage",t[t.renameOnType=90]="renameOnType",t[t.renderControlCharacters=91]="renderControlCharacters",t[t.renderFinalNewline=92]="renderFinalNewline",t[t.renderLineHighlight=93]="renderLineHighlight",t[t.renderLineHighlightOnlyWhenFocus=94]="renderLineHighlightOnlyWhenFocus",t[t.renderValidationDecorations=95]="renderValidationDecorations",t[t.renderWhitespace=96]="renderWhitespace",t[t.revealHorizontalRightPadding=97]="revealHorizontalRightPadding",t[t.roundedSelection=98]="roundedSelection",t[t.rulers=99]="rulers",t[t.scrollbar=100]="scrollbar",t[t.scrollBeyondLastColumn=101]="scrollBeyondLastColumn",t[t.scrollBeyondLastLine=102]="scrollBeyondLastLine",t[t.scrollPredominantAxis=103]="scrollPredominantAxis",t[t.selectionClipboard=104]="selectionClipboard",t[t.selectionHighlight=105]="selectionHighlight",t[t.selectOnLineNumbers=106]="selectOnLineNumbers",t[t.showFoldingControls=107]="showFoldingControls",t[t.showUnused=108]="showUnused",t[t.snippetSuggestions=109]="snippetSuggestions",t[t.smartSelect=110]="smartSelect",t[t.smoothScrolling=111]="smoothScrolling",t[t.stickyScroll=112]="stickyScroll",t[t.stickyTabStops=113]="stickyTabStops",t[t.stopRenderingLineAfter=114]="stopRenderingLineAfter",t[t.suggest=115]="suggest",t[t.suggestFontSize=116]="suggestFontSize",t[t.suggestLineHeight=117]="suggestLineHeight",t[t.suggestOnTriggerCharacters=118]="suggestOnTriggerCharacters",t[t.suggestSelection=119]="suggestSelection",t[t.tabCompletion=120]="tabCompletion",t[t.tabIndex=121]="tabIndex",t[t.unicodeHighlighting=122]="unicodeHighlighting",t[t.unusualLineTerminators=123]="unusualLineTerminators",t[t.useShadowDOM=124]="useShadowDOM",t[t.useTabStops=125]="useTabStops",t[t.wordBreak=126]="wordBreak",t[t.wordSeparators=127]="wordSeparators",t[t.wordWrap=128]="wordWrap",t[t.wordWrapBreakAfterCharacters=129]="wordWrapBreakAfterCharacters",t[t.wordWrapBreakBeforeCharacters=130]="wordWrapBreakBeforeCharacters",t[t.wordWrapColumn=131]="wordWrapColumn",t[t.wordWrapOverride1=132]="wordWrapOverride1",t[t.wordWrapOverride2=133]="wordWrapOverride2",t[t.wrappingIndent=134]="wrappingIndent",t[t.wrappingStrategy=135]="wrappingStrategy",t[t.showDeprecated=136]="showDeprecated",t[t.inlayHints=137]="inlayHints",t[t.editorClassName=138]="editorClassName",t[t.pixelRatio=139]="pixelRatio",t[t.tabFocusMode=140]="tabFocusMode",t[t.layoutInfo=141]="layoutInfo",t[t.wrappingInfo=142]="wrappingInfo",t[t.defaultColorDecorators=143]="defaultColorDecorators",t[t.colorDecoratorsActivatedOn=144]="colorDecoratorsActivatedOn"})(h||(n.EditorOption=h={}));var d;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(d||(n.EndOfLinePreference=d={}));var _;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(_||(n.EndOfLineSequence=_={}));var g;(function(t){t[t.Left=1]="Left",t[t.Right=2]="Right"})(g||(n.GlyphMarginLane=g={}));var N;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(N||(n.IndentAction=N={}));var v;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(v||(n.InjectedTextCursorStops=v={}));var A;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(A||(n.InlayHintKind=A={}));var S;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(S||(n.InlineCompletionTriggerKind=S={}));var u;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.F20=78]="F20",t[t.F21=79]="F21",t[t.F22=80]="F22",t[t.F23=81]="F23",t[t.F24=82]="F24",t[t.NumLock=83]="NumLock",t[t.ScrollLock=84]="ScrollLock",t[t.Semicolon=85]="Semicolon",t[t.Equal=86]="Equal",t[t.Comma=87]="Comma",t[t.Minus=88]="Minus",t[t.Period=89]="Period",t[t.Slash=90]="Slash",t[t.Backquote=91]="Backquote",t[t.BracketLeft=92]="BracketLeft",t[t.Backslash=93]="Backslash",t[t.BracketRight=94]="BracketRight",t[t.Quote=95]="Quote",t[t.OEM_8=96]="OEM_8",t[t.IntlBackslash=97]="IntlBackslash",t[t.Numpad0=98]="Numpad0",t[t.Numpad1=99]="Numpad1",t[t.Numpad2=100]="Numpad2",t[t.Numpad3=101]="Numpad3",t[t.Numpad4=102]="Numpad4",t[t.Numpad5=103]="Numpad5",t[t.Numpad6=104]="Numpad6",t[t.Numpad7=105]="Numpad7",t[t.Numpad8=106]="Numpad8",t[t.Numpad9=107]="Numpad9",t[t.NumpadMultiply=108]="NumpadMultiply",t[t.NumpadAdd=109]="NumpadAdd",t[t.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=111]="NumpadSubtract",t[t.NumpadDecimal=112]="NumpadDecimal",t[t.NumpadDivide=113]="NumpadDivide",t[t.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",t[t.ABNT_C1=115]="ABNT_C1",t[t.ABNT_C2=116]="ABNT_C2",t[t.AudioVolumeMute=117]="AudioVolumeMute",t[t.AudioVolumeUp=118]="AudioVolumeUp",t[t.AudioVolumeDown=119]="AudioVolumeDown",t[t.BrowserSearch=120]="BrowserSearch",t[t.BrowserHome=121]="BrowserHome",t[t.BrowserBack=122]="BrowserBack",t[t.BrowserForward=123]="BrowserForward",t[t.MediaTrackNext=124]="MediaTrackNext",t[t.MediaTrackPrevious=125]="MediaTrackPrevious",t[t.MediaStop=126]="MediaStop",t[t.MediaPlayPause=127]="MediaPlayPause",t[t.LaunchMediaPlayer=128]="LaunchMediaPlayer",t[t.LaunchMail=129]="LaunchMail",t[t.LaunchApp2=130]="LaunchApp2",t[t.Clear=131]="Clear",t[t.MAX_VALUE=132]="MAX_VALUE"})(u||(n.KeyCode=u={}));var r;(function(t){t[t.Hint=1]="Hint",t[t.Info=2]="Info",t[t.Warning=4]="Warning",t[t.Error=8]="Error"})(r||(n.MarkerSeverity=r={}));var l;(function(t){t[t.Unnecessary=1]="Unnecessary",t[t.Deprecated=2]="Deprecated"})(l||(n.MarkerTag=l={}));var f;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(f||(n.MinimapPosition=f={}));var L;(function(t){t[t.UNKNOWN=0]="UNKNOWN",t[t.TEXTAREA=1]="TEXTAREA",t[t.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",t[t.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",t[t.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",t[t.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",t[t.CONTENT_TEXT=6]="CONTENT_TEXT",t[t.CONTENT_EMPTY=7]="CONTENT_EMPTY",t[t.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",t[t.CONTENT_WIDGET=9]="CONTENT_WIDGET",t[t.OVERVIEW_RULER=10]="OVERVIEW_RULER",t[t.SCROLLBAR=11]="SCROLLBAR",t[t.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",t[t.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(L||(n.MouseTargetType=L={}));var C;(function(t){t[t.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",t[t.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",t[t.TOP_CENTER=2]="TOP_CENTER"})(C||(n.OverlayWidgetPositionPreference=C={}));var p;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(p||(n.OverviewRulerLane=p={}));var R;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(R||(n.PositionAffinity=R={}));var y;(function(t){t[t.Off=0]="Off",t[t.On=1]="On",t[t.Relative=2]="Relative",t[t.Interval=3]="Interval",t[t.Custom=4]="Custom"})(y||(n.RenderLineNumbersType=y={}));var M;(function(t){t[t.None=0]="None",t[t.Text=1]="Text",t[t.Blocks=2]="Blocks"})(M||(n.RenderMinimap=M={}));var F;(function(t){t[t.Smooth=0]="Smooth",t[t.Immediate=1]="Immediate"})(F||(n.ScrollType=F={}));var I;(function(t){t[t.Auto=1]="Auto",t[t.Hidden=2]="Hidden",t[t.Visible=3]="Visible"})(I||(n.ScrollbarVisibility=I={}));var P;(function(t){t[t.LTR=0]="LTR",t[t.RTL=1]="RTL"})(P||(n.SelectionDirection=P={}));var U;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(U||(n.SignatureHelpTriggerKind=U={}));var W;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(W||(n.SymbolKind=W={}));var z;(function(t){t[t.Deprecated=1]="Deprecated"})(z||(n.SymbolTag=z={}));var T;(function(t){t[t.Hidden=0]="Hidden",t[t.Blink=1]="Blink",t[t.Smooth=2]="Smooth",t[t.Phase=3]="Phase",t[t.Expand=4]="Expand",t[t.Solid=5]="Solid"})(T||(n.TextEditorCursorBlinkingStyle=T={}));var x;(function(t){t[t.Line=1]="Line",t[t.Block=2]="Block",t[t.Underline=3]="Underline",t[t.LineThin=4]="LineThin",t[t.BlockOutline=5]="BlockOutline",t[t.UnderlineThin=6]="UnderlineThin"})(x||(n.TextEditorCursorStyle=x={}));var q;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(q||(n.TrackedRangeStickiness=q={}));var H;(function(t){t[t.None=0]="None",t[t.Same=1]="Same",t[t.Indent=2]="Indent",t[t.DeepIndent=3]="DeepIndent"})(H||(n.WrappingIndent=H={}))}),X(J[53],Z([0,1,7,10]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class i{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(w){this._onDidChange.fire({changedLanguages:w,changedColorMap:!1})}register(w,a){return this._tokenizationSupports.set(w,a),this.handleChange([w]),(0,D.toDisposable)(()=>{this._tokenizationSupports.get(w)===a&&(this._tokenizationSupports.delete(w),this.handleChange([w]))})}get(w){return this._tokenizationSupports.get(w)||null}registerFactory(w,a){var s;(s=this._factories.get(w))===null||s===void 0||s.dispose();const b=new o(this,w,a);return this._factories.set(w,b),(0,D.toDisposable)(()=>{const e=this._factories.get(w);!e||e!==b||(this._factories.delete(w),e.dispose())})}getOrCreate(w){return ge(this,void 0,void 0,function*(){const a=this.get(w);if(a)return a;const s=this._factories.get(w);return!s||s.isResolved?null:(yield s.resolve(),this.get(w))})}isResolved(w){if(this.get(w))return!0;const s=this._factories.get(w);return!!(!s||s.isResolved)}setColorMap(w){this._colorMap=w,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}n.TokenizationRegistry=i;class o extends D.Disposable{get isResolved(){return this._isResolved}constructor(w,a,s){super(),this._registry=w,this._languageId=a,this._factory=s,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}resolve(){return ge(this,void 0,void 0,function*(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise})}_create(){return ge(this,void 0,void 0,function*(){const w=yield this._factory.tokenizationSupport;this._isResolved=!0,w&&!this._isDisposed&&this._register(this._registry.register(this._languageId,w))})}}}),X(J[54],Z([25,59]),function(O,n){return O.create("vs/base/common/platform",n)}),X(J[13],Z([0,1,54]),function(O,n,E){"use strict";var D;Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.isLittleEndian=n.OS=n.setTimeout0=n.setTimeout0IsFaster=n.language=n.userAgent=n.isMobile=n.isIOS=n.isWebWorker=n.isWeb=n.isNative=n.isLinux=n.isMacintosh=n.isWindows=n.globals=n.LANGUAGE_DEFAULT=void 0,n.LANGUAGE_DEFAULT="en";let i=!1,o=!1,m=!1,w=!1,a=!1,s=!1,b=!1,e=!1,c=!1,h=!1,d,_=n.LANGUAGE_DEFAULT,g=n.LANGUAGE_DEFAULT,N,v;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let A;typeof n.globals.vscode<"u"&&typeof n.globals.vscode.process<"u"?A=n.globals.vscode.process:typeof process<"u"&&(A=process);const S=typeof((D=A?.versions)===null||D===void 0?void 0:D.electron)=="string",u=S&&A?.type==="renderer";if(typeof navigator=="object"&&!u)v=navigator.userAgent,i=v.indexOf("Windows")>=0,o=v.indexOf("Macintosh")>=0,e=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,m=v.indexOf("Linux")>=0,h=v?.indexOf("Mobi")>=0,s=!0,d=E.getConfiguredDefaultLocale(E.localize(0,null))||n.LANGUAGE_DEFAULT,_=d,g=navigator.language;else if(typeof A=="object"){i=A.platform==="win32",o=A.platform==="darwin",m=A.platform==="linux",w=m&&!!A.env.SNAP&&!!A.env.SNAP_REVISION,b=S,c=!!A.env.CI||!!A.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=n.LANGUAGE_DEFAULT,_=n.LANGUAGE_DEFAULT;const C=A.env.VSCODE_NLS_CONFIG;if(C)try{const p=JSON.parse(C),R=p.availableLanguages["*"];d=p.locale,g=p.osLocale,_=R||n.LANGUAGE_DEFAULT,N=p._translationsConfigFile}catch{}a=!0}else console.error("Unable to resolve platform.");let r=0;o?r=1:i?r=3:m&&(r=2),n.isWindows=i,n.isMacintosh=o,n.isLinux=m,n.isNative=a,n.isWeb=s,n.isWebWorker=s&&typeof n.globals.importScripts=="function",n.isIOS=e,n.isMobile=h,n.userAgent=v,n.language=_,n.setTimeout0IsFaster=typeof n.globals.postMessage=="function"&&!n.globals.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){const C=[];n.globals.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let y=0,M=C.length;y<M;y++){const F=C[y];if(F.id===R.data.vscodeScheduleAsyncWork){C.splice(y,1),F.callback();return}}});let p=0;return R=>{const y=++p;C.push({id:y,callback:R}),n.globals.postMessage({vscodeScheduleAsyncWork:y},"*")}}return C=>setTimeout(C)})(),n.OS=o||e?2:i?1:3;let l=!0,f=!1;function L(){if(!f){f=!0;const C=new Uint8Array(2);C[0]=1,C[1]=2,l=new Uint16Array(C.buffer)[0]===(2<<8)+1}return l}n.isLittleEndian=L,n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),X(J[55],Z([0,1,13]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.platform=n.env=n.cwd=void 0;let D;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const i=E.globals.vscode.process;D={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:D={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=D.cwd,n.env=D.env,n.platform=D.platform}),X(J[56],Z([0,1,55]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sep=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.normalize=n.posix=n.win32=void 0;const D=65,i=97,o=90,m=122,w=46,a=47,s=92,b=58,e=63;class c extends Error{constructor(l,f,L){let C;typeof f=="string"&&f.indexOf("not ")===0?(C="must not be",f=f.replace(/^not /,"")):C="must be";const p=l.indexOf(".")!==-1?"property":"argument";let R=`The "${l}" ${p} ${C} of type ${f}`;R+=`. Received type ${typeof L}`,super(R),this.code="ERR_INVALID_ARG_TYPE"}}function h(r,l){if(r===null||typeof r!="object")throw new c(l,"Object",r)}function d(r,l){if(typeof r!="string")throw new c(l,"string",r)}const _=E.platform==="win32";function g(r){return r===a||r===s}function N(r){return r===a}function v(r){return r>=D&&r<=o||r>=i&&r<=m}function A(r,l,f,L){let C="",p=0,R=-1,y=0,M=0;for(let F=0;F<=r.length;++F){if(F<r.length)M=r.charCodeAt(F);else{if(L(M))break;M=a}if(L(M)){if(!(R===F-1||y===1))if(y===2){if(C.length<2||p!==2||C.charCodeAt(C.length-1)!==w||C.charCodeAt(C.length-2)!==w){if(C.length>2){const I=C.lastIndexOf(f);I===-1?(C="",p=0):(C=C.slice(0,I),p=C.length-1-C.lastIndexOf(f)),R=F,y=0;continue}else if(C.length!==0){C="",p=0,R=F,y=0;continue}}l&&(C+=C.length>0?`${f}..`:"..",p=2)}else C.length>0?C+=`${f}${r.slice(R+1,F)}`:C=r.slice(R+1,F),p=F-R-1;R=F,y=0}else M===w&&y!==-1?++y:y=-1}return C}function S(r,l){h(l,"pathObject");const f=l.dir||l.root,L=l.base||`${l.name||""}${l.ext||""}`;return f?f===l.root?`${f}${L}`:`${f}${r}${L}`:L}n.win32={resolve(...r){let l="",f="",L=!1;for(let C=r.length-1;C>=-1;C--){let p;if(C>=0){if(p=r[C],d(p,"path"),p.length===0)continue}else l.length===0?p=E.cwd():(p=E.env[`=${l}`]||E.cwd(),(p===void 0||p.slice(0,2).toLowerCase()!==l.toLowerCase()&&p.charCodeAt(2)===s)&&(p=`${l}\\`));const R=p.length;let y=0,M="",F=!1;const I=p.charCodeAt(0);if(R===1)g(I)&&(y=1,F=!0);else if(g(I))if(F=!0,g(p.charCodeAt(1))){let P=2,U=P;for(;P<R&&!g(p.charCodeAt(P));)P++;if(P<R&&P!==U){const W=p.slice(U,P);for(U=P;P<R&&g(p.charCodeAt(P));)P++;if(P<R&&P!==U){for(U=P;P<R&&!g(p.charCodeAt(P));)P++;(P===R||P!==U)&&(M=`\\\\${W}\\${p.slice(U,P)}`,y=P)}}}else y=1;else v(I)&&p.charCodeAt(1)===b&&(M=p.slice(0,2),y=2,R>2&&g(p.charCodeAt(2))&&(F=!0,y=3));if(M.length>0)if(l.length>0){if(M.toLowerCase()!==l.toLowerCase())continue}else l=M;if(L){if(l.length>0)break}else if(f=`${p.slice(y)}\\${f}`,L=F,F&&l.length>0)break}return f=A(f,!L,"\\",g),L?`${l}\\${f}`:`${l}${f}`||"."},normalize(r){d(r,"path");const l=r.length;if(l===0)return".";let f=0,L,C=!1;const p=r.charCodeAt(0);if(l===1)return N(p)?"\\":r;if(g(p))if(C=!0,g(r.charCodeAt(1))){let y=2,M=y;for(;y<l&&!g(r.charCodeAt(y));)y++;if(y<l&&y!==M){const F=r.slice(M,y);for(M=y;y<l&&g(r.charCodeAt(y));)y++;if(y<l&&y!==M){for(M=y;y<l&&!g(r.charCodeAt(y));)y++;if(y===l)return`\\\\${F}\\${r.slice(M)}\\`;y!==M&&(L=`\\\\${F}\\${r.slice(M,y)}`,f=y)}}}else f=1;else v(p)&&r.charCodeAt(1)===b&&(L=r.slice(0,2),f=2,l>2&&g(r.charCodeAt(2))&&(C=!0,f=3));let R=f<l?A(r.slice(f),!C,"\\",g):"";return R.length===0&&!C&&(R="."),R.length>0&&g(r.charCodeAt(l-1))&&(R+="\\"),L===void 0?C?`\\${R}`:R:C?`${L}\\${R}`:`${L}${R}`},isAbsolute(r){d(r,"path");const l=r.length;if(l===0)return!1;const f=r.charCodeAt(0);return g(f)||l>2&&v(f)&&r.charCodeAt(1)===b&&g(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let l,f;for(let p=0;p<r.length;++p){const R=r[p];d(R,"path"),R.length>0&&(l===void 0?l=f=R:l+=`\\${R}`)}if(l===void 0)return".";let L=!0,C=0;if(typeof f=="string"&&g(f.charCodeAt(0))){++C;const p=f.length;p>1&&g(f.charCodeAt(1))&&(++C,p>2&&(g(f.charCodeAt(2))?++C:L=!1))}if(L){for(;C<l.length&&g(l.charCodeAt(C));)C++;C>=2&&(l=`\\${l.slice(C)}`)}return n.win32.normalize(l)},relative(r,l){if(d(r,"from"),d(l,"to"),r===l)return"";const f=n.win32.resolve(r),L=n.win32.resolve(l);if(f===L||(r=f.toLowerCase(),l=L.toLowerCase(),r===l))return"";let C=0;for(;C<r.length&&r.charCodeAt(C)===s;)C++;let p=r.length;for(;p-1>C&&r.charCodeAt(p-1)===s;)p--;const R=p-C;let y=0;for(;y<l.length&&l.charCodeAt(y)===s;)y++;let M=l.length;for(;M-1>y&&l.charCodeAt(M-1)===s;)M--;const F=M-y,I=R<F?R:F;let P=-1,U=0;for(;U<I;U++){const z=r.charCodeAt(C+U);if(z!==l.charCodeAt(y+U))break;z===s&&(P=U)}if(U!==I){if(P===-1)return L}else{if(F>I){if(l.charCodeAt(y+U)===s)return L.slice(y+U+1);if(U===2)return L.slice(y+U)}R>I&&(r.charCodeAt(C+U)===s?P=U:U===2&&(P=3)),P===-1&&(P=0)}let W="";for(U=C+P+1;U<=p;++U)(U===p||r.charCodeAt(U)===s)&&(W+=W.length===0?"..":"\\..");return y+=P,W.length>0?`${W}${L.slice(y,M)}`:(L.charCodeAt(y)===s&&++y,L.slice(y,M))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const l=n.win32.resolve(r);if(l.length<=2)return r;if(l.charCodeAt(0)===s){if(l.charCodeAt(1)===s){const f=l.charCodeAt(2);if(f!==e&&f!==w)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(v(l.charCodeAt(0))&&l.charCodeAt(1)===b&&l.charCodeAt(2)===s)return`\\\\?\\${l}`;return r},dirname(r){d(r,"path");const l=r.length;if(l===0)return".";let f=-1,L=0;const C=r.charCodeAt(0);if(l===1)return g(C)?r:".";if(g(C)){if(f=L=1,g(r.charCodeAt(1))){let y=2,M=y;for(;y<l&&!g(r.charCodeAt(y));)y++;if(y<l&&y!==M){for(M=y;y<l&&g(r.charCodeAt(y));)y++;if(y<l&&y!==M){for(M=y;y<l&&!g(r.charCodeAt(y));)y++;if(y===l)return r;y!==M&&(f=L=y+1)}}}}else v(C)&&r.charCodeAt(1)===b&&(f=l>2&&g(r.charCodeAt(2))?3:2,L=f);let p=-1,R=!0;for(let y=l-1;y>=L;--y)if(g(r.charCodeAt(y))){if(!R){p=y;break}}else R=!1;if(p===-1){if(f===-1)return".";p=f}return r.slice(0,p)},basename(r,l){l!==void 0&&d(l,"ext"),d(r,"path");let f=0,L=-1,C=!0,p;if(r.length>=2&&v(r.charCodeAt(0))&&r.charCodeAt(1)===b&&(f=2),l!==void 0&&l.length>0&&l.length<=r.length){if(l===r)return"";let R=l.length-1,y=-1;for(p=r.length-1;p>=f;--p){const M=r.charCodeAt(p);if(g(M)){if(!C){f=p+1;break}}else y===-1&&(C=!1,y=p+1),R>=0&&(M===l.charCodeAt(R)?--R===-1&&(L=p):(R=-1,L=y))}return f===L?L=y:L===-1&&(L=r.length),r.slice(f,L)}for(p=r.length-1;p>=f;--p)if(g(r.charCodeAt(p))){if(!C){f=p+1;break}}else L===-1&&(C=!1,L=p+1);return L===-1?"":r.slice(f,L)},extname(r){d(r,"path");let l=0,f=-1,L=0,C=-1,p=!0,R=0;r.length>=2&&r.charCodeAt(1)===b&&v(r.charCodeAt(0))&&(l=L=2);for(let y=r.length-1;y>=l;--y){const M=r.charCodeAt(y);if(g(M)){if(!p){L=y+1;break}continue}C===-1&&(p=!1,C=y+1),M===w?f===-1?f=y:R!==1&&(R=1):f!==-1&&(R=-1)}return f===-1||C===-1||R===0||R===1&&f===C-1&&f===L+1?"":r.slice(f,C)},format:S.bind(null,"\\"),parse(r){d(r,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return l;const f=r.length;let L=0,C=r.charCodeAt(0);if(f===1)return g(C)?(l.root=l.dir=r,l):(l.base=l.name=r,l);if(g(C)){if(L=1,g(r.charCodeAt(1))){let P=2,U=P;for(;P<f&&!g(r.charCodeAt(P));)P++;if(P<f&&P!==U){for(U=P;P<f&&g(r.charCodeAt(P));)P++;if(P<f&&P!==U){for(U=P;P<f&&!g(r.charCodeAt(P));)P++;P===f?L=P:P!==U&&(L=P+1)}}}}else if(v(C)&&r.charCodeAt(1)===b){if(f<=2)return l.root=l.dir=r,l;if(L=2,g(r.charCodeAt(2))){if(f===3)return l.root=l.dir=r,l;L=3}}L>0&&(l.root=r.slice(0,L));let p=-1,R=L,y=-1,M=!0,F=r.length-1,I=0;for(;F>=L;--F){if(C=r.charCodeAt(F),g(C)){if(!M){R=F+1;break}continue}y===-1&&(M=!1,y=F+1),C===w?p===-1?p=F:I!==1&&(I=1):p!==-1&&(I=-1)}return y!==-1&&(p===-1||I===0||I===1&&p===y-1&&p===R+1?l.base=l.name=r.slice(R,y):(l.name=r.slice(R,p),l.base=r.slice(R,y),l.ext=r.slice(p,y))),R>0&&R!==L?l.dir=r.slice(0,R-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(_){const r=/\\/g;return()=>{const l=E.cwd().replace(r,"/");return l.slice(l.indexOf("/"))}}return()=>E.cwd()})();n.posix={resolve(...r){let l="",f=!1;for(let L=r.length-1;L>=-1&&!f;L--){const C=L>=0?r[L]:u();d(C,"path"),C.length!==0&&(l=`${C}/${l}`,f=C.charCodeAt(0)===a)}return l=A(l,!f,"/",N),f?`/${l}`:l.length>0?l:"."},normalize(r){if(d(r,"path"),r.length===0)return".";const l=r.charCodeAt(0)===a,f=r.charCodeAt(r.length-1)===a;return r=A(r,!l,"/",N),r.length===0?l?"/":f?"./":".":(f&&(r+="/"),l?`/${r}`:r)},isAbsolute(r){return d(r,"path"),r.length>0&&r.charCodeAt(0)===a},join(...r){if(r.length===0)return".";let l;for(let f=0;f<r.length;++f){const L=r[f];d(L,"path"),L.length>0&&(l===void 0?l=L:l+=`/${L}`)}return l===void 0?".":n.posix.normalize(l)},relative(r,l){if(d(r,"from"),d(l,"to"),r===l||(r=n.posix.resolve(r),l=n.posix.resolve(l),r===l))return"";const f=1,L=r.length,C=L-f,p=1,R=l.length-p,y=C<R?C:R;let M=-1,F=0;for(;F<y;F++){const P=r.charCodeAt(f+F);if(P!==l.charCodeAt(p+F))break;P===a&&(M=F)}if(F===y)if(R>y){if(l.charCodeAt(p+F)===a)return l.slice(p+F+1);if(F===0)return l.slice(p+F)}else C>y&&(r.charCodeAt(f+F)===a?M=F:F===0&&(M=0));let I="";for(F=f+M+1;F<=L;++F)(F===L||r.charCodeAt(F)===a)&&(I+=I.length===0?"..":"/..");return`${I}${l.slice(p+M)}`},toNamespacedPath(r){return r},dirname(r){if(d(r,"path"),r.length===0)return".";const l=r.charCodeAt(0)===a;let f=-1,L=!0;for(let C=r.length-1;C>=1;--C)if(r.charCodeAt(C)===a){if(!L){f=C;break}}else L=!1;return f===-1?l?"/":".":l&&f===1?"//":r.slice(0,f)},basename(r,l){l!==void 0&&d(l,"ext"),d(r,"path");let f=0,L=-1,C=!0,p;if(l!==void 0&&l.length>0&&l.length<=r.length){if(l===r)return"";let R=l.length-1,y=-1;for(p=r.length-1;p>=0;--p){const M=r.charCodeAt(p);if(M===a){if(!C){f=p+1;break}}else y===-1&&(C=!1,y=p+1),R>=0&&(M===l.charCodeAt(R)?--R===-1&&(L=p):(R=-1,L=y))}return f===L?L=y:L===-1&&(L=r.length),r.slice(f,L)}for(p=r.length-1;p>=0;--p)if(r.charCodeAt(p)===a){if(!C){f=p+1;break}}else L===-1&&(C=!1,L=p+1);return L===-1?"":r.slice(f,L)},extname(r){d(r,"path");let l=-1,f=0,L=-1,C=!0,p=0;for(let R=r.length-1;R>=0;--R){const y=r.charCodeAt(R);if(y===a){if(!C){f=R+1;break}continue}L===-1&&(C=!1,L=R+1),y===w?l===-1?l=R:p!==1&&(p=1):l!==-1&&(p=-1)}return l===-1||L===-1||p===0||p===1&&l===L-1&&l===f+1?"":r.slice(l,L)},format:S.bind(null,"/"),parse(r){d(r,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return l;const f=r.charCodeAt(0)===a;let L;f?(l.root="/",L=1):L=0;let C=-1,p=0,R=-1,y=!0,M=r.length-1,F=0;for(;M>=L;--M){const I=r.charCodeAt(M);if(I===a){if(!y){p=M+1;break}continue}R===-1&&(y=!1,R=M+1),I===w?C===-1?C=M:F!==1&&(F=1):C!==-1&&(F=-1)}if(R!==-1){const I=p===0&&f?1:p;C===-1||F===0||F===1&&C===R-1&&C===p+1?l.base=l.name=r.slice(I,R):(l.name=r.slice(I,C),l.base=r.slice(I,R),l.ext=r.slice(C,R))}return p>0?l.dir=r.slice(0,p-1):f&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=_?n.win32.normalize:n.posix.normalize,n.resolve=_?n.win32.resolve:n.posix.resolve,n.relative=_?n.win32.relative:n.posix.relative,n.dirname=_?n.win32.dirname:n.posix.dirname,n.basename=_?n.win32.basename:n.posix.basename,n.extname=_?n.win32.extname:n.posix.extname,n.sep=_?n.win32.sep:n.posix.sep}),X(J[14],Z([0,1,56,13]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const i=/^\w[\w\d+.-]*$/,o=/^\//,m=/^\/\//;function w(f,L){if(!f.scheme&&L)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${f.authority}", path: "${f.path}", query: "${f.query}", fragment: "${f.fragment}"}`);if(f.scheme&&!i.test(f.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(f.path){if(f.authority){if(!o.test(f.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(m.test(f.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(f,L){return!f&&!L?"file":f}function s(f,L){switch(f){case"https":case"http":case"file":L?L[0]!==e&&(L=e+L):L=e;break}return L}const b="",e="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(L){return L instanceof h?!0:L?typeof L.authority=="string"&&typeof L.fragment=="string"&&typeof L.path=="string"&&typeof L.query=="string"&&typeof L.scheme=="string"&&typeof L.fsPath=="string"&&typeof L.with=="function"&&typeof L.toString=="function":!1}constructor(L,C,p,R,y,M=!1){typeof L=="object"?(this.scheme=L.scheme||b,this.authority=L.authority||b,this.path=L.path||b,this.query=L.query||b,this.fragment=L.fragment||b):(this.scheme=a(L,M),this.authority=C||b,this.path=s(this.scheme,p||b),this.query=R||b,this.fragment=y||b,w(this,M))}get fsPath(){return A(this,!1)}with(L){if(!L)return this;let{scheme:C,authority:p,path:R,query:y,fragment:M}=L;return C===void 0?C=this.scheme:C===null&&(C=b),p===void 0?p=this.authority:p===null&&(p=b),R===void 0?R=this.path:R===null&&(R=b),y===void 0?y=this.query:y===null&&(y=b),M===void 0?M=this.fragment:M===null&&(M=b),C===this.scheme&&p===this.authority&&R===this.path&&y===this.query&&M===this.fragment?this:new _(C,p,R,y,M)}static parse(L,C=!1){const p=c.exec(L);return p?new _(p[2]||b,l(p[4]||b),l(p[5]||b),l(p[7]||b),l(p[9]||b),C):new _(b,b,b,b,b)}static file(L){let C=b;if(D.isWindows&&(L=L.replace(/\\/g,e)),L[0]===e&&L[1]===e){const p=L.indexOf(e,2);p===-1?(C=L.substring(2),L=e):(C=L.substring(2,p),L=L.substring(p)||e)}return new _("file",C,L,b,b)}static from(L,C){return new _(L.scheme,L.authority,L.path,L.query,L.fragment,C)}static joinPath(L,...C){if(!L.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return D.isWindows&&L.scheme==="file"?p=h.file(E.win32.join(A(L,!0),...C)).path:p=E.posix.join(L.path,...C),L.with({path:p})}toString(L=!1){return S(this,L)}toJSON(){return this}static revive(L){var C,p;if(L){if(L instanceof h)return L;{const R=new _(L);return R._formatted=(C=L.external)!==null&&C!==void 0?C:null,R._fsPath=L._sep===d&&(p=L.fsPath)!==null&&p!==void 0?p:null,R}}else return L}}n.URI=h;const d=D.isWindows?1:void 0;class _ extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=A(this,!1)),this._fsPath}toString(L=!1){return L?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const L={$mid:1};return this._fsPath&&(L.fsPath=this._fsPath,L._sep=d),this._formatted&&(L.external=this._formatted),this.path&&(L.path=this.path),this.scheme&&(L.scheme=this.scheme),this.authority&&(L.authority=this.authority),this.query&&(L.query=this.query),this.fragment&&(L.fragment=this.fragment),L}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function N(f,L,C){let p,R=-1;for(let y=0;y<f.length;y++){const M=f.charCodeAt(y);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||L&&M===47||C&&M===91||C&&M===93||C&&M===58)R!==-1&&(p+=encodeURIComponent(f.substring(R,y)),R=-1),p!==void 0&&(p+=f.charAt(y));else{p===void 0&&(p=f.substr(0,y));const F=g[M];F!==void 0?(R!==-1&&(p+=encodeURIComponent(f.substring(R,y)),R=-1),p+=F):R===-1&&(R=y)}}return R!==-1&&(p+=encodeURIComponent(f.substring(R))),p!==void 0?p:f}function v(f){let L;for(let C=0;C<f.length;C++){const p=f.charCodeAt(C);p===35||p===63?(L===void 0&&(L=f.substr(0,C)),L+=g[p]):L!==void 0&&(L+=f[C])}return L!==void 0?L:f}function A(f,L){let C;return f.authority&&f.path.length>1&&f.scheme==="file"?C=`//${f.authority}${f.path}`:f.path.charCodeAt(0)===47&&(f.path.charCodeAt(1)>=65&&f.path.charCodeAt(1)<=90||f.path.charCodeAt(1)>=97&&f.path.charCodeAt(1)<=122)&&f.path.charCodeAt(2)===58?L?C=f.path.substr(1):C=f.path[1].toLowerCase()+f.path.substr(2):C=f.path,D.isWindows&&(C=C.replace(/\//g,"\\")),C}n.uriToFsPath=A;function S(f,L){const C=L?v:N;let p="",{scheme:R,authority:y,path:M,query:F,fragment:I}=f;if(R&&(p+=R,p+=":"),(y||R==="file")&&(p+=e,p+=e),y){let P=y.indexOf("@");if(P!==-1){const U=y.substr(0,P);y=y.substr(P+1),P=U.lastIndexOf(":"),P===-1?p+=C(U,!1,!1):(p+=C(U.substr(0,P),!1,!1),p+=":",p+=C(U.substr(P+1),!1,!0)),p+="@"}y=y.toLowerCase(),P=y.lastIndexOf(":"),P===-1?p+=C(y,!1,!0):(p+=C(y.substr(0,P),!1,!0),p+=y.substr(P))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const P=M.charCodeAt(1);P>=65&&P<=90&&(M=`/${String.fromCharCode(P+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const P=M.charCodeAt(0);P>=65&&P<=90&&(M=`${String.fromCharCode(P+32)}:${M.substr(2)}`)}p+=C(M,!0,!1)}return F&&(p+="?",p+=C(F,!1,!1)),I&&(p+="#",p+=L?I:N(I,!1,!1)),p}function u(f){try{return decodeURIComponent(f)}catch{return f.length>3?f.substr(0,3)+u(f.substr(3)):f}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(f){return f.match(r)?f.replace(r,L=>u(L)):f}}),X(J[60],Z([0,1,4,7,10,11,13,5]),function(O,n,E,D,i,o,m,w){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const a="$initialize";let s=!1;function b(l){m.isWeb&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(l.message))}n.logOnceWebWorkerWarning=b;class e{constructor(f,L,C,p){this.vsWorker=f,this.req=L,this.method=C,this.args=p,this.type=0}}class c{constructor(f,L,C,p){this.vsWorker=f,this.seq=L,this.res=C,this.err=p,this.type=1}}class h{constructor(f,L,C,p){this.vsWorker=f,this.req=L,this.eventName=C,this.arg=p,this.type=2}}class d{constructor(f,L,C){this.vsWorker=f,this.req=L,this.event=C,this.type=3}}class _{constructor(f,L){this.vsWorker=f,this.req=L,this.type=4}}class g{constructor(f){this._workerId=-1,this._handler=f,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(f){this._workerId=f}sendMessage(f,L){const C=String(++this._lastSentReq);return new Promise((p,R)=>{this._pendingReplies[C]={resolve:p,reject:R},this._send(new e(this._workerId,C,f,L))})}listen(f,L){let C=null;const p=new D.Emitter({onWillAddFirstListener:()=>{C=String(++this._lastSentReq),this._pendingEmitters.set(C,p),this._send(new h(this._workerId,C,f,L))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(C),this._send(new _(this._workerId,C)),C=null}});return p.event}handleMessage(f){!f||!f.vsWorker||this._workerId!==-1&&f.vsWorker!==this._workerId||this._handleMessage(f)}_handleMessage(f){switch(f.type){case 1:return this._handleReplyMessage(f);case 0:return this._handleRequestMessage(f);case 2:return this._handleSubscribeEventMessage(f);case 3:return this._handleEventMessage(f);case 4:return this._handleUnsubscribeEventMessage(f)}}_handleReplyMessage(f){if(!this._pendingReplies[f.seq]){console.warn("Got reply to unknown seq");return}const L=this._pendingReplies[f.seq];if(delete this._pendingReplies[f.seq],f.err){let C=f.err;f.err.$isError&&(C=new Error,C.name=f.err.name,C.message=f.err.message,C.stack=f.err.stack),L.reject(C);return}L.resolve(f.res)}_handleRequestMessage(f){const L=f.req;this._handler.handleMessage(f.method,f.args).then(p=>{this._send(new c(this._workerId,L,p,void 0))},p=>{p.detail instanceof Error&&(p.detail=(0,E.transformErrorForSerialization)(p.detail)),this._send(new c(this._workerId,L,void 0,(0,E.transformErrorForSerialization)(p)))})}_handleSubscribeEventMessage(f){const L=f.req,C=this._handler.handleEvent(f.eventName,f.arg)(p=>{this._send(new d(this._workerId,L,p))});this._pendingEvents.set(L,C)}_handleEventMessage(f){if(!this._pendingEmitters.has(f.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(f.req).fire(f.event)}_handleUnsubscribeEventMessage(f){if(!this._pendingEvents.has(f.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(f.req).dispose(),this._pendingEvents.delete(f.req)}_send(f){const L=[];if(f.type===0)for(let C=0;C<f.args.length;C++)f.args[C]instanceof ArrayBuffer&&L.push(f.args[C]);else f.type===1&&f.res instanceof ArrayBuffer&&L.push(f.res);this._handler.sendMessage(f,L)}}class N extends i.Disposable{constructor(f,L,C){super();let p=null;this._worker=this._register(f.create("vs/base/common/worker/simpleWorker",P=>{this._protocol.handleMessage(P)},P=>{p?.(P)})),this._protocol=new g({sendMessage:(P,U)=>{this._worker.postMessage(P,U)},handleMessage:(P,U)=>{if(typeof C[P]!="function")return Promise.reject(new Error("Missing method "+P+" on main thread host."));try{return Promise.resolve(C[P].apply(C,U))}catch(W){return Promise.reject(W)}},handleEvent:(P,U)=>{if(A(P)){const W=C[P].call(C,U);if(typeof W!="function")throw new Error(`Missing dynamic event ${P} on main thread host.`);return W}if(v(P)){const W=C[P];if(typeof W!="function")throw new Error(`Missing event ${P} on main thread host.`);return W}throw new Error(`Malformed event name ${P}`)}}),this._protocol.setWorkerId(this._worker.getId());let R=null;const y=globalThis.require;typeof y<"u"&&typeof y.getConfig=="function"?R=y.getConfig():typeof globalThis.requirejs<"u"&&(R=globalThis.requirejs.s.contexts._.config);const M=(0,o.getAllMethodNames)(C);this._onModuleLoaded=this._protocol.sendMessage(a,[this._worker.getId(),JSON.parse(JSON.stringify(R)),L,M]);const F=(P,U)=>this._request(P,U),I=(P,U)=>this._protocol.listen(P,U);this._lazyProxy=new Promise((P,U)=>{p=U,this._onModuleLoaded.then(W=>{P(S(W,F,I))},W=>{U(W),this._onError("Worker failed to load "+L,W)})})}getProxyObject(){return this._lazyProxy}_request(f,L){return new Promise((C,p)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(f,L).then(C,p)},p)})}_onError(f,L){console.error(f),console.info(L)}}n.SimpleWorkerClient=N;function v(l){return l[0]==="o"&&l[1]==="n"&&w.isUpperAsciiLetter(l.charCodeAt(2))}function A(l){return/^onDynamic/.test(l)&&w.isUpperAsciiLetter(l.charCodeAt(9))}function S(l,f,L){const C=y=>function(){const M=Array.prototype.slice.call(arguments,0);return f(y,M)},p=y=>function(M){return L(y,M)},R={};for(const y of l){if(A(y)){R[y]=p(y);continue}if(v(y)){R[y]=L(y,void 0);continue}R[y]=C(y)}return R}class u{constructor(f,L){this._requestHandlerFactory=L,this._requestHandler=null,this._protocol=new g({sendMessage:(C,p)=>{f(C,p)},handleMessage:(C,p)=>this._handleMessage(C,p),handleEvent:(C,p)=>this._handleEvent(C,p)})}onmessage(f){this._protocol.handleMessage(f)}_handleMessage(f,L){if(f===a)return this.initialize(L[0],L[1],L[2],L[3]);if(!this._requestHandler||typeof this._requestHandler[f]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+f));try{return Promise.resolve(this._requestHandler[f].apply(this._requestHandler,L))}catch(C){return Promise.reject(C)}}_handleEvent(f,L){if(!this._requestHandler)throw new Error("Missing requestHandler");if(A(f)){const C=this._requestHandler[f].call(this._requestHandler,L);if(typeof C!="function")throw new Error(`Missing dynamic event ${f} on request handler.`);return C}if(v(f)){const C=this._requestHandler[f];if(typeof C!="function")throw new Error(`Missing event ${f} on request handler.`);return C}throw new Error(`Malformed event name ${f}`)}initialize(f,L,C,p){this._protocol.setWorkerId(f);const M=S(p,(F,I)=>this._protocol.sendMessage(F,I),(F,I)=>this._protocol.listen(F,I));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(M),Promise.resolve((0,o.getAllMethodNames)(this._requestHandler))):(L&&(typeof L.baseUrl<"u"&&delete L.baseUrl,typeof L.paths<"u"&&typeof L.paths.vs<"u"&&delete L.paths.vs,typeof L.trustedTypesPolicy!==void 0&&delete L.trustedTypesPolicy,L.catchError=!0,globalThis.require.config(L)),new Promise((F,I)=>{(globalThis.require||O)([C],U=>{if(this._requestHandler=U.create(M),!this._requestHandler){I(new Error("No RequestHandler!"));return}F((0,o.getAllMethodNames)(this._requestHandler))},I)}))}}n.SimpleWorkerServer=u;function r(l){return new u(l,null)}n.create=r}),X(J[57],Z([0,1,34,14,2,53]),function(O,n,E,D,i,o){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=n.LazyTokenizationSupport=n.InlayHintKind=n.Command=n.FoldingRangeKind=n.SymbolKinds=n.isLocationLink=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.SelectedSuggestionInfo=n.InlineCompletionTriggerKind=n.CompletionItemKinds=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0;class m{constructor(u,r,l){this.offset=u,this.type=r,this.language=l,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=m;class w{constructor(u,r){this.tokens=u,this.endState=r,this._tokenizationResultBrand=void 0}}n.TokenizationResult=w;class a{constructor(u,r){this.tokens=u,this.endState=r,this._encodedTokenizationResultBrand=void 0}}n.EncodedTokenizationResult=a;var s;(function(S){const u=new Map;u.set(0,E.Codicon.symbolMethod),u.set(1,E.Codicon.symbolFunction),u.set(2,E.Codicon.symbolConstructor),u.set(3,E.Codicon.symbolField),u.set(4,E.Codicon.symbolVariable),u.set(5,E.Codicon.symbolClass),u.set(6,E.Codicon.symbolStruct),u.set(7,E.Codicon.symbolInterface),u.set(8,E.Codicon.symbolModule),u.set(9,E.Codicon.symbolProperty),u.set(10,E.Codicon.symbolEvent),u.set(11,E.Codicon.symbolOperator),u.set(12,E.Codicon.symbolUnit),u.set(13,E.Codicon.symbolValue),u.set(15,E.Codicon.symbolEnum),u.set(14,E.Codicon.symbolConstant),u.set(15,E.Codicon.symbolEnum),u.set(16,E.Codicon.symbolEnumMember),u.set(17,E.Codicon.symbolKeyword),u.set(27,E.Codicon.symbolSnippet),u.set(18,E.Codicon.symbolText),u.set(19,E.Codicon.symbolColor),u.set(20,E.Codicon.symbolFile),u.set(21,E.Codicon.symbolReference),u.set(22,E.Codicon.symbolCustomColor),u.set(23,E.Codicon.symbolFolder),u.set(24,E.Codicon.symbolTypeParameter),u.set(25,E.Codicon.account),u.set(26,E.Codicon.issues);function r(L){let C=u.get(L);return C||(console.info("No codicon found for CompletionItemKind "+L),C=E.Codicon.symbolProperty),C}S.toIcon=r;const l=new Map;l.set("method",0),l.set("function",1),l.set("constructor",2),l.set("field",3),l.set("variable",4),l.set("class",5),l.set("struct",6),l.set("interface",7),l.set("module",8),l.set("property",9),l.set("event",10),l.set("operator",11),l.set("unit",12),l.set("value",13),l.set("constant",14),l.set("enum",15),l.set("enum-member",16),l.set("enumMember",16),l.set("keyword",17),l.set("snippet",27),l.set("text",18),l.set("color",19),l.set("file",20),l.set("reference",21),l.set("customcolor",22),l.set("folder",23),l.set("type-parameter",24),l.set("typeParameter",24),l.set("account",25),l.set("issue",26);function f(L,C){let p=l.get(L);return typeof p>"u"&&!C&&(p=9),p}S.fromString=f})(s||(n.CompletionItemKinds=s={}));var b;(function(S){S[S.Automatic=0]="Automatic",S[S.Explicit=1]="Explicit"})(b||(n.InlineCompletionTriggerKind=b={}));class e{constructor(u,r,l,f){this.range=u,this.text=r,this.completionKind=l,this.isSnippetText=f}equals(u){return i.Range.lift(this.range).equalsRange(u.range)&&this.text===u.text&&this.completionKind===u.completionKind&&this.isSnippetText===u.isSnippetText}}n.SelectedSuggestionInfo=e;var c;(function(S){S[S.Invoke=1]="Invoke",S[S.TriggerCharacter=2]="TriggerCharacter",S[S.ContentChange=3]="ContentChange"})(c||(n.SignatureHelpTriggerKind=c={}));var h;(function(S){S[S.Text=0]="Text",S[S.Read=1]="Read",S[S.Write=2]="Write"})(h||(n.DocumentHighlightKind=h={}));function d(S){return S&&D.URI.isUri(S.uri)&&i.Range.isIRange(S.range)&&(i.Range.isIRange(S.originSelectionRange)||i.Range.isIRange(S.targetSelectionRange))}n.isLocationLink=d;var _;(function(S){const u=new Map;u.set(0,E.Codicon.symbolFile),u.set(1,E.Codicon.symbolModule),u.set(2,E.Codicon.symbolNamespace),u.set(3,E.Codicon.symbolPackage),u.set(4,E.Codicon.symbolClass),u.set(5,E.Codicon.symbolMethod),u.set(6,E.Codicon.symbolProperty),u.set(7,E.Codicon.symbolField),u.set(8,E.Codicon.symbolConstructor),u.set(9,E.Codicon.symbolEnum),u.set(10,E.Codicon.symbolInterface),u.set(11,E.Codicon.symbolFunction),u.set(12,E.Codicon.symbolVariable),u.set(13,E.Codicon.symbolConstant),u.set(14,E.Codicon.symbolString),u.set(15,E.Codicon.symbolNumber),u.set(16,E.Codicon.symbolBoolean),u.set(17,E.Codicon.symbolArray),u.set(18,E.Codicon.symbolObject),u.set(19,E.Codicon.symbolKey),u.set(20,E.Codicon.symbolNull),u.set(21,E.Codicon.symbolEnumMember),u.set(22,E.Codicon.symbolStruct),u.set(23,E.Codicon.symbolEvent),u.set(24,E.Codicon.symbolOperator),u.set(25,E.Codicon.symbolTypeParameter);function r(l){let f=u.get(l);return f||(console.info("No codicon found for SymbolKind "+l),f=E.Codicon.symbolProperty),f}S.toIcon=r})(_||(n.SymbolKinds=_={}));class g{static fromValue(u){switch(u){case"comment":return g.Comment;case"imports":return g.Imports;case"region":return g.Region}return new g(u)}constructor(u){this.value=u}}n.FoldingRangeKind=g,g.Comment=new g("comment"),g.Imports=new g("imports"),g.Region=new g("region");var N;(function(S){function u(r){return!r||typeof r!="object"?!1:typeof r.id=="string"&&typeof r.title=="string"}S.is=u})(N||(n.Command=N={}));var v;(function(S){S[S.Type=1]="Type",S[S.Parameter=2]="Parameter"})(v||(n.InlayHintKind=v={}));class A{constructor(u){this.createSupport=u,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(u=>{u&&u.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}n.LazyTokenizationSupport=A,n.TokenizationRegistry=new o.TokenizationRegistry}),X(J[58],Z([0,1,32,7,30,14,3,2,35,57,52]),function(O,n,E,D,i,o,m,w,a,s,b){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class e{static chord(d,_){return(0,i.KeyChord)(d,_)}}n.KeyMod=e,e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256;function c(){return{editor:void 0,languages:void 0,CancellationTokenSource:E.CancellationTokenSource,Emitter:D.Emitter,KeyCode:b.KeyCode,KeyMod:e,Position:m.Position,Range:w.Range,Selection:a.Selection,SelectionDirection:b.SelectionDirection,MarkerSeverity:b.MarkerSeverity,MarkerTag:b.MarkerTag,Uri:o.URI,Token:s.Token}}n.createMonacoBaseAPI=c}),X(J[61],Z([0,1,19,14,3,2,49,23,45,46,58,18,51,43,11,44]),function(O,n,E,D,i,o,m,w,a,s,b,e,c,h,d,_){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=void 0;class g extends m.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(S){const u=[];for(let r=0;r<this._lines.length;r++){const l=this._lines[r],f=this.offsetAt(new i.Position(r+1,1)),L=l.matchAll(S);for(const C of L)(C.index||C.index===0)&&(C.index=C.index+f),u.push(C)}return u}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(S){return this._lines[S-1]}getWordAtPosition(S,u){const r=(0,w.getWordAtText)(S.column,(0,w.ensureValidWordDefinition)(u),this._lines[S.lineNumber-1],0);return r?new o.Range(S.lineNumber,r.startColumn,S.lineNumber,r.endColumn):null}words(S){const u=this._lines,r=this._wordenize.bind(this);let l=0,f="",L=0,C=[];return{*[Symbol.iterator](){for(;;)if(L<C.length){const p=f.substring(C[L].start,C[L].end);L+=1,yield p}else if(l<u.length)f=u[l],C=r(f,S),L=0,l+=1;else break}}}getLineWords(S,u){const r=this._lines[S-1],l=this._wordenize(r,u),f=[];for(const L of l)f.push({word:r.substring(L.start,L.end),startColumn:L.start+1,endColumn:L.end+1});return f}_wordenize(S,u){const r=[];let l;for(u.lastIndex=0;(l=u.exec(S))&&l[0].length!==0;)r.push({start:l.index,end:l.index+l[0].length});return r}getValueInRange(S){if(S=this._validateRange(S),S.startLineNumber===S.endLineNumber)return this._lines[S.startLineNumber-1].substring(S.startColumn-1,S.endColumn-1);const u=this._eol,r=S.startLineNumber-1,l=S.endLineNumber-1,f=[];f.push(this._lines[r].substring(S.startColumn-1));for(let L=r+1;L<l;L++)f.push(this._lines[L]);return f.push(this._lines[l].substring(0,S.endColumn-1)),f.join(u)}offsetAt(S){return S=this._validatePosition(S),this._ensureLineStarts(),this._lineStarts.getPrefixSum(S.lineNumber-2)+(S.column-1)}positionAt(S){S=Math.floor(S),S=Math.max(0,S),this._ensureLineStarts();const u=this._lineStarts.getIndexOf(S),r=this._lines[u.index].length;return{lineNumber:1+u.index,column:1+Math.min(u.remainder,r)}}_validateRange(S){const u=this._validatePosition({lineNumber:S.startLineNumber,column:S.startColumn}),r=this._validatePosition({lineNumber:S.endLineNumber,column:S.endColumn});return u.lineNumber!==S.startLineNumber||u.column!==S.startColumn||r.lineNumber!==S.endLineNumber||r.column!==S.endColumn?{startLineNumber:u.lineNumber,startColumn:u.column,endLineNumber:r.lineNumber,endColumn:r.column}:S}_validatePosition(S){if(!i.Position.isIPosition(S))throw new Error("bad position");let{lineNumber:u,column:r}=S,l=!1;if(u<1)u=1,r=1,l=!0;else if(u>this._lines.length)u=this._lines.length,r=this._lines[u-1].length+1,l=!0;else{const f=this._lines[u-1].length+1;r<1?(r=1,l=!0):r>f&&(r=f,l=!0)}return l?{lineNumber:u,column:r}:S}}class N{constructor(S,u){this._host=S,this._models=Object.create(null),this._foreignModuleFactory=u,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(S){return this._models[S]}_getModels(){const S=[];return Object.keys(this._models).forEach(u=>S.push(this._models[u])),S}acceptNewModel(S){this._models[S.url]=new g(D.URI.parse(S.url),S.lines,S.EOL,S.versionId)}acceptModelChanged(S,u){if(!this._models[S])return;this._models[S].onEvents(u)}acceptRemovedModel(S){this._models[S]&&delete this._models[S]}computeUnicodeHighlights(S,u,r){return ge(this,void 0,void 0,function*(){const l=this._getModel(S);return l?c.UnicodeTextModelHighlighter.computeUnicodeHighlights(l,u,r):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}})}computeDiff(S,u,r,l){return ge(this,void 0,void 0,function*(){const f=this._getModel(S),L=this._getModel(u);return!f||!L?null:N.computeDiff(f,L,r,l)})}static computeDiff(S,u,r,l){const f=l==="advanced"?h.linesDiffComputers.getAdvanced():h.linesDiffComputers.getLegacy(),L=S.getLinesContent(),C=u.getLinesContent(),p=f.computeDiff(L,C,r),R=p.changes.length>0?!1:this._modelsAreIdentical(S,u);function y(M){return M.map(F=>{var I;return[F.originalRange.startLineNumber,F.originalRange.endLineNumberExclusive,F.modifiedRange.startLineNumber,F.modifiedRange.endLineNumberExclusive,(I=F.innerChanges)===null||I===void 0?void 0:I.map(P=>[P.originalRange.startLineNumber,P.originalRange.startColumn,P.originalRange.endLineNumber,P.originalRange.endColumn,P.modifiedRange.startLineNumber,P.modifiedRange.startColumn,P.modifiedRange.endLineNumber,P.modifiedRange.endColumn])]})}return{identical:R,quitEarly:p.hitTimeout,changes:y(p.changes),moves:p.moves.map(M=>[M.lineRangeMapping.originalRange.startLineNumber,M.lineRangeMapping.originalRange.endLineNumberExclusive,M.lineRangeMapping.modifiedRange.startLineNumber,M.lineRangeMapping.modifiedRange.endLineNumberExclusive,y(M.changes)])}}static _modelsAreIdentical(S,u){const r=S.getLineCount(),l=u.getLineCount();if(r!==l)return!1;for(let f=1;f<=r;f++){const L=S.getLineContent(f),C=u.getLineContent(f);if(L!==C)return!1}return!0}computeMoreMinimalEdits(S,u,r){return ge(this,void 0,void 0,function*(){const l=this._getModel(S);if(!l)return u;const f=[];let L;u=u.slice(0).sort((C,p)=>{if(C.range&&p.range)return o.Range.compareRangesUsingStarts(C.range,p.range);const R=C.range?0:1,y=p.range?0:1;return R-y});for(let{range:C,text:p,eol:R}of u){if(typeof R=="number"&&(L=R),o.Range.isEmpty(C)&&!p)continue;const y=l.getValueInRange(C);if(p=p.replace(/\r\n|\n|\r/g,l.eol),y===p)continue;if(Math.max(p.length,y.length)>N._diffLimit){f.push({range:C,text:p});continue}const M=(0,E.stringDiff)(y,p,r),F=l.offsetAt(o.Range.lift(C).getStartPosition());for(const I of M){const P=l.positionAt(F+I.originalStart),U=l.positionAt(F+I.originalStart+I.originalLength),W={text:p.substr(I.modifiedStart,I.modifiedLength),range:{startLineNumber:P.lineNumber,startColumn:P.column,endLineNumber:U.lineNumber,endColumn:U.column}};l.getValueInRange(W.range)!==W.text&&f.push(W)}}return typeof L=="number"&&f.push({eol:L,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),f})}computeLinks(S){return ge(this,void 0,void 0,function*(){const u=this._getModel(S);return u?(0,a.computeLinks)(u):null})}computeDefaultDocumentColors(S){return ge(this,void 0,void 0,function*(){const u=this._getModel(S);return u?(0,_.computeDefaultDocumentColors)(u):null})}textualSuggest(S,u,r,l){return ge(this,void 0,void 0,function*(){const f=new e.StopWatch,L=new RegExp(r,l),C=new Set;e:for(const p of S){const R=this._getModel(p);if(R){for(const y of R.words(L))if(!(y===u||!isNaN(Number(y)))&&(C.add(y),C.size>N._suggestionsLimit))break e}}return{words:Array.from(C),duration:f.elapsed()}})}computeWordRanges(S,u,r,l){return ge(this,void 0,void 0,function*(){const f=this._getModel(S);if(!f)return Object.create(null);const L=new RegExp(r,l),C=Object.create(null);for(let p=u.startLineNumber;p<u.endLineNumber;p++){const R=f.getLineWords(p,L);for(const y of R){if(!isNaN(Number(y.word)))continue;let M=C[y.word];M||(M=[],C[y.word]=M),M.push({startLineNumber:p,startColumn:y.startColumn,endLineNumber:p,endColumn:y.endColumn})}}return C})}navigateValueSet(S,u,r,l,f){return ge(this,void 0,void 0,function*(){const L=this._getModel(S);if(!L)return null;const C=new RegExp(l,f);u.startColumn===u.endColumn&&(u={startLineNumber:u.startLineNumber,startColumn:u.startColumn,endLineNumber:u.endLineNumber,endColumn:u.endColumn+1});const p=L.getValueInRange(u),R=L.getWordAtPosition({lineNumber:u.startLineNumber,column:u.startColumn},C);if(!R)return null;const y=L.getValueInRange(R);return s.BasicInplaceReplace.INSTANCE.navigateValueSet(u,p,R,y,r)})}loadForeignModule(S,u,r){const l=(C,p)=>this._host.fhr(C,p),L={host:(0,d.createProxyObject)(r,l),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(L,u),Promise.resolve((0,d.getAllMethodNames)(this._foreignModule))):new Promise((C,p)=>{O([S],R=>{this._foreignModule=R.create(L,u),C((0,d.getAllMethodNames)(this._foreignModule))},p)})}fmr(S,u){if(!this._foreignModule||typeof this._foreignModule[S]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+S));try{return Promise.resolve(this._foreignModule[S].apply(this._foreignModule,u))}catch(r){return Promise.reject(r)}}}n.EditorSimpleWorker=N,N._diffLimit=1e5,N._suggestionsLimit=1e4;function v(A){return new N(A,null)}n.create=v,typeof importScripts=="function"&&(globalThis.monaco=(0,b.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map